//cd C:/Users/Tobias/Google\ Drive/Maps/generation
//g++ main.cpp -o test.exe -Wall -g
/*
cd C:/Users/Tobias/Google\ Drive/Maps/generation
./test.exe anything arena
*/


#include <iostream>
#include <fstream>
#include <string>
#include <string.h>
#include <map>
#include <vector>
#include <cassert>
#include <cstdlib>
#include <math.h>
#include <time.h>

//#include "tile.h"
#include "submain.cpp"

int ATTEMPTS=0;

void BuildMap(vector<vector<Tile> > grid, vector<vector<vector<Tile> > > gametilegrid, vector<vector<vector<Tile> > > envirogrid, vector<vector<vector<Tile> > > burrowtiles, LevelSettings Area){
	
	
	vector<vector<string> > prefabs = vector<vector<string> >();
	vector<vector<vector<string> > > burrowprefabs = vector<vector<vector<string> > >();
	burrowprefabs.push_back(vector<vector<string> >());
	burrowprefabs.push_back(vector<vector<string> >());
	while (prefabs.size()<1000) prefabs.push_back(vector<string>());
	while (burrowprefabs[0].size()<1000) burrowprefabs[0].push_back(vector<string>());
	while (burrowprefabs[1].size()<1000) burrowprefabs[1].push_back(vector<string>());
	if (CELL_HEIGHT==256){
		if (theme=="g"){
			prefabs[FLOOR].push_back("g_blockprefab.vmf");
			prefabs[SECRET_FLOOR].push_back("g_blockprefab.vmf");
			prefabs[SECRET_ENTRANCE].push_back("g_blockprefab.vmf");
			prefabs[WALL].push_back("g_tallprefab.vmf");
			prefabs[SECRET_WALL].push_back("g_tallprefab.vmf");
			prefabs[WALL].push_back("g_tallprefab_2.vmf");
			prefabs[SECRET_WALL].push_back("g_tallprefab_2.vmf");
			prefabs[WALL].push_back("g_tallprefab_3.vmf");
			prefabs[SECRET_WALL].push_back("g_tallprefab_3.vmf");
			prefabs[WALL].push_back("g_tallprefab.vmf");
			prefabs[SECRET_WALL].push_back("g_tallprefab.vmf");
			prefabs[WALL].push_back("g_tallprefab_2.vmf");
			prefabs[SECRET_WALL].push_back("g_tallprefab_2.vmf");
			prefabs[WALL].push_back("g_tallprefab_3.vmf");
			prefabs[SECRET_WALL].push_back("g_tallprefab_3.vmf");
			prefabs[WALL].push_back("g_tallprefab_4.vmf");
			prefabs[SECRET_WALL].push_back("g_tallprefab_4.vmf");
			prefabs[WALL].push_back("g_tallprefab_5.vmf");
			prefabs[SECRET_WALL].push_back("g_tallprefab_5.vmf");
			prefabs[WALL].push_back("g_tallprefab_6.vmf");
			prefabs[SECRET_WALL].push_back("g_tallprefab_6.vmf");
			prefabs[WALL].push_back("g_tallprefab_5.vmf");
			prefabs[SECRET_WALL].push_back("g_tallprefab_5.vmf");
			prefabs[WALL].push_back("g_tallprefab_6.vmf");
			prefabs[SECRET_WALL].push_back("g_tallprefab_6.vmf");
			if (Area.gamemode=="arena"){
				prefabs[PATHER_ENDPOINT].push_back("spawnblock_red_a.vmf");
				prefabs[PATHER_STARTPOINT].push_back("spawnblock_blu_a.vmf");
			} else {
				prefabs[PATHER_ENDPOINT].push_back("spawnblock_red.vmf");
				prefabs[PATHER_STARTPOINT].push_back("spawnblock_blu.vmf");
			}
			if (Area.gamemode=="cp2"){
				prefabs[PATHER_ENDPOINT_SPECIAL].push_back("tcpa.vmf");
				prefabs[PATHER_STARTPOINT_SPECIAL].push_back("tcpb.vmf");
			}
			if (Area.gamemode=="ctf"||Area.gamemode=="ctfALT"){
				prefabs[PATHER_ENDPOINT_SPECIAL].push_back("ctfa.vmf");
				prefabs[PATHER_STARTPOINT_SPECIAL].push_back("ctfb.vmf");
			}
			if (Area.gamemode=="pl"){
				prefabs[PATHER_ENDPOINT_SPECIAL].push_back("plcpfinal.vmf");
				prefabs[PATHER_STARTPOINT_SPECIAL].push_back("plstart.vmf");
				prefabs[PATHER_MIDPOINT].push_back("plcp1.vmf");
				prefabs[PATHER_MIDPOINT2].push_back("plcp2.vmf");
				prefabs[PATHER_MIDPOINT3].push_back("plcp3.vmf");
			}
			prefabs[MARK_DEAD_END].push_back("g_healthandammo.vmf");
			prefabs[PROP_SINGLE].push_back("g_prop_1.vmf");
			prefabs[PROP_SINGLE_S].push_back("g_prop_1.vmf");
			prefabs[PROP_SINGLE].push_back("g_prop_2.vmf");
			prefabs[PROP_SINGLE_S].push_back("g_prop_2.vmf");
			prefabs[PROP_SINGLE].push_back("g_prop_3.vmf");
			prefabs[PROP_SINGLE_S].push_back("g_prop_3.vmf");
			prefabs[PROP_SINGLE].push_back("g_prop_4.vmf");
			prefabs[PROP_SINGLE_S].push_back("g_prop_4.vmf");
			prefabs[PROP_SINGLE].push_back("g_prop_5.vmf");
			prefabs[PROP_SINGLE_S].push_back("g_prop_5.vmf");
			prefabs[802].push_back("g_doordown.vmf");
			prefabs[803].push_back("g_doorleft.vmf");
			prefabs[804].push_back("g_doorup.vmf");
			prefabs[805].push_back("g_doorright.vmf");
			prefabs[802].push_back("g_doordown_2.vmf");
			prefabs[803].push_back("g_doorleft_2.vmf");
			prefabs[804].push_back("g_doorup_2.vmf");
			prefabs[805].push_back("g_doorright_2.vmf");
			prefabs[802].push_back("g_doordown_2.vmf");
			prefabs[803].push_back("g_doorleft_2.vmf");
			prefabs[804].push_back("g_doorup_2.vmf");
			prefabs[805].push_back("g_doorright_2.vmf");
			prefabs[500].push_back("g_hallline2.vmf");
			prefabs[501].push_back("g_hallline1.vmf");
			prefabs[500].push_back("g_hallline2_2.vmf");
			prefabs[501].push_back("g_hallline1_2.vmf");
			prefabs[500].push_back("g_hallline2_3.vmf");
			prefabs[501].push_back("g_hallline1_3.vmf");
			prefabs[500].push_back("g_hallline2_4.vmf");
			prefabs[501].push_back("g_hallline1_4.vmf");
			prefabs[500].push_back("g_hallline2_5.vmf");
			prefabs[501].push_back("g_hallline1_5.vmf");
			prefabs[500].push_back("g_hallline2_6.vmf");
			prefabs[501].push_back("g_hallline1_6.vmf");
			prefabs[500].push_back("g_hallline2_7.vmf");
			prefabs[501].push_back("g_hallline1_7.vmf");
			prefabs[500].push_back("g_hallline2_8.vmf");
			prefabs[501].push_back("g_hallline1_8.vmf");
			prefabs[500].push_back("g_hallline2_9.vmf");
			prefabs[501].push_back("g_hallline1_9.vmf");
			prefabs[502].push_back("g_hallturn1.vmf");
			prefabs[503].push_back("g_hallturn3.vmf");
			prefabs[504].push_back("g_hallturn2.vmf");
			prefabs[505].push_back("g_hallturn4.vmf");
			prefabs[506].push_back("g_hallt1.vmf");
			prefabs[507].push_back("g_hallt3.vmf");
			prefabs[508].push_back("g_hallt4.vmf");
			prefabs[509].push_back("g_hallt2.vmf");
			prefabs[510].push_back("g_hallx.vmf");
			prefabs[ORIGIN_ROOMCENTER].push_back("g_healthandammo.vmf");
			prefabs[ORIGIN_ROOMCENTER].push_back("g_proptiny_1.vmf");
			prefabs[ORIGIN_ROOMCENTER].push_back("g_proptiny_2.vmf");
			prefabs[ORIGIN_ROOMCENTER].push_back("g_proptiny_3.vmf");
			prefabs[ORIGIN_ROOMCENTER].push_back("g_proptiny_4.vmf");
			prefabs[INDOOR_ROOM].push_back("g_hallroom.vmf");
			prefabs[ENVIRO_INDOOR].push_back("g_indoor_env.vmf");
			prefabs[ENVIRO_OUTDOOR].push_back("g_outdoor_disp.vmf");
			prefabs[PROP_SMALL].push_back("g_proptiny_1.vmf");
			prefabs[PROP_SMALL].push_back("g_proptiny_2.vmf");
			prefabs[PROP_SMALL].push_back("g_proptiny_3.vmf");
			prefabs[PROP_SMALL].push_back("g_proptiny_4.vmf");
			prefabs[BURROW_ENTER].push_back("g_burrow.vmf");
			prefabs[BURROW_EXIT].push_back("g_burrow.vmf");
			//prefabs[ORIGIN_ROOMCENTER].push_back("pillarprop.vmf");
			
			
			
			burrowprefabs[0][FLOOR].push_back("pipe_blockprefab.vmf");
			burrowprefabs[0][SECRET_FLOOR].push_back("turbine_hallx.vmf");
			burrowprefabs[0][SECRET_ENTRANCE].push_back("turbine_hallx.vmf");
			burrowprefabs[0][WALL].push_back("pipe_tallprefab.vmf");
			burrowprefabs[0][SECRET_WALL].push_back("turbine_tallprefab.vmf");
			burrowprefabs[0][WALL].push_back("pipe_tallprefab_2.vmf");
			//burrowprefabs[0][SECRET_WALL].push_back("pipe_tallprefab_2.vmf");
			burrowprefabs[0][WALL].push_back("pipe_tallprefab_3.vmf");
			//burrowprefabs[0][SECRET_WALL].push_back("pipe_tallprefab_3.vmf");
			burrowprefabs[0][WALL].push_back("pipe_tallprefab_4.vmf");
			//burrowprefabs[0][SECRET_WALL].push_back("pipe_tallprefab_4.vmf");
			burrowprefabs[0][WALL].push_back("pipe_tallprefab_3.vmf");
			//burrowprefabs[0][SECRET_WALL].push_back("pipe_tallprefab_3.vmf");
			burrowprefabs[0][WALL].push_back("pipe_tallprefab_4.vmf");
			//burrowprefabs[0][SECRET_WALL].push_back("pipe_tallprefab_4.vmf");
			burrowprefabs[0][PATHER_ENDPOINT].push_back("pipe_blockprefab.vmf");
			burrowprefabs[0][PATHER_STARTPOINT].push_back("pipe_blockprefab.vmf");
			burrowprefabs[0][MARK_DEAD_END].push_back("pipe_tallprefab.vmf");
			burrowprefabs[0][PROP_SINGLE].push_back("pipe_blockprefab.vmf");
			burrowprefabs[0][PROP_SINGLE_S].push_back("pipe_blockprefab.vmf");
			burrowprefabs[0][802].push_back("pipe_doordown.vmf");
			burrowprefabs[0][803].push_back("pipe_doorleft.vmf");
			burrowprefabs[0][804].push_back("pipe_doorup.vmf");
			burrowprefabs[0][805].push_back("pipe_doorright.vmf");
			burrowprefabs[0][802].push_back("pipe_doordown_2.vmf");
			burrowprefabs[0][803].push_back("pipe_doorleft_2.vmf");
			burrowprefabs[0][804].push_back("pipe_doorup_2.vmf");
			burrowprefabs[0][805].push_back("pipe_doorright_2.vmf");
			burrowprefabs[0][802].push_back("pipe_doordown_2.vmf");
			burrowprefabs[0][803].push_back("pipe_doorleft_2.vmf");
			burrowprefabs[0][804].push_back("pipe_doorup_2.vmf");
			burrowprefabs[0][805].push_back("pipe_doorright_2.vmf");
			burrowprefabs[0][500].push_back("pipe_hallline2.vmf");
			burrowprefabs[0][501].push_back("pipe_hallline1.vmf");
			burrowprefabs[0][502].push_back("pipe_hallturn1.vmf");
			burrowprefabs[0][503].push_back("pipe_hallturn3.vmf");
			burrowprefabs[0][504].push_back("pipe_hallturn2.vmf");
			burrowprefabs[0][505].push_back("pipe_hallturn4.vmf");
			burrowprefabs[0][506].push_back("pipe_hallt1.vmf");
			burrowprefabs[0][507].push_back("pipe_hallt3.vmf");
			burrowprefabs[0][508].push_back("pipe_hallt4.vmf");
			burrowprefabs[0][509].push_back("pipe_hallt2.vmf");
			burrowprefabs[0][510].push_back("pipe_hallx.vmf");
			burrowprefabs[0][510].push_back("pipe_hallx_2.vmf");
			burrowprefabs[0][510].push_back("pipe_hallx_3.vmf");
			burrowprefabs[0][ORIGIN_ROOMCENTER].push_back("pipe_blockprefab.vmf");
			burrowprefabs[0][ORIGIN_ROOMCENTER].push_back("pipe_blockprefab.vmf");
			burrowprefabs[0][INDOOR_ROOM].push_back("pipe_blockprefab.vmf");
			burrowprefabs[0][BURROW_ENTER].push_back("pipe_exit.vmf");
			burrowprefabs[0][BURROW_EXIT].push_back("pipe_exit.vmf");
			burrowprefabs[0][BURROW_ENTER].push_back("pipe_exit_2.vmf");
			burrowprefabs[0][BURROW_EXIT].push_back("pipe_exit_2.vmf");
			burrowprefabs[0][BURROW_ENTER].push_back("pipe_exit.vmf");
			burrowprefabs[0][BURROW_EXIT].push_back("pipe_exit.vmf");
			burrowprefabs[0][BURROW_ENTER].push_back("pipe_exit_2.vmf");
			burrowprefabs[0][BURROW_EXIT].push_back("pipe_exit_2.vmf");
			burrowprefabs[0][BURROW_ENTER].push_back("pipe_exit_3.vmf");
			burrowprefabs[0][BURROW_EXIT].push_back("pipe_exit_3.vmf");
			
			
			
			
		} else {
			prefabs[FLOOR].push_back("blockprefab.vmf");
			prefabs[SECRET_FLOOR].push_back("blockprefab.vmf");
			prefabs[SECRET_ENTRANCE].push_back("blockprefab.vmf");
			prefabs[WALL].push_back("tallprefab.vmf");
			prefabs[SECRET_WALL].push_back("tallprefab.vmf");
			if (Area.gamemode=="arena"){
				prefabs[PATHER_ENDPOINT].push_back("spawnblock_red_a.vmf");
				prefabs[PATHER_STARTPOINT].push_back("spawnblock_blu_a.vmf");
			} else {
				prefabs[PATHER_ENDPOINT].push_back("spawnblock_red.vmf");
				prefabs[PATHER_STARTPOINT].push_back("spawnblock_blu.vmf");
			}
			if (Area.gamemode=="cp2"){
				prefabs[PATHER_ENDPOINT_SPECIAL].push_back("tcpa.vmf");
				prefabs[PATHER_STARTPOINT_SPECIAL].push_back("tcpb.vmf");
			}
			if (Area.gamemode=="ctf"||Area.gamemode=="ctfALT"){
				prefabs[PATHER_ENDPOINT_SPECIAL].push_back("ctfa.vmf");
				prefabs[PATHER_STARTPOINT_SPECIAL].push_back("ctfb.vmf");
			}
			if (Area.gamemode=="pl"){
				prefabs[PATHER_ENDPOINT_SPECIAL].push_back("plcpfinal.vmf");
				prefabs[PATHER_STARTPOINT_SPECIAL].push_back("plstart.vmf");
				prefabs[PATHER_MIDPOINT].push_back("plcp1.vmf");
				prefabs[PATHER_MIDPOINT2].push_back("plcp2.vmf");
				prefabs[PATHER_MIDPOINT3].push_back("plcp3.vmf");
			}
			prefabs[MARK_DEAD_END].push_back("healthandammo.vmf");
			prefabs[PROP_SINGLE].push_back("pillarprop.vmf");
			prefabs[PROP_SINGLE_S].push_back("pillarprop.vmf");
			prefabs[802].push_back("doordown.vmf");
			prefabs[803].push_back("doorleft.vmf");
			prefabs[804].push_back("doorup.vmf");
			prefabs[805].push_back("doorright.vmf");
			prefabs[500].push_back("hallline2.vmf");
			prefabs[501].push_back("hallline1.vmf");
			prefabs[502].push_back("hallturn1.vmf");
			prefabs[503].push_back("hallturn3.vmf");
			prefabs[504].push_back("hallturn2.vmf");
			prefabs[505].push_back("hallturn4.vmf");
			prefabs[506].push_back("hallt3.vmf");
			prefabs[507].push_back("hallt1.vmf");
			prefabs[508].push_back("hallt4.vmf");
			prefabs[509].push_back("hallt2.vmf");
			prefabs[510].push_back("hallx.vmf");
			prefabs[ORIGIN_ROOMCENTER].push_back("healthandammo.vmf");
			prefabs[INDOOR_ROOM].push_back("hallroom.vmf");
			prefabs[ENVIRO_INDOOR].push_back("indoor_env.vmf");
			prefabs[PROP_SMALL].push_back("g_proptiny_3.vmf");
			//prefabs[ORIGIN_ROOMCENTER].push_back("pillarprop.vmf");
		}
	}
	string mapfile = "randommap";
	cin >> mapfile;
	mapfile += ".vmf";
	int id = 10;
	ofstream output(mapfile.c_str());
	ofstream entput("entholder.txt");
	ifstream inp1("base1.txt");
	ifstream inp2("base2.txt");
	string pin;
	while (getline(inp1,pin)){
		output << pin << endl;
	}
	cout << "building terrain" << endl;
	for (int y = 0; y < height; y++){
		for (int x = 0; x < width; x++){
			if (prefabs[grid[x][y].GetTileID()].size()>0){
				grid[x][y].PrintOut(output, entput, prefabs[grid[x][y].GetTileID()][irandom(prefabs[grid[x][y].GetTileID()].size()-1)], id);
			}
			/*
			Tile t = grid[x][y];
			if (t.GetTileID()==FLOOR||t.GetTileID()==SECRET_FLOOR||t.GetTileID()==SECRET_ENTRANCE) t.PrintOut(output, entput, "blockprefab.vmf", id);
			else if (t.GetTileID()==WALL||t.GetTileID()==SECRET_WALL) t.PrintOut(output, entput, "tallprefab.vmf", id);
			else if (t.GetTileID()==PATHER_ENDPOINT) t.PrintOut(output, entput, "spawnblock_red.vmf", id);
			else if (t.GetTileID()==PATHER_STARTPOINT) t.PrintOut(output, entput, "spawnblock_blu.vmf", id);
			else if (t.GetTileID()==MARK_DEAD_END) t.PrintOut(output, entput, "healthandammo.vmf", id);
			*/
		}
	}
	cout << "building gamemode logic" << endl;
	for (int y = 0; y < height; y++){
		for (int x = 0; x < width; x++){
			for (int i = 0; i < gametilegrid[x][y].size(); i++){
				if (Area.gamemode == "pl"){
					if (gametilegrid[x][y][i].GetTileID()>=300) {
						gametilegrid[x][y][i].PrintEnt(output, entput, "plnode.vmf", id);
					}
				}
			}
		}
	}
	cout << "building environment" << endl;
	for (int y = 0; y < height; y++){
		for (int x = 0; x < width; x++){
			for (int i = 0; i < envirogrid[x][y].size(); i++){
				if (prefabs[envirogrid[x][y][i].GetTileID()].size()>0){
					envirogrid[x][y][i].PrintOut(output, entput, prefabs[envirogrid[x][y][i].GetTileID()][irandom(prefabs[envirogrid[x][y][i].GetTileID()].size()-1)], id);
				}
			}
		}
	}
	cout << "building burrows and overhangs" << endl;
	for (int y = 0; y < height; y++){
		for (int x = 0; x < width; x++){
			for (int i = 0; i < 2; i++){
				//cout << x << "," << y << " " << burrowtiles[i][x][y].GetTileID() << endl;
				if (burrowtiles[i][x][y].GetTileID()>=0&&burrowprefabs[i][burrowtiles[i][x][y].GetTileID()].size()>0){
					burrowtiles[i][x][y].PrintOut(output, entput, burrowprefabs[i][burrowtiles[i][x][y].GetTileID()][irandom(burrowprefabs[i][burrowtiles[i][x][y].GetTileID()].size()-1)], id);
				} else if (burrowtiles[i][x][y].GetTileID()<0&&burrowprefabs[i][FLOOR].size()>0){
					burrowtiles[i][x][y].PrintOut(output, entput, burrowprefabs[i][FLOOR][irandom(burrowprefabs[i][FLOOR].size()-1)], id);
				}
			}
		}
	}
	entput.close();
	while (getline(inp2,pin)){
		output << pin << endl;
	}
	ifstream inp3("entholder.txt");
	while (getline(inp3,pin)){
		output << pin << endl;
	}
	if (Area.gamemode == "arena"){
		ifstream inp4("logic_arena.vmf");
		while (getline(inp4,pin)){
			output << pin << endl;
		}
	}
}
int main(int argc, char* argv[]){
	// create level
	cout<< "loading settings..." << endl;
	LevelSettings Area;
	
	if (argc < 2)
	Area = LevelSettings();
	else
	Area = LevelSettings(argv[1]);
	if (argc > 2) Area.gamemode = argv[2];
	
	/*
	Area = LevelSettings();
	if (argc > 1) {
		for (int i=1; i<argc; i+=2){
			if (argv[i]=="gamemode")
				Area.gamemode = argv[i+1];
			if (argv[i]=="preset")
				Area = LevelSettings(argv[i+1]);
			if (argv[i]=="pather_loop")
				Area.pather_loop = argv[i+1]*250;
			if (argv[i]=="odds")
				Area.odds = int(1.0/argv[i+1]);
			if (argv[i]=="pathers")
				Area.num_pathers = argv[i+1]*argv[i+1];
			if (argv[i]=="room_start")
				Area.room_start_odds = int(1.0/argv[i+1]);
			if (argv[i]=="room_end")
				Area.room_end_odds = int(1.0/argv[i+1]);
			if (argv[i]=="room_chance")
				Area.room_turn_odds = int(1.0/argv[i+1]);
			if (argv[i]=="room_x_max")
				Area.room_x_max = argv[i+1];
			if (argv[i]=="room_y_max")
				Area.room_y_max = argv[i+1];
			
		}
		Area.ScaleHyperly();
	}
	*/
	
	ATTEMPTS++;
	// we need this for later
	int totalsecrets=0;

	int numhiddentiles=0;
	vector<Tile> hiddentiles= vector<Tile>();
	int numdisguisedtiles=0;
	vector<Tile> disguisedtiles= vector<Tile>();

	// the odds variable for changing direction
	int odds = Area.odds;

	// the number of pathers to use
	int pathers = Area.num_pathers;
	int xy_pathers = sqrt(pathers);
	/*
	//resize room
	int room_width = (CELL_WIDTH/16)*720;
	int room_height = (CELL_HEIGHT/16)*720;

	// set grid dimensions
	int width = room_width / CELL_WIDTH;
	int height = room_height / CELL_HEIGHT;
	*/
	cout << width << " " << height << endl;
	// set jump vars
	int maxjumps=Area.pather_jump;
	bool jumpy=Area.use_jump;
	
	cout<< "making grids..." << endl;
	
	// create grid
	vector<vector<int> > grid = vector<vector<int> >();
	vector<vector<int> > quadgrid = vector<vector<int> >();
	vector<vector<int> > absgrid = vector<vector<int> >();
	vector<vector<int> > congrid = vector<vector<int> >();
	vector<vector<int> > overgrid = vector<vector<int> >();
	vector<vector<int> > markgrid = vector<vector<int> >();
	vector<vector<vector<int> > > gamegrid = vector<vector<vector<int> > >();
	vector<int> issecret = vector<int>();
	vector<vector<Tile> > tilegrid = vector<vector<Tile> >();
	vector<vector<vector<Tile> > > gametilegrid = vector<vector<vector<Tile> > >();
	vector<vector<Tile> > tilequadgrid = vector<vector<Tile> >();
	vector<vector<vector<int> > > pathergrid = vector<vector<vector<int> > >();
	vector<vector<int> > inoutgrid = vector<vector<int> >();
	vector<vector<int> > displacegrid = vector<vector<int> >();
	vector<vector<int> > burrowgrid = vector<vector<int> >();
	vector<vector<vector<Tile> > > envirogrid = vector<vector<vector<Tile> > >();
	vector<vector<vector<Tile> > > burrowtilegrid = vector<vector<vector<Tile> > >();
	
	cout<< "filling grids..." << endl;
	// fill grid with void
	ds_grid_set_region(grid, 0, 0, width, height, VOID);
	ds_grid_set_region(absgrid, 0, 0, width, height, VOID);
	ds_grid_set_region(quadgrid, 0, 0, width, height, VOID);
	ds_grid_set_region(congrid, 0, 0, width, height, 0);
	ds_grid_set_region(overgrid, 0, 0, width, height, VOID);
	ds_grid_set_region(markgrid, 0, 0, width, height, VOID);
	cout<<"filling tile grids..."<<endl;
	ds_grid_set_region(tilegrid, 0, 0, width, height, noone);
	ds_grid_set_region(tilequadgrid, 0, 0, width, height, noone);
	ds_grid_set_region(inoutgrid, 0, 0, width, height, -1);
	ds_grid_set_region(displacegrid, 0, 0, width, height, -1);
	ds_grid_set_region(burrowgrid, 0, 0, width, height, VOID);
	for (int i=0; i<2; i++){
		burrowtilegrid.push_back(vector<vector<Tile> >());
		ds_grid_set_region(burrowtilegrid[i], 0, 0, width, height, noone);
	}
	for (int i=0; i <= pathers; i++){
		issecret.push_back(0);
	}
	while (pathergrid.size() <= width) pathergrid.push_back(vector<vector<int> >());
	for (int x=0; x<=width; x++){
		while (pathergrid[x].size() <= height) pathergrid[x].push_back(vector<int>());
		for (int y=0; y<=height; y++){
			while (pathergrid[x][y].size() <= 4) pathergrid[x][y].push_back(0);
		}
	}
	while (gamegrid.size() <= width) gamegrid.push_back(vector<vector<int> >());
	for (int x=0; x<=width; x++){
		while (gamegrid[x].size() <= height) gamegrid[x].push_back(vector<int>());
		for (int y=0; y<=height; y++){
			//while (gamegrid[x][y].size() <= 4) gamegrid[x][y].push_back(vector<int>());
		}
	}
	while (gametilegrid.size() <= width) gametilegrid.push_back(vector<vector<Tile> >());
	for (int x=0; x<=width; x++){
		while (gametilegrid[x].size() <= height) gametilegrid[x].push_back(vector<Tile>());
		for (int y=0; y<=height; y++){
			//while (gametilegrid[x][y].size() <= 4) gametilegrid[x][y].push_back(vector<Tile>());
		}
	}
	while (envirogrid.size() <= width) envirogrid.push_back(vector<vector<Tile> >());
	for (int x=0; x<=width; x++){
		while (envirogrid[x].size() <= height) envirogrid[x].push_back(vector<Tile>());
		for (int y=0; y<=height; y++){
			//while (envirogrid[x][y].size() <= 4) envirogrid[x][y].push_back(vector<Tile>());
		}
	}
	
	

	// randomize the world
	randomize();
	cout<< "setting up controller..." << endl;
	// create the controller in center of grid
	int cx = width / (xy_pathers*2);
	int cy = height / (xy_pathers*2);
	/*
	//create the player
	instance_create(cx*CELL_WIDTH+CELL_WIDTH/2, cy*CELL_HEIGHT+CELL_HEIGHT/2, obj_player1);
	*/
	// give the controller a random direction
int cdir = irandom(3);
	// create the level using controllers ("pathers")
	int pp;
	int gmx1;
	int gmy1;
	int gmv1;
	int gmx2;
	int gmy2;
	int gmv2;
	int gmx3;
	int gmy3;
	int gmv3;
	int gmx4;
	int gmy4;
	int gmv4;
	int gmp=0;
	bool gms1=false;
	bool gms2=false;
	bool gms3=false;
	if (Area.gamemode=="2cp"||Area.gamemode=="ctf"){
		pathers = 3;
		Area.pather_loop = 300*HYPERSCALE;
	} else if (Area.gamemode=="pl"){
		pathers++;
	}
	for (int p=0; p<pathers; p++){
		pp=p;
		cout<< "starting pather " << p << "..." << endl;
		if (Area.gamemode=="pl"){
			if (p==0){
				cx = width/2;
				cy = height/2;
			}
			else{
				cx = width / (xy_pathers*2);
				cy = height / (xy_pathers*2);
				int gx = (p-1) % xy_pathers;
				int gy = (int)((p-1)/xy_pathers);
				cx *= gx*2+1;
				cy *= gy*2+1;
			}
		}
		else{
			float fx = (float)width / (float)(xy_pathers*2);
			float fy = (float)height / (float)(xy_pathers*2);
			int gx = p % xy_pathers;
			int gy = (int)(p/xy_pathers);
			cx = (int)(fx * (float)(gx*2+1));
			cy = (int)(fy * (float)(gy*2+1));
			cout << "start position is " << cx << "," << cy << endl;
		}
		int jumps=0;
		if (p==1 && (Area.gamemode=="2cp"||Area.gamemode=="ctf")){
			cx = gmx1;
			cy = gmy1;
		}
		if (p==2 && (Area.gamemode=="2cp"||Area.gamemode=="ctf")){
			cx = gmx2;
			cy = gmy2;
		}
		if (irandom(Area.room_start_odds)==Area.room_start_odds){
			int rx=irandom(Area.room_x_max-1)+1;
			int ry=irandom(Area.room_y_max-1)+1;
			overgrid[cx][cy] == ORIGIN_ROOMCENTER;
			for (int xx=cx-rx; xx<cx+rx+1; xx++){
				for (int yy=cy-ry; yy<cy+ry; yy++){
					if (xx > -1 && yy > -1 && xx < width && yy < height){
						grid[xx][yy]=FLOOR;
						if (quadgrid[xx][yy] == VOID) quadgrid[xx][yy] = pp;
						if (overgrid[xx][yy] != ORIGIN_ROOMCENTER) overgrid[xx][yy]=ORIGIN_ROOMGEN;
					}
				}
			}
		}
		if (groupspawns==1){
			if (cy > height/2) {
				if (markgrid[cx][cy] < PATHER_ENDPOINT) markgrid[cx][cy]=PATHER_STARTPOINT;
			} else {
				if (markgrid[cx][cy] < PATHER_ENDPOINT) markgrid[cx][cy]=PATHER_ENDPOINT;
			}
		} else if (groupspawns==2){
			if (cx > width/2) {
				if (markgrid[cx][cy] < PATHER_ENDPOINT) markgrid[cx][cy]=PATHER_STARTPOINT;
			} else {
				if (markgrid[cx][cy] < PATHER_ENDPOINT) markgrid[cx][cy]=PATHER_ENDPOINT;
			}
		}
		else if (markgrid[cx][cy] < PATHER_ENDPOINT) markgrid[cx][cy]=PATHER_STARTPOINT;
		cout << markgrid[cx][cy] << " " << cx << " " << cy << endl;
		if (p==0 && (Area.gamemode=="2cp"||Area.gamemode=="ctf")){
			markgrid[cx][cy] += 2;
			cout << markgrid[cx][cy] << endl;
			gmx1 = cx;
			gmy1 = cy;
			if (cy > height/2) 
				gms1 = true;
			else
				gms2 = true;
		} else if (p==0 && Area.gamemode=="pl"){
			markgrid[cx][cy]=PATHER_STARTPOINT_SPECIAL;
		}
		//cout << cx << " " << cy << endl;
		cout<< "beginning pather loop..." << endl;
		for (int repeating = 0; repeating < Area.pather_loop; repeating ++){
			//cout << repeating << endl;
			//place a floor tile at the controller position
			if (Area.gamemode=="pl"&&p==0){
				gmp++;
				
				if (!gms1 && repeating >= Area.pather_loop/4){
					gms1=true;
					gmx1=cx;
					gmy1=cy;
					gmv1=gmp;
				} else if (!gms2 && repeating >= Area.pather_loop/2){
					gms2=true;
					gmx2=cx;
					gmy2=cy;
					gmv2=gmp;
				} else if (!gms3 && repeating >= (Area.pather_loop*3)/4){
					gms3=true;
					gmx3=cx;
					gmy3=cy;
					gmv3=gmp;
				} else {
					gamegrid[cx][cy].push_back(gmp);
				}
			}
			if (!jumpy || grid[cx][cy]!=PLACEHOLDER) grid[cx][cy] = FLOOR;    //ds_grid_set(grid, cx, cy, FLOOR);
			if (jumpy && grid[cx][cy]==PLACEHOLDER){
				grid[cx][cy] = DROPTILE;
			}
			
			if (irandom(Area.room_turn_odds)==Area.room_turn_odds){
				//cout << "rr ";
				int rx=irandom(Area.room_x_max-1)+1;
				int ry=irandom(Area.room_y_max-1)+1;
				overgrid[cx][cy] == ORIGIN_ROOMCENTER;
				if (cx-rx-1 > -1 && cy-ry-1 > -1 && cx+rx+1 < width && cy+ry+1 < height){
					if (Area.allow_room_overlap || (
						overgrid[cx-rx][cy-ry]!=ORIGIN_ROOMGEN && overgrid[cx+rx][cy-ry]!=ORIGIN_ROOMGEN && overgrid[cx-rx][cy+ry]!=ORIGIN_ROOMGEN && overgrid[cx+rx][cy+ry]!=ORIGIN_ROOMGEN
						&& overgrid[cx-rx-1][cy-ry-1]!=ORIGIN_ROOMGEN && overgrid[cx+rx+1][cy-ry-1]!=ORIGIN_ROOMGEN && overgrid[cx-rx-1][cy+ry+1]!=ORIGIN_ROOMGEN && overgrid[cx+rx+1][cy+ry+1]!=ORIGIN_ROOMGEN
						&& overgrid[cx-rx-1][cy]!=ORIGIN_ROOMGEN && overgrid[cx+rx+1][cy]!=ORIGIN_ROOMGEN && overgrid[cx][cy+ry+1]!=ORIGIN_ROOMGEN && overgrid[cx][cy+ry-1]!=ORIGIN_ROOMGEN)){
							for (int xx=cx-rx; xx<cx+rx+1; xx++){
								for (int yy=cy-ry; yy<cy+ry; yy++){
									if (xx > -1 && yy > -1 && xx < width && yy < height){
										grid[xx][yy]=FLOOR;
										if (quadgrid[xx][yy] == VOID) quadgrid[xx][yy] = p;
										if (overgrid[xx][yy] != ORIGIN_ROOMCENTER) overgrid[xx][yy]=ORIGIN_ROOMGEN;
									}
								}
							}
						
					}
				}
			}
			if (quadgrid[cx][cy] == VOID) quadgrid[cx][cy] = p;
			/*
			else if (quadgrid[cx][cy]>=0&&quadgrid[cx][cy]<connectsto.size()) {
				connectsto[p][quadgrid[cx][cy]] = true;
				connectsto[quadgrid[cx][cy]][p] = true;
			}
			*/
			//cout << "1" << endl;
			
			//randomize direction
			if (irandom(odds) == odds ){//|| jumps==maxjumps
				//cout << "od ";
				cdir = irandom(3);/*
				if (cdir==1 && jumps==maxjumps){
					while (cdir==1){
						cdir = irandom(3);
					}
				}*/
			}
			//cout << "2" << endl;
			if (jumpy && cdir==1){
				jumps ++;
			} else if (jumpy && grid[cx][cy+1]==VOID){
				jumps=0;
				grid[cx][cy+1]=PLACEHOLDER;
			}
			//cout << "3" << endl;
			//move controller
			int xdir = cos ((cdir*90)*M_PI/180);//lengthdir_x(1, cdir*90)
			int ydir = sin ((cdir*90)*M_PI/180);//lengthdir_y(1, cdir*90)
			/*
			if (p==1 && Area.gamemode=="2cp"){
				if (cy+ydir > height/2) ydir = ydir * -1;
			}
			if (p==2 && Area.gamemode=="2cp"){
				if (cy+ydir < height/2) ydir = ydir * -1;
			}
			*/
			pathergrid[cx][cy][cdir]=2;
			cx += xdir;
			cy += ydir;
			pathergrid[cx][cy][(cdir+2)%4]=2;
			//cout << "4" << endl;
			//make sure controller doesn't move outside the grid
			if (cx < 1) cx = 1;
			else if (cx > width-2) cx = width - 2;
			if (cy < 1) cy = 1;
			else if (cy > height-2) cy = height - 2;
			//cx = clamp(cx, 1, width-2);
			//cy = clamp(cy, 1, height-2);
		}
		cout << "finished pather loop..."<<endl;
		if (irandom(Area.room_end_odds)==Area.room_end_odds){
			int rx=irandom(Area.room_x_max-1)+1;
			int ry=irandom(Area.room_y_max-1)+1;
			overgrid[cx][cy] = ORIGIN_ROOMCENTER;
			for (int xx=cx-rx; xx<cx+rx+1; xx++){
				for (int yy=cy-ry; yy<cy+ry; yy++){
					if (xx > -1 && yy > -1 && xx < width && yy < height){
						grid[xx][yy]=FLOOR;
						if (quadgrid[xx][yy] == VOID) quadgrid[xx][yy] = pp;
						if (overgrid[xx][yy] != ORIGIN_ROOMCENTER) overgrid[xx][yy]=ORIGIN_ROOMGEN;
					}
				}
			}
		}
		if (groupspawns==1){
			if (cy > height/2) {
				if (markgrid[cx][cy] < PATHER_ENDPOINT) markgrid[cx][cy]=PATHER_STARTPOINT;
			} else {
				if (markgrid[cx][cy] < PATHER_ENDPOINT) markgrid[cx][cy]=PATHER_ENDPOINT;
			}
		} else if (groupspawns==2){
			if (cx > width/2)  {
				if (markgrid[cx][cy] < PATHER_ENDPOINT) markgrid[cx][cy]=PATHER_STARTPOINT;
			} else {
				if (markgrid[cx][cy] < PATHER_ENDPOINT) markgrid[cx][cy]=PATHER_ENDPOINT;
			}
		}
		else markgrid[cx][cy]=PATHER_ENDPOINT;
		cout << markgrid[cx][cy] << " " << cx << " " << cy << endl;
		if (p==0 && (Area.gamemode=="2cp"||Area.gamemode=="ctf")){
			markgrid[cx][cy] += 2;
			gmx2 = cx;
			gmy2 = cy;
			if (cy > height/2 && gms1 && ATTEMPTS < MAXATTEMPTS){
				cout << "restarting for 2cp point things " << cy << " " << gmx1 << endl;
				return main(argc, argv);
			}
			else if (cy < height/2 && gms2 && ATTEMPTS < MAXATTEMPTS){
				cout << "restarting for 2cp point things " << cy << " " << gmx1 << endl;
				return main(argc, argv);
			}
		} else if (p==0 && Area.gamemode=="pl"){
			markgrid[cx][cy]=PATHER_ENDPOINT_SPECIAL;
		}
		if (p==1 && (Area.gamemode=="2cp"||Area.gamemode=="ctf")){
			gmx3 = cx;
			gmy3 = cy;
		}
		if (p==2 && (Area.gamemode=="2cp"||Area.gamemode=="ctf")){
			gmx4 = cx;
			gmy4 = cy;
		}
	}
	cout << "finished pathers!" << endl;


	if (Area.gamemode!="2cp"&&Area.gamemode!="ctf"){
		if (noplloops==2){
		cout << "fixing up silly cart paths" << endl;
			for (int x=0; x<width; x++){
				for (int y=0; y<height; y++){
					if (gamegrid[x][y].size()>1){
						int kos = gamegrid[x][y][0]+1;
						int kosc = gamegrid[x][y][1]-gamegrid[x][y][0];
						if ((kos < gmv1+1+kosc || kos > gmv1-1-kosc)
							&&(kos < gmv2+1+kosc || kos > gmv2-1-kosc)
							&&(kos < gmv3+1+kosc || kos > gmv3-1-kosc)
							&&(kos > 1+kosc)
						){
							cout << ".";
							for (int xx=0; xx<width; xx++){
								for (int yy=0; yy<height; yy++){
									for (int ii=0; ii<gamegrid[xx][yy].size(); ii++){
										if (gamegrid[xx][yy][ii]>=kos&&gamegrid[xx][yy][ii]<=kos+kosc-1){
											gamegrid[xx][yy].erase(gamegrid[xx][yy].begin()+ii);
										}
									}
								}
							}
							for (int xx=0; xx<width; xx++){
								for (int yy=0; yy<height; yy++){
									for (int ii=0; ii<gamegrid[xx][yy].size(); ii++){
										if (gamegrid[xx][yy][ii]>kos){
											gamegrid[xx][yy][ii]-=kosc;
										}
									}
								}
							}
							if (gmv1 > kos) gmv1-=kosc;
							if (gmv2 > kos) gmv2-=kosc;
							if (gmv3 > kos) gmv3-=kosc;
						}
					}
				}
			}
			cout << endl;
		} else if (noplloops==1){
		cout << "fixing up silly cart paths" << endl;
			for (int repeating=0; repeating < 4; repeating++){
				cout << " " << repeating;
				for (int x=0; x<width; x++){
					for (int y=0; y<height; y++){
						if (gamegrid[x][y].size()>1){
							for (int i=0; i<gamegrid[x][y].size()-1; i++){
								if (gamegrid[x][y][i]+2==gamegrid[x][y][i+1]){
									int kos = gamegrid[x][y][i]+1;
									if ((kos < gmv1-3 || kos > gmv1+3)
										&&(kos < gmv2-3 || kos > gmv2+3)
										&&(kos < gmv3-3 || kos > gmv3+3)
										&&(kos > 3 && kos < Area.pather_loop-3)
									){
										cout << ".";
										for (int xx=0; xx<width; xx++){
											for (int yy=0; yy<height; yy++){
												for (int ii=0; ii<gamegrid[xx][yy].size(); ii++){
													if (gamegrid[xx][yy][ii]==kos||gamegrid[xx][yy][ii]==kos+1){
														gamegrid[xx][yy].erase(gamegrid[xx][yy].begin()+ii);
													}
												}
											}
										}
										for (int xx=0; xx<width; xx++){
											for (int yy=0; yy<height; yy++){
												for (int ii=0; ii<gamegrid[xx][yy].size(); ii++){
													if (gamegrid[xx][yy][ii]>kos){
														gamegrid[xx][yy][ii]-=2;
													}
												}
											}
										}
										if (gmv1 > kos) gmv1-=2;
										if (gmv2 > kos) gmv2-=2;
										if (gmv3 > kos) gmv3-=2;
									}
								}
							}
						}
					}
				}
			}
			cout << endl;
		}
		
		cout << "fixing up really close spawns " << endl;
		int record=1;
		vector<vector<int> > rc = vector<vector<int> >();
		vector<vector<int> > bc = vector<vector<int> >();
		for (int x=0; x<width; x++){
			for (int y=0; y<height; y++){
				if (markgrid[x][y]==PATHER_STARTPOINT){
					bc.push_back(vector<int>());
					bc.back().push_back(x);
					bc.back().push_back(y);
				} else if (markgrid[x][y]==PATHER_ENDPOINT){
					rc.push_back(vector<int>());
					rc.back().push_back(x);
					rc.back().push_back(y);
				}
			}
		}
		/*
		cout << "fixing up really close spawns (p2)" << endl;
		for (int atmp=0; rc.size()>2&&bc.size()>2&&record<100*HYPERSCALE&&atmp<50; atmp++){
			record++;
			cout << atmp << endl;
			for (int r=0; r<rc.size()&&rc.size()>2&&bc.size()>2; r++){
				for (int b=0; b<bc.size()&&rc.size()>2&&bc.size()>2; b++){
					if(minpath(rc[r][0], rc[r][1], bc[b][0], bc[b][1], grid)<=record){
						markgrid[rc[r][0]][rc[r][1]]=0;
						markgrid[bc[b][0]][bc[b][1]]=0;
						rc.erase(rc.begin()+r);
						bc.erase(bc.begin()+b);
						cout << record << " " << endl;
					}
				}
			}
		}
		*/
		cout << endl;
		
	}
	
	// determine connections
	/*
	var ultour=0;
	var ultodl=0;
	var urtodr=0;
	var dltodr=0;
	var ultodr=0;
	var urtodl=0;
	for (var yy = 1; yy < height-1; yy++){
		for (var xx = 1; xx < width-1; xx++){
			if (quadgrid[xx, yy] == 1){
				 if (quadgrid[xx+1, yy] == 2) ultour=1;
				 if (quadgrid[xx-1, yy] == 2) ultour=1;
				 if (quadgrid[xx, yy+1] == 2) ultour=1;
				 if (quadgrid[xx, yy-1] == 2) ultour=1;
				 if (quadgrid[xx+1, yy] == 3) ultodl=1;
				 if (quadgrid[xx-1, yy] == 3) ultodl=1;
				 if (quadgrid[xx, yy+1] == 3) ultodl=1;
				 if (quadgrid[xx, yy-1] == 3) ultodr=1;
				 if (quadgrid[xx+1, yy] == 4) ultodr=1;
				 if (quadgrid[xx-1, yy] == 4) ultodr=1;
				 if (quadgrid[xx, yy+1] == 4) ultodr=1;
				 if (quadgrid[xx, yy-1] == 4) ultodr=1;
			} else if (quadgrid[xx, yy] == 4){
				 if (quadgrid[xx+1, yy] == 2) urtodr=1;
				 if (quadgrid[xx-1, yy] == 2) urtodr=1;
				 if (quadgrid[xx, yy+1] == 2) urtodr=1;
				 if (quadgrid[xx, yy-1] == 2) urtodr=1;
				 if (quadgrid[xx+1, yy] == 3) dltodr=1;
				 if (quadgrid[xx-1, yy] == 3) dltodr=1;
				 if (quadgrid[xx, yy+1] == 3) dltodr=1;
				 if (quadgrid[xx, yy-1] == 3) dltodr=1;
			} else if (quadgrid[xx, yy] == 2){
				 if (quadgrid[xx+1, yy] == 3) urtodl=1;
				 if (quadgrid[xx-1, yy] == 3) urtodl=1;
				 if (quadgrid[xx, yy+1] == 3) urtodl=1;
				 if (quadgrid[xx, yy-1] == 3) urtodl=1;
			}
		}
	}
	var uls=0;
	var urs=0;
	var dls=0;
	var drs=0;
	if (ultour+ultodl+ultodr==0) uls=1;
	if (ultour+urtodl+urtodr==0) urs=1;
	if (urtodl+ultodl+dltodr==0) dls=1;
	if (ultodr+urtodr+dltodr==0) drs=1;
	*/

	cout<< "fixing up placeholders..." << endl;
	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){
			if (jumpy){
				if (grid[xx][yy]==PLACEHOLDER) grid[xx][yy]=VOID;
			}
			if (quadgrid[xx][yy]>-1){
				for (int i = 0; i < 7; i++){
					int xxx = xx;
					int yyy = yy;
					if (i < 4) xxx += (i-1);
					if (i > 3) yyy += (i-5);
					if (quadgrid[xxx][yyy]>-1){
						congrid[quadgrid[xx][yy]][quadgrid[xxx][yyy]]=1;
						congrid[quadgrid[xxx][yyy]][quadgrid[xx][yy]]=1;
					}
				}
			}
		}
	}
	cout<< "planning secrets..." << endl;
	//determine secrets
	for (int xp=0; xp<pathers; xp++){
		issecret[xp] = 1;
		for (int yp=0; yp<pathers; yp++){
			if (xp != yp){
				if (congrid[xp][yp]==1) issecret[xp] = 0;
			}
		}
		if (issecret[xp]==1) totalsecrets++;
	}
	cout<< "planning walls..." << endl;
	// add walls
	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){
			if (grid[xx][yy] == FLOOR) {
				if (grid[xx+1][yy] != FLOOR) {
					grid[xx+1][yy] = WALL;
				}
				if (grid[xx-1][yy] != FLOOR) {
					grid[xx-1][yy] = WALL;
				}
				if (grid[xx][yy+1] != FLOOR) {
					grid[xx][yy+1] = WALL;
				}
				if (grid[xx][yy-1] != FLOOR) {
					grid[xx][yy-1] = WALL;
				}
			}
		}
	}
	
	if (Area.wall_thickness>1){
    for (int i=0; i<Area.wall_thickness-1; i++){
        for (int yy = 1; yy < height-1; yy++){
            for (int xx = 1; xx < width-1; xx++){
                if (grid[xx][yy] == WALL) {
                    if (grid[xx+1][yy] == VOID) {
                        grid[xx+1][yy] = PLACEHOLDER;
                    }
                    if (grid[xx-1][yy] == VOID) {
                        grid[xx-1][yy] = PLACEHOLDER;
                    }
                    if (grid[xx][yy+1] == VOID) {
                        grid[xx][yy+1] = PLACEHOLDER;
                    }
                    if (grid[xx][yy-1] == VOID) {
                        grid[xx][yy-1] = PLACEHOLDER;
                    }
                }
            }
        }
        for (int yy = 1; yy < height-1; yy++){
            for (int xx = 1; xx < width-1; xx++){
                if (grid[xx][yy]==PLACEHOLDER) grid[xx][yy]=WALL;
            }
        }
    }
}
	
	cout<< "building secrets..." << endl;
	// create secrets
	int numconnections=0;
	for (int yy = 0; yy < height; yy++){
		for (int xx = 0; xx < width; xx++){
			int issec=0;
			int adnonsec=0;
			for (int i = 0; i < 7; i++){
				int xxx = xx;
				int yyy = yy;
				if (i < 4) xxx += (i-1);
				if (i > 3) yyy += (i-5);
				if (xxx > -1 && yyy > -1 && xxx < width && yyy < height){
					if (quadgrid[xxx][yyy] > -1){
						while (issecret.size() < quadgrid[xxx][yyy]) issecret.push_back(0);
						if (issecret[quadgrid[xxx][yyy]] == 1){
							issec=1;
						} else {
							adnonsec=1;
						}
					}
				}
			}
			if (issec==1){
				if(grid[xx][yy]==FLOOR) grid[xx][yy] = SECRET_FLOOR;
				if(grid[xx][yy]==WALL) {
					if (adnonsec==1) {
						grid[xx][yy] = SECRET_ENTRANCE;
						numconnections ++;
					}
					if (adnonsec!=1) grid[xx][yy] = SECRET_WALL;
				}
			}
		}
	}
	
	for(int repeating=0; repeating<Area.fix_loop; repeating++){
		cout<< "expanding secrecy..." << endl;
		//if there are not enough secret room connections, expand the secret room a bit
		if (totalsecrets>0){
			if (numconnections<totalsecrets*2){
				for (int yy = 0; yy < height; yy++){
					for (int xx = 0; xx < width; xx++){
						if(grid[xx][yy]==SECRET_WALL){
							int conr=0;
							int conv=0;
							int cons=0;
							for (int i = 0; i < 7; i++){
								int xxx = xx;
								int yyy = yy;
								if (i < 4) xxx += (i-1);
								if (i > 3) yyy += (i-5);
								if (xxx > -1 && yyy > -1 && xxx < width && yyy < height){
									if (grid[xxx][yyy]==VOID) conv=1;
									if (grid[xxx][yyy]==SECRET_FLOOR) cons=1;
									if (grid[xxx][yyy]==WALL) {
										conr=1;
										if (grid[xxx+1][yyy]==VOID) conv=1;
										if (grid[xxx-1][yyy]==VOID) conv=1;
										if (grid[xxx][yyy+1]==VOID) conv=1;
										if (grid[xxx][yyy-1]==VOID) conv=1;
									}
								}
							}
							if (conr+cons==2){
								if (conv==0){
									for (int i = 0; i < 7; i++){
										int xxx = xx;
										int yyy = yy;
										if (i < 4) xxx += (i-1);
										if (i > 3) yyy += (i-5);
										if (xxx > -1 && yyy > -1 && xxx < width && yyy < height){
											if (grid[xxx][yyy]==WALL) quadgrid[xxx][yyy]=ORIGIN_WALLMEET;
											if (grid[xxx][yyy]==WALL) grid[xxx][yyy]=SECRET_ENTRANCE;
										}
									}
									grid[xx][yy]=SECRET_FLOOR;
									quadgrid[xx][yy]=ORIGIN_WALLMEET;
									numconnections++;
								}
							}
						}
					}
				}
			}
			if (numconnections<totalsecrets*2){
				for (int yy = 0; yy < height; yy++){
					for (int xx = 0; xx < width; xx++){
						if(grid[xx][yy]==VOID){
							int cons=0;
							int conr=0;
							for (int i = 0; i < 7; i++){
								int xxx = xx;
								int yyy = yy;
								if (i < 4) xxx += (i-1);
								if (i > 3) yyy += (i-5);
								if (xxx > 0 && yyy > 0 && xxx < width-1 && yyy < height-1){
									if (grid[xxx][yyy] == SECRET_WALL){
										if (grid[xxx+1][yyy]==SECRET_FLOOR) cons=1;
										if (grid[xxx-1][yyy]==SECRET_FLOOR) cons=1;
										if (grid[xxx][yyy+1]==SECRET_FLOOR) cons=1;
										if (grid[xxx][yyy-1]==SECRET_FLOOR) cons=1;
									}
									if (grid[xxx][yyy] == WALL){
										if (grid[xxx+1][yyy]==FLOOR) conr=1;
										if (grid[xxx-1][yyy]==FLOOR) conr=1;
										if (grid[xxx][yyy+1]==FLOOR) conr=1;
										if (grid[xxx][yyy-1]==FLOOR) conr=1;
									}
								}
							}
							if (cons+conr==2){
								for (int i = 0; i < 7; i++){
									int xxx = xx;
									int yyy = yy;
									if (i < 4) xxx += (i-1);
									if (i > 3) yyy += (i-5);
									if (xxx > -1 && yyy > -1 && xxx < width && yyy < height){
										if (grid[xxx][yyy]==WALL) quadgrid[xxx][yyy]=ORIGIN_EXTENDED_WALL;
										if (grid[xxx][yyy]==WALL) grid[xxx][yyy]=SECRET_ENTRANCE;
										if (grid[xxx][yyy]==SECRET_WALL) grid[xxx][yyy]=SECRET_FLOOR;
										if (grid[xxx][yyy]==VOID) grid[xxx][yyy]=SECRET_WALL;
									}
								}
								grid[xx][yy]=SECRET_FLOOR;
								numconnections++;
							}
						}
					}
				}
				for (int yy = 1; yy < height-1; yy++){
					for (int xx = 1; xx < width-1; xx++){
						if (grid[xx][yy] == SECRET_FLOOR) {
							if (grid[xx+1][yy] == VOID) {
								grid[xx+1][yy] = SECRET_WALL;
							}
							if (grid[xx-1][yy] == VOID) {
								grid[xx-1][yy] = SECRET_WALL;
							}
							if (grid[xx][yy+1] == VOID) {
								grid[xx][yy+1] = SECRET_WALL;
							}
							if (grid[xx][yy-1] == VOID) {
								grid[xx][yy-1] = SECRET_WALL;
							}
						}
						if (grid[xx][yy] == SECRET_ENTRANCE) {
							if (grid[xx+1][yy] == VOID) {
								grid[xx+1][yy] = SECRET_WALL;
							}
							if (grid[xx-1][yy] == VOID) {
								grid[xx-1][yy] = SECRET_WALL;
							}
							if (grid[xx][yy+1] == VOID) {
								grid[xx][yy+1] = SECRET_WALL;
							}
							if (grid[xx][yy-1] == VOID) {
								grid[xx][yy-1] = SECRET_WALL;
							}
						}
						if (grid[xx][yy] == FLOOR) {
							if (grid[xx+1][yy] == VOID) {
								grid[xx+1][yy] = WALL;
							}
							if (grid[xx-1][yy] == VOID) {
								grid[xx-1][yy] = WALL;
							}
							if (grid[xx][yy+1] == VOID) {
								grid[xx][yy+1] = WALL;
							}
							if (grid[xx][yy-1] == VOID) {
								grid[xx][yy-1] = WALL;
							}
							if (grid[xx+1][yy] == SECRET_FLOOR) {
								grid[xx+1][yy] = FLOOR;
							}
							if (grid[xx-1][yy] == SECRET_FLOOR) {
								grid[xx-1][yy] = FLOOR;
							}
							if (grid[xx][yy+1] == SECRET_FLOOR) {
								grid[xx][yy+1] = FLOOR;
							}
							if (grid[xx][yy-1] == SECRET_FLOOR) {
								grid[xx][yy-1] = FLOOR;
							}
							if (grid[xx+1][yy] == SECRET_WALL) {
								grid[xx+1][yy] = WALL;
							}
							if (grid[xx-1][yy] == SECRET_WALL) {
								grid[xx-1][yy] = WALL;
							}
							if (grid[xx][yy+1] == SECRET_WALL) {
								grid[xx][yy+1] = WALL;
							}
							if (grid[xx][yy-1] == SECRET_WALL) {
								grid[xx][yy-1] = WALL;
							}
						}
					}
				}
		
			}
		}
		cout<< "fixing up secrets..." << endl;
		for(int repeating2=0; repeating2<Area.fix_loop_secret_extender; repeating2++){
			for (int yy = 1; yy < height-1; yy++){
				for (int xx = 1; xx < width-1; xx++){
					if (grid[xx][yy] == SECRET_FLOOR) {
						if (quadgrid[xx][yy] == 0){
							for (int i = 0; i < 7; i++){
								int xxx = xx;
								int yyy = yy;
								if (i < 4) xxx += (i-1);
								if (i > 3) yyy += (i-5);
								if (xxx > -1 && yyy > -1 && xxx < width && yyy < height){
									if (quadgrid[xxx][yyy]>=0){
										if (issecret[quadgrid[xxx][yyy]]==1) quadgrid[xx][yy]=ORIGIN_EXTENDED;
									} else if (quadgrid[xxx][yyy]==ORIGIN_EXTENDED){
										quadgrid[xx][yy]=ORIGIN_EXTENDED;
									}
								}
							}
						}
					}
				}
			}
		}
		cout<< "correcting tiles..." << endl;
		for (int repeating2=0; repeating2<Area.fix_loop_by_tile;repeating2++){
			for (int yy = 1; yy < height-1; yy++){
				for (int xx = 1; xx < width-1; xx++){
					int conns=0;
					int connr=0;
					int connv=0;
					int conne=0;
					if (grid[xx+1][yy] == FLOOR) {
						connr=1;
					}
					if (grid[xx-1][yy] == FLOOR) {
						connr=1;
					}
					if (grid[xx][yy+1] == FLOOR) {
						connr=1;
					}
					if (grid[xx][yy-1] == FLOOR) {
						connr=1;
					}
					if (grid[xx+1][yy] == SECRET_FLOOR) {
						conns=1;
					}
					if (grid[xx-1][yy] == SECRET_FLOOR) {
						conns=1;
					}
					if (grid[xx][yy+1] == SECRET_FLOOR) {
						conns=1;
					}
					if (grid[xx][yy-1] == SECRET_FLOOR) {
						conns=1;
					}
					if (grid[xx+1][yy] == SECRET_ENTRANCE) {
						conne=1;
					}
					if (grid[xx-1][yy] == SECRET_ENTRANCE) {
						conne=1;
					}
					if (grid[xx][yy+1] == SECRET_ENTRANCE) {
						conne=1;
					}
					if (grid[xx][yy-1] == SECRET_ENTRANCE) {
						conne=1;
					}
					if (grid[xx+1][yy] == VOID) {
						connv=1;
					}
					if (grid[xx-1][yy] == VOID) {
						connv=1;
					}
					if (grid[xx][yy+1] == VOID) {
						connv=1;
					}
					if (grid[xx][yy-1] == VOID) {
						connv=1;
					}
					if (grid[xx][yy] == SECRET_FLOOR) {
						if (quadgrid[xx][yy]==0) {
							grid[xx][yy]=SECRET_WALL;
							quadgrid[xx][yy]=ORIGIN_DENIED;
						} else if (quadgrid[xx][yy]==ORIGIN_EXTENDED) {
							if (conns==0) grid[xx][yy] = SECRET_WALL;
							if (conns==0) quadgrid[xx][yy] = ORIGIN_DENIED;
						}
					}
					if (grid[xx][yy] == SECRET_FLOOR) {
						if (grid[xx+1][yy] == VOID) {
							grid[xx+1][yy] = SECRET_WALL;
						}
						if (grid[xx-1][yy] == VOID) {
							grid[xx-1][yy] = SECRET_WALL;
						}
						if (grid[xx][yy+1] == VOID) {
							grid[xx][yy+1] = SECRET_WALL;
						}
						if (grid[xx][yy-1] == VOID) {
							grid[xx][yy-1] = SECRET_WALL;
						}
					}
					if (grid[xx][yy] == SECRET_ENTRANCE) {
						if (conns+connr < 2){
							grid[xx][yy]=SECRET_WALL;
						}
					}
					if (grid[xx][yy] == SECRET_ENTRANCE) {
						if (grid[xx+1][yy] == VOID) {
							grid[xx+1][yy] = SECRET_WALL;
						}
						if (grid[xx-1][yy] == VOID) {
							grid[xx-1][yy] = SECRET_WALL;
						}
						if (grid[xx][yy+1] == VOID) {
							grid[xx][yy+1] = SECRET_WALL;
						}
						if (grid[xx][yy-1] == VOID) {
							grid[xx][yy-1] = SECRET_WALL;
						}
					}
					if (grid[xx][yy] == FLOOR) {
						if (grid[xx+1][yy] == VOID) {
							grid[xx+1][yy] = WALL;
						}
						if (grid[xx-1][yy] == VOID) {
							grid[xx-1][yy] = WALL;
						}
						if (grid[xx][yy+1] == VOID) {
							grid[xx][yy+1] = WALL;
						}
						if (grid[xx][yy-1] == VOID) {
							grid[xx][yy-1] = WALL;
						}
						if (grid[xx+1][yy] == SECRET_FLOOR) {
							grid[xx+1][yy] = FLOOR;
						}
						if (grid[xx-1][yy] == SECRET_FLOOR) {
							grid[xx-1][yy] = FLOOR;
						}
						if (grid[xx][yy+1] == SECRET_FLOOR) {
							grid[xx][yy+1] = FLOOR;
						}
						if (grid[xx][yy-1] == SECRET_FLOOR) {
							grid[xx][yy-1] = FLOOR;
						}
						if (grid[xx+1][yy] == SECRET_WALL) {
							grid[xx+1][yy] = WALL;
						}
						if (grid[xx-1][yy] == SECRET_WALL) {
							grid[xx-1][yy] = WALL;
						}
						if (grid[xx][yy+1] == SECRET_WALL) {
							grid[xx][yy+1] = WALL;
						}
						if (grid[xx][yy-1] == SECRET_WALL) {
							grid[xx][yy-1] = WALL;
						}
					}
					if (grid[xx][yy] == WALL) {
						
						if (conns+connr == 2){
							if (connv==0) grid[xx][yy]=SECRET_ENTRANCE;
						}
					}
					if (grid[xx][yy] == SECRET_WALL){
						if (conns+conne==0){
							grid[xx][yy]=VOID;
						}
					}
				}
			}
		}
	}
	
	
	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){
			if (grid[xx][yy] == WALL && irandom(Area.single_remove_odds) == Area.single_remove_odds){
				if (grid[xx+1][yy] == FLOOR && grid[xx-1][yy] == FLOOR && grid[xx][yy+1] == FLOOR && grid[xx][yy-1] == FLOOR && grid[xx+1][yy+1] == FLOOR && grid[xx-1][yy+1] == FLOOR && grid[xx+1][yy-1] == FLOOR && grid[xx-1][yy-1] == FLOOR){
					grid[xx][yy]=FLOOR;
					quadgrid[xx][yy]=ORIGIN_DENIED;
				}
			}
			if (grid[xx][yy] == SECRET_WALL && irandom(Area.single_remove_odds) == Area.single_remove_odds){
				if (grid[xx+1][yy] == SECRET_FLOOR && grid[xx-1][yy] == SECRET_FLOOR && grid[xx][yy+1] == SECRET_FLOOR && grid[xx][yy-1] == SECRET_FLOOR && grid[xx+1][yy+1] == SECRET_FLOOR && grid[xx-1][yy+1] == SECRET_FLOOR && grid[xx+1][yy-1] == SECRET_FLOOR && grid[xx-1][yy-1] == SECRET_FLOOR){
					grid[xx][yy]=SECRET_FLOOR;
					quadgrid[xx][yy]=ORIGIN_DENIED;
				}
			}
		}
	}
	cout << "building adjacency grids..." << endl;
	vector<vector<int> > adj_floor = vector<vector<int> >();
	vector<vector<int> > adj_sfloor = vector<vector<int> >();
	vector<vector<int> > adj_afloor = vector<vector<int> >();
	vector<vector<int> > adj_wall = vector<vector<int> >();
	vector<vector<int> > adj_swall = vector<vector<int> >();
	vector<vector<int> > adj_awall = vector<vector<int> >();
	vector<vector<int> > adj_void = vector<vector<int> >();

	ds_grid_set_region(adj_floor, 0, 0, width, height, 0);
	ds_grid_set_region(adj_sfloor, 0, 0, width, height, 0);
	ds_grid_set_region(adj_afloor, 0, 0, width, height, 0);
	ds_grid_set_region(adj_wall, 0, 0, width, height, 0);
	ds_grid_set_region(adj_swall, 0, 0, width, height, 0);
	ds_grid_set_region(adj_awall, 0, 0, width, height, 0);
	ds_grid_set_region(adj_void, 0, 0, width, height, 0);


	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){
			for (int i = 1; i < 7; i++){
				int xxx = xx;
				int yyy = yy;
				if (i < 4) xxx += (i-2);
				if (i > 3) yyy += (i-5);
				if (xxx > -1 && yyy > -1 && xxx < width && yyy < height){
					if (xxx != xx || yyy != yy){
						if (grid[xxx][yyy]==WALL) adj_wall[xx][yy]+=1;
						if (grid[xxx][yyy]==SECRET_WALL) adj_swall[xx][yy]+=1;
						if (grid[xxx][yyy]==WALL || grid[xxx][yyy]==SECRET_WALL) adj_awall[xx][yy]+=1;
						if (grid[xxx][yyy]==FLOOR) adj_floor[xx][yy]+=1;
						if (grid[xxx][yyy]==SECRET_FLOOR) adj_sfloor[xx][yy]+=1;
						if (grid[xxx][yyy]==FLOOR || grid[xxx][yyy]==SECRET_FLOOR) adj_afloor[xx][yy]+=1;
						if (grid[xxx][yyy]==VOID) adj_void[xx][yy]+=1;
					}
				}
			}
		}
	}

	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){      
			if (grid[xx][yy]==FLOOR || grid[xx][yy]==SECRET_FLOOR){
				if (adj_awall[xx][yy]==3 && adj_afloor[xx][yy]==1){
					int dedir=VOID;
					quadgrid[xx][yy]=ORIGIN_WALLMEET;
					for (int i = 1; i < 7; i++){
						int xxx = xx;
						int yyy = yy;
						if (i < 4) xxx += (i-2);
						if (i > 3) yyy += (i-5);
						if (xxx > -1 && yyy > -1 && xxx < width && yyy < height){
							if (xxx != xx || yyy != yy){
								if (grid[xxx][yyy]==grid[xx][yy]){
									dedir=i;
								}
							}
						}
					}
					if (dedir!=VOID){
						int dirx=0;
						int diry=0;
						if (dedir < 4) dirx += (dedir-2);
						if (dedir > 3) diry += (dedir-5);
						bool isded=true;
						for(int i=1; i<=Area.detect_deadend; i++){
							if (xx+i*dirx > -1 && yy+i*diry > -1 && xx+i*dirx < width && yy+i*diry < height){
								quadgrid[xx+i*dirx][yy+i*diry]=ORIGIN_DENIED;
								if (adj_afloor[xx+i*dirx][yy+i*diry]!=2) isded=false;
							}
						}
						if (isded && markgrid[xx][yy] < PATHER_ENDPOINT) markgrid[xx][yy]=MARK_DEAD_END;
					}
				}
			}
			if (grid[xx][yy]==WALL){
				if (adj_wall[xx][yy]+adj_floor[xx][yy]==4&&markgrid[xx][yy] < PATHER_ENDPOINT) markgrid[xx][yy]=MARK_NOT_EDGE;
			}
		}
	}
	
	for (int repeating=0; repeating<Area.wall_thickness+1; repeating++){
		for (int yy = 1; yy < height-1; yy++){
			for (int xx = 1; xx < width-1; xx++){
				if (grid[xx][yy]==WALL){
					bool voided=false;
					for (int i = 1; i < 7; i++){
						int xxx = xx;
						int yyy = yy;
						if (i < 4) xxx += (i-2);
						if (i > 3) yyy += (i-5);
						if (xxx > -1 && yyy > -1 && xxx < width && yyy < height){
							if (xxx != xx || yyy != yy){
								if (grid[xxx][yyy]==VOID || markgrid[xxx][yyy]==MARK_VOIDCON || markgrid[xxx][yyy]==MARK_NONEDGE_VOIDCON) voided=true;
							}
						}
					}
					if (voided){
						if (markgrid[xx][yy]!=MARK_NOT_EDGE) markgrid[xx][yy]=MARK_VOIDCON;
						if (markgrid[xx][yy]==MARK_NOT_EDGE) markgrid[xx][yy]=MARK_NONEDGE_VOIDCON;
					}
				}
			}
		}
	}
	cout<< "planning prop placement..." << endl;
	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){
			if (grid[xx][yy] == WALL && irandom(Area.single_prop_odds) == Area.single_prop_odds){
				if (grid[xx+1][yy] == FLOOR && grid[xx-1][yy] == FLOOR && grid[xx][yy+1] == FLOOR && grid[xx][yy-1] == FLOOR && grid[xx+1][yy+1] == FLOOR && grid[xx-1][yy+1] == FLOOR && grid[xx+1][yy-1] == FLOOR && grid[xx-1][yy-1] == FLOOR && (Area.gamemode != "pl" || (gamegrid[xx+1][yy].size() <= 0 && gamegrid[xx-1][yy].size() <= 0 && gamegrid[xx][yy+1].size() <= 0 && gamegrid[xx][yy-1].size() <= 0))) grid[xx][yy]=PROP_SINGLE;
			}
			if (grid[xx][yy] == SECRET_WALL && irandom(Area.single_prop_odds) == Area.single_prop_odds){
				if (grid[xx+1][yy] == SECRET_FLOOR && grid[xx-1][yy] == SECRET_FLOOR && grid[xx][yy+1] == SECRET_FLOOR && grid[xx][yy-1] == SECRET_FLOOR && grid[xx+1][yy+1] == SECRET_FLOOR && grid[xx-1][yy+1] == SECRET_FLOOR && grid[xx+1][yy-1] == SECRET_FLOOR && grid[xx-1][yy-1] == SECRET_FLOOR && (Area.gamemode != "pl" || (gamegrid[xx+1][yy].size() <= 0 && gamegrid[xx-1][yy].size() <= 0 && gamegrid[xx][yy+1].size() <= 0 && gamegrid[xx][yy-1].size() <= 0))) grid[xx][yy]=PROP_SINGLE_S;
			}
		}
	}
	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){
			if (grid[xx][yy] == FLOOR && irandom(Area.spawn_prop_odds) == Area.spawn_prop_odds && (Area.gamemode != "pl" || gamegrid[xx][yy].size() <= 0)){
				if (grid[xx+1][yy] == FLOOR && grid[xx-1][yy] == FLOOR && grid[xx][yy+1] == FLOOR && grid[xx][yy-1] == FLOOR && grid[xx+1][yy+1] == FLOOR && grid[xx-1][yy+1] == FLOOR && grid[xx+1][yy-1] == FLOOR && grid[xx-1][yy-1] == FLOOR && (Area.gamemode != "pl" || (gamegrid[xx+1][yy].size() <= 0 && gamegrid[xx-1][yy].size() <= 0 && gamegrid[xx][yy+1].size() <= 0 && gamegrid[xx][yy-1].size() <= 0))) grid[xx][yy]=PROP_SINGLE;
			}
			if (grid[xx][yy] == SECRET_FLOOR && irandom(Area.spawn_prop_odds) == Area.spawn_prop_odds && (Area.gamemode != "pl" || gamegrid[xx][yy].size() <= 0)){
				if (grid[xx+1][yy] == SECRET_FLOOR && grid[xx-1][yy] == SECRET_FLOOR && grid[xx][yy+1] == SECRET_FLOOR && grid[xx][yy-1] == SECRET_FLOOR && grid[xx+1][yy+1] == SECRET_FLOOR && grid[xx-1][yy+1] == SECRET_FLOOR && grid[xx+1][yy-1] == SECRET_FLOOR && grid[xx-1][yy-1] == SECRET_FLOOR && (Area.gamemode != "pl" || (gamegrid[xx+1][yy].size() <= 0 && gamegrid[xx-1][yy].size() <= 0 && gamegrid[xx][yy+1].size() <= 0 && gamegrid[xx][yy-1].size() <= 0))) grid[xx][yy]=PROP_SINGLE_S;
			}
		}
	}
	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){
			if (grid[xx][yy] == FLOOR && irandom(Area.single_prop_odds) == Area.small_prop_odds && (Area.gamemode != "pl" || gamegrid[xx][yy].size() <= 0)){
				int adjwalls = 0;
				int adjfloor = 0;
				if (grid[xx+1][yy+1] != FLOOR || (grid[xx+1][yy] != FLOOR || grid[xx][yy+1] != FLOOR)) adjwalls++;
				if (grid[xx-1][yy-1] != FLOOR || (grid[xx-1][yy] != FLOOR || grid[xx][yy-1] != FLOOR)) adjwalls++;
				if (grid[xx+1][yy-1] != FLOOR || (grid[xx+1][yy] != FLOOR || grid[xx][yy-1] != FLOOR)) adjwalls++;
				if (grid[xx-1][yy+1] != FLOOR || (grid[xx-1][yy] != FLOOR || grid[xx][yy+1] != FLOOR)) adjwalls++;
				
				if (grid[xx+1][yy+1] == FLOOR || (grid[xx+1][yy] == FLOOR || grid[xx][yy+1] == FLOOR)) adjfloor++;
				if (grid[xx-1][yy-1] == FLOOR || (grid[xx-1][yy] == FLOOR || grid[xx][yy-1] == FLOOR)) adjfloor++;
				if (grid[xx+1][yy-1] == FLOOR || (grid[xx+1][yy] == FLOOR || grid[xx][yy-1] == FLOOR)) adjfloor++;
				if (grid[xx-1][yy+1] == FLOOR || (grid[xx-1][yy] == FLOOR || grid[xx][yy+1] == FLOOR)) adjfloor++;
				
				if ( adjwalls < 2 && adjfloor >= 2){
					grid[xx][yy]=PROP_SMALL;
				}
			}
			if (grid[xx][yy] == SECRET_FLOOR && irandom(Area.single_prop_odds) == Area.small_prop_odds && (Area.gamemode != "pl" || gamegrid[xx][yy].size() <= 0)){
				int adjwalls = 0;
				int adjfloor = 0;
				if (grid[xx+1][yy+1] != SECRET_FLOOR || (grid[xx+1][yy] != SECRET_FLOOR || grid[xx][yy+1] != SECRET_FLOOR)) adjwalls++;
				if (grid[xx-1][yy-1] != SECRET_FLOOR || (grid[xx-1][yy] != SECRET_FLOOR || grid[xx][yy-1] != SECRET_FLOOR)) adjwalls++;
				if (grid[xx+1][yy-1] != SECRET_FLOOR || (grid[xx+1][yy] != SECRET_FLOOR || grid[xx][yy-1] != SECRET_FLOOR)) adjwalls++;
				if (grid[xx-1][yy+1] != SECRET_FLOOR || (grid[xx-1][yy] != SECRET_FLOOR || grid[xx][yy+1] != SECRET_FLOOR)) adjwalls++;
				
				if (grid[xx+1][yy+1] == SECRET_FLOOR || (grid[xx+1][yy] == SECRET_FLOOR || grid[xx][yy+1] == SECRET_FLOOR)) adjfloor++;
				if (grid[xx-1][yy-1] == SECRET_FLOOR || (grid[xx-1][yy] == SECRET_FLOOR || grid[xx][yy-1] == SECRET_FLOOR)) adjfloor++;
				if (grid[xx+1][yy-1] == SECRET_FLOOR || (grid[xx+1][yy] == SECRET_FLOOR || grid[xx][yy-1] == SECRET_FLOOR)) adjfloor++;
				if (grid[xx-1][yy+1] == SECRET_FLOOR || (grid[xx-1][yy] == SECRET_FLOOR || grid[xx][yy+1] == SECRET_FLOOR)) adjfloor++;
				
				if ( adjwalls < 2 && adjfloor >= 2){
					grid[xx][yy]=PROP_SMALL;
				}
				
				/*
				if (((grid[xx+1][yy] == SECRET_FLOOR && grid[xx-1][yy] == SECRET_FLOOR) || 
				(grid[xx+1][yy+1] == SECRET_FLOOR && grid[xx-1][yy-1] == SECRET_FLOOR) || 
				(grid[xx+1][yy-1] == SECRET_FLOOR && grid[xx-1][yy+1] == SECRET_FLOOR) || 
				(grid[xx][yy+1] == SECRET_FLOOR && grid[xx][yy-1] == SECRET_FLOOR)
				) &&
				!((grid[xx+1][yy] == SECRET_FLOOR && grid[xx][yy+1] == SECRET_FLOOR && grid[xx+1][yy+1] != SECRET_FLOOR)||
				(grid[xx-1][yy] == SECRET_FLOOR && grid[xx][yy-1] == SECRET_FLOOR && grid[xx-1][yy-1] != SECRET_FLOOR)||
				(grid[xx-1][yy] == SECRET_FLOOR && grid[xx][yy+1] == SECRET_FLOOR && grid[xx-1][yy+1] != SECRET_FLOOR)||
				(grid[xx+1][yy] == SECRET_FLOOR && grid[xx][yy-1] == SECRET_FLOOR && grid[xx+1][yy-1] != SECRET_FLOOR))){
					grid[xx][yy]=PROP_SMALL;
				}
				*/
			}
		}
	}
	cout << "thinking sbout movement..." << endl;
	for (int yy = 0; yy < height; yy++){
		for (int xx = 0; xx < width; xx++){
			if (grid[xx][yy] == FLOOR){
				absgrid[xx][yy] = FLOOR;
			} else if (grid[xx][yy] == WALL){
				absgrid[xx][yy] = WALL;
			} else if (grid[xx][yy] == PROP_SINGLE){
				absgrid[xx][yy] = PROP;
			} else if (grid[xx][yy] == SECRET_FLOOR){
				absgrid[xx][yy] = FLOOR;
			} else if (grid[xx][yy] == SECRET_WALL){
				absgrid[xx][yy] = WALL;
			} else if (grid[xx][yy] == PROP_SINGLE_S){
				absgrid[xx][yy] = PROP;
			} else if (grid[xx][yy] == SECRET_ENTRANCE){
				absgrid[xx][yy] = FLOOR;
			} else if (grid[xx][yy] == PROP_SMALL){
				absgrid[xx][yy] = PROP;
			}
		}
	}
	/*
	if (Area.gamemode=="2cp"||Area.gamemode=="ctf"){
		cout << "thinking about fair spawns..." << endl;
		float forgiveness = 0.85;
		if (!(minpath(gmx1, gmy1, gmx2, gmy2, absgrid)*forgiveness<=minpath(gmx1, gmy1, gmx4, gmy4, absgrid)&&minpath(gmx1, gmy1, gmx2, gmy2, absgrid)*forgiveness<=minpath(gmx2, gmy2, gmx3, gmy3, absgrid))){
			cout << "2cp spawn placement determined unfair by alg 1" << endl;
			//orgniz = false;
			//return main(argc, argv);
		} else {
			forgiveness *= 0.8;
		}
		cout << minpath(gmx1, gmy1, gmx4, gmy4, absgrid) << " " << minpath(gmx2, gmy2, gmx3, gmy3, absgrid) << " " << minpath(gmx1, gmy1, gmx3, gmy3, absgrid) << " " << minpath(gmx2, gmy2, gmx4, gmy4, absgrid) << endl;
		int a = minpath(gmx1, gmy1, gmx4, gmy4, absgrid) - minpath(gmx2, gmy2, gmx3, gmy3, absgrid);
		int b = minpath(gmx1, gmy1, gmx3, gmy3, absgrid) - minpath(gmx2, gmy2, gmx4, gmy4, absgrid);
		b *= (minpath(gmx1, gmy1, gmx4, gmy4, absgrid)+minpath(gmx2, gmy2, gmx3, gmy3, absgrid))/(minpath(gmx1, gmy1, gmx3, gmy3, absgrid)+minpath(gmx2, gmy2, gmx4, gmy4, absgrid));
		int c = a + b;
		cout << a << " " << b;
		if (a < 0) a *= -1;
		if (b < 0) b *= -1;
		if (c < 0) c *= -1;
		cout << " " << c << endl;
		if (c*forgiveness*0.9 > (width+height)/8){
			cout << "2cp spawn placement determined unfair by alg 2" << endl;
			return main(argc, argv);
		}
		a = minpath(gmx1, gmy1, gmx3, gmy3, absgrid) - minpath(gmx2, gmy2, gmx3, gmy3, absgrid);
		b = minpath(gmx1, gmy1, gmx4, gmy4, absgrid) - minpath(gmx2, gmy2, gmx4, gmy4, absgrid);
		c = a + b;
		cout << a << " " << b;
		if (a < 0) a *= -1;
		if (b < 0) b *= -1;
		if (c < 0) c *= -1;
		cout << " " << c << endl;
		if (c*forgiveness > (width+height)/10){
			cout << "2cp spawn placement determined unfair by alg 3" << endl;
			return main(argc, argv);
		}
		if (minpath(gmx1, gmy1, gmx3, gmy3, absgrid)<6||minpath(gmx2, gmy2, gmx4, gmy4, absgrid)<6){
			cout << "2cp spawn placement determined too close to point" << endl;
			return main(argc, argv);
		}
		//cout << minpath(gmx1, gmy1, gmx2, gmy2, absgrid) << " " << minpath(gmx1, gmy1, gmx4, gmy4, absgrid) << " " << minpath(gmx2, gmy2, gmx3, gmy3, absgrid) << endl;
	}
	*/
	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){
			if (pathergrid[xx][yy][PYM]&&absgrid[xx][yy-1]==WALL){
				pathergrid[xx][yy][PYM]=0;
			}
			if (pathergrid[xx][yy][PYP]&&absgrid[xx][yy+1]==WALL){
				pathergrid[xx][yy][PYP]=0;
			}
			if (pathergrid[xx][yy][PXM]&&absgrid[xx+1][yy]==WALL){
				pathergrid[xx][yy][PXM]=0;
			}
			if (pathergrid[xx][yy][PXP]&&absgrid[xx-1][yy]==WALL){
				pathergrid[xx][yy][PXP]=0;
			}
		}
	}
	for (int yy = 1; yy < height-1; yy++){
		pathergrid[1][yy][PATH_LEFT]=0;
		pathergrid[width-2][yy][PATH_RIGHT]=0;
	}
	for (int xx = 1; xx < width-1; xx++){
		pathergrid[xx][1][PATH_UP]=0;
		pathergrid[xx][height-2][PATH_DOWN]=0;
	}
	
	vector<vector<int> > hallgrid = vector<vector<int> >();
	ds_grid_set_region(hallgrid, 0, 0, width, height, 0);
	cout << "working out halls..." << endl;
	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){
			if (absgrid[xx][yy]==FLOOR && (pathergrid[xx][yy][0]+pathergrid[xx][yy][1]+pathergrid[xx][yy][2]+pathergrid[xx][yy][3]>0)){
				
				int adjwalls = 0;
				if (absgrid[xx+1][yy+1]==WALL || (absgrid[xx+1][yy]==WALL || absgrid[xx][yy+1]==WALL)) adjwalls++;
				if (absgrid[xx-1][yy-1]==WALL || (absgrid[xx-1][yy]==WALL || absgrid[xx][yy-1]==WALL)) adjwalls++;
				if (absgrid[xx+1][yy-1]==WALL || (absgrid[xx+1][yy]==WALL || absgrid[xx][yy-1]==WALL)) adjwalls++;
				if (absgrid[xx-1][yy+1]==WALL || (absgrid[xx-1][yy]==WALL || absgrid[xx][yy+1]==WALL)) adjwalls++;
				/*
				bool got1=false;
				bool got2=false;
				bool got3=false;
				bool got4=false;
				if (pathergrid[xx+1][yy+1][0]+pathergrid[xx+1][yy+1][1]+pathergrid[xx+1][yy+1][2]+pathergrid[xx+1][yy+1][3]>0) got1=true;
				if (pathergrid[xx-1][yy-1][0]+pathergrid[xx-1][yy-1][1]+pathergrid[xx-1][yy-1][2]+pathergrid[xx-1][yy-1][3]>0) got2=true;
				if (pathergrid[xx+1][yy+1][0]+pathergrid[xx+1][yy+1][1]+pathergrid[xx+1][yy+1][2]+pathergrid[xx+1][yy+1][3]>0) got3=true;
				if (pathergrid[xx-1][yy-1][0]+pathergrid[xx-1][yy-1][1]+pathergrid[xx-1][yy-1][2]+pathergrid[xx-1][yy-1][3]>0) got4=true;
				*/
				//cout << adj_awall[xx][yy] << " " << adjwalls << endl;
				if (adjwalls==4){
					hallgrid[xx][yy]=1;
				}
				
				/*
				if (!(
				(pathergrid[xx][yy][1]==0&&absgrid[xx][yy-1]!=WALL)||
				(pathergrid[xx][yy][3]==0&&absgrid[xx][yy+1]!=WALL)||
				(pathergrid[xx][yy][2]==0&&absgrid[xx+1][yy]!=WALL)||
				(pathergrid[xx][yy][0]==0&&absgrid[xx-1][yy]!=WALL)
				)) hallgrid[xx][yy]=1;
				*/
			}
		}
	}
	cout << "halls p2" << endl;
	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){
			if (hallgrid[xx][yy]>0){
				if (absgrid[xx][yy]==WALL) hallgrid[xx][yy]=0;
			}
		}
	}
	cout << "halls p3" << endl;
	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){
			if (hallgrid[xx][yy]>0){
				if (hallgrid[xx+1][yy]==0&&hallgrid[xx-1][yy]==0&&hallgrid[xx][yy+1]==0&&hallgrid[xx][yy-1]==0) hallgrid[xx][yy]=0;
				else {
					if (pathergrid[xx][yy][PYM]&&hallgrid[xx][yy-1]==0&&absgrid[xx][yy-1]!=WALL){
						hallgrid[xx][yy]=2;
					}
					if (pathergrid[xx][yy][PYP]&&hallgrid[xx][yy+1]==0&&absgrid[xx][yy+1]!=WALL){
						hallgrid[xx][yy]=4;
					}
					if (pathergrid[xx][yy][PXP]&&hallgrid[xx+1][yy]==0&&absgrid[xx+1][yy]!=WALL){
						hallgrid[xx][yy]=5;
					}
					if (pathergrid[xx][yy][PXM]&&hallgrid[xx-1][yy]==0&&absgrid[xx-1][yy]!=WALL){
						hallgrid[xx][yy]=3;
					}
				}
			}
		}
	}
	
	cout << "determining indoors / outdoors" << endl;
	
	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){
			if (inoutgrid[xx][yy]<0){
				if (absgrid[xx][yy]==WALL || hallgrid[xx][yy]>0){
					inoutgrid[xx][yy]=2;
				}					
				/*
				if (overgrid[xx][yy]==ORIGIN_ROOMCENTER){
					
					bool gotem = false;
					bool cont = true;
					
					int brokex = 0;
					int brokey = 0;
					bool brokewalls = false;
					
					
					for (int round = 0; round <= 5 && cont; round++){
						bool brokewall = false;
						bool brokeroom = false;
						for (int xxx=xx-round; xxx<xx+round+1; xxx++){
							//for (int yyy=yy-2; yyy<yy+2; yyy++){
							for (int iii=0; iii<2; iii++){
								int yyy = yy-1;
								if (iii > 0) yyy = yy+1-1;
								if (xxx > -1 && yyy > -1 && xxx < width && yyy < height){
									if (overgrid[xxx][yyy] != ORIGIN_ROOMCENTER && overgrid[xxx][yyy] != ORIGIN_ROOMGEN){
										if (absgrid[xxx][yyy] != FLOOR) brokeroom = true;
									}
									if (absgrid[xxx][yyy] != WALL && hallgrid[xxx][yyy] <= 0){
										brokewall = true;
									}
								}
							}
						}
						if (brokeroom){
							brokex = round;
							cont = false;
							if (brokewall) brokewalls = true;
						}
					}
					
					cont = true;
					for (int round = 0; round <= 5 && cont; round++){
						bool brokewall = false;
						bool brokeroom = false;
						for (int yyy=yy-round; yyy<yy+round; yyy++){
							//for (int yyy=yy-2; yyy<yy+2; yyy++){
							for (int iii=0; iii<2; iii++){
								int xxx = xx-brokex+1;
								if (iii > 0) xxx = xx+brokex-1;
								if (xxx > -1 && yyy > -1 && xxx < width && yyy < height){
									if (overgrid[xxx][yyy] != ORIGIN_ROOMCENTER && overgrid[xxx][yyy] != ORIGIN_ROOMGEN){
										if (absgrid[xxx][yyy] != FLOOR) brokeroom = true;
									}
									if (absgrid[xxx][yyy] != WALL && hallgrid[xxx][yyy] <= 0){
										brokewall = true;
									}
								}
							}
						}
						if (brokeroom){
							brokey = round;
							cont = false;
							if (brokewall) brokewalls = true;
						}
					}
					cont = true;
					cout << "Broke on " << brokex << "," << brokey << endl;
					cout << brokewalls << endl;
				}
					*/
			}
		}
	}
	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){
			if (inoutgrid[xx][yy]<0){
				if (absgrid[xx][yy]==FLOOR && inoutgrid[xx-1][yy]>0 && inoutgrid[xx][yy-1]>0){
					int xxx = xx;
					bool cont = true;
					while (xxx < width-1 && cont){
						xxx++;
						if(absgrid[xxx][yy]!=FLOOR || inoutgrid[xxx][yy-1]<2){
							cont = false;
						}
					}
					cont = true;
					bool gotem = false;
					int yyy = yy;
					while (yyy < height-1 && cont){
						gotem = true;
						yyy++;
						for (int xxxx=xx; xxxx < xxx; xxxx++){
							if (inoutgrid[xxxx][yyy]<2) gotem=false;
							if (absgrid[xxxx][yyy]!=FLOOR || inoutgrid[xxxx][yyy]>0) {
								cont = false;
							}
						}
						if (!gotem && (inoutgrid[xx-1][yyy]<2 || inoutgrid[xxx][yyy]<2)){
							cont = false;
						}
					}
					if (gotem) {
						for (int xxxx = xx; xxxx < xxx; xxxx++){
							for (int yyyy = yy; yyyy < yyy; yyyy++){
								inoutgrid[xxxx][yyyy] = 1;
							}
						}
					}
				}
			}
		}
	}
	
	cout << "building displacements..." << endl;
	
	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){
			if (inoutgrid[xx][yy]<0){
				if (absgrid[xx][yy]==FLOOR) inoutgrid[xx][yy]=0;
				if (Area.displacementrange > 0 && displacementstrength > 0 && absgrid[xx][yy] != PROP && markgrid[xx][yy] != PATHER_ENDPOINT && markgrid[xx][yy] != PATHER_STARTPOINT && markgrid[xx][yy] != PATHER_ENDPOINT_SPECIAL && markgrid[xx][yy] != PATHER_STARTPOINT_SPECIAL && markgrid[xx][yy] != PATHER_MIDPOINT && markgrid[xx][yy] != PATHER_MIDPOINT2 && markgrid[xx][yy] != PATHER_MIDPOINT3 && (Area.gamemode != "pl" || gamegrid[xx][yy].size() <= 0)) displacegrid[xx][yy] = irandom(Area.displacementrange);
			}
		}
	}
	
	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){
			if (displacegrid[xx][yy]>0){
				if ((displacegrid[xx+1][yy]<0 && absgrid[xx+1][yy] != WALL) || (displacegrid[xx-1][yy]<0 && absgrid[xx-1][yy] != WALL) || (displacegrid[xx][yy+1]<0 && absgrid[xx][yy+1] != WALL) || (displacegrid[xx][yy-1]<0 && absgrid[xx][yy-1] != WALL)){
					displacegrid[xx][yy]=0;
				}
			}
		}
	}
	
	cout << "generating extragrid..." << endl;
	
	LevelSettings FreeArea = LevelSettings();
	FreeArea.num_pathers = 4;
	FreeArea.displacementrange = 0;
	FreeArea.pather_loop = 40 + irandom(10);
	FreeArea.odds = irandom(2) + 3;
	FreeArea.spawnsecretmin = 1;
	FreeArea.spawnsecretmax = FreeArea.num_pathers;
	FreeArea.room_start_odds = 100;
	FreeArea.room_end_odds = 100;
	FreeArea.room_turn_odds = 100;
	FreeArea.wall_thickness = 1;
	
	cout << endl;
	cout << "analyzing extragrid..." << endl;
	vector<vector<Tile> > extragrid;
	if (Area.burrowers > 0 && usingburrowers){
		extragrid = GetFreeGrid(FreeArea);
	} else {
		extragrid = tilegrid;
	}
	vector<vector<int> > extraconsist = vector<vector<int> >();
	vector<int> extraconsistcombined = vector<int>();
	vector<bool> extraquadiscombined = vector<bool>();
	vector<int> extraquadisvalid = vector<int>();
	vector<vector<vector<int> > > extraquadmap = vector<vector<vector<int> > >();
	vector<vector<vector<int> > > extracoordlist = vector<vector<vector<int> > >();
	vector<vector<int> > extracoordlistcombined = vector<vector<int> >();
	for (int i=0; i<FreeArea.num_pathers; i++){
		extraquadiscombined.push_back(false);
		extraquadisvalid.push_back(0);
		extracoordlist.push_back(vector<vector<int> >());
		//extracoordlistcombined.push_back(vector<int>());
		extraconsist.push_back(vector<int>());
		extraquadmap.push_back(vector<vector<int> >());
	}
	cout << "analyzing extragrid (2)..." << endl;
	for (int yy = 0; yy < height; yy++){
		for (int xx = 0; xx < width; xx++){
			//cout << xx << "," << yy << endl;
			if (extragrid[xx][yy].GetTileID() % 100 == PATHER_ENDPOINT || extragrid[xx][yy].GetTileID() % 100 == PATHER_STARTPOINT || extragrid[xx][yy].GetTileID() % 100 == PATHER_STARTPOINT_SPECIAL || extragrid[xx][yy].GetTileID() % 100 == PATHER_ENDPOINT_SPECIAL) {
				//cout << 1 << endl;
				int quad = extragrid[xx][yy].GetTileID() / 100;
				if (quad < FreeArea.num_pathers){
					//cout << "q " << quad << endl;
					extracoordlist[quad].push_back(vector<int>());
					extracoordlist[quad].back().push_back(xx);
					extracoordlist[quad].back().push_back(yy);
					//cout << 2 << endl;
					
					if (absgrid[xx][yy] == VOID){
						extraconsist[quad].push_back(0);
						if (extragrid[xx][yy].GetTileID() % 100 == PATHER_ENDPOINT || extragrid[xx][yy].GetTileID() % 100 == PATHER_STARTPOINT){
							extraconsistcombined.push_back(0);
							extraquadiscombined[quad]=true;
							extracoordlistcombined.push_back(vector<int>());
							extracoordlistcombined.back().push_back(xx);
							extracoordlistcombined.back().push_back(yy);
						}
					} else if (absgrid[xx][yy] == WALL){
						extraconsist[quad].push_back(1);
						if (extragrid[xx][yy].GetTileID() % 100 == PATHER_ENDPOINT || extragrid[xx][yy].GetTileID() % 100 == PATHER_STARTPOINT){
							extraconsistcombined.push_back(1);
							extraquadiscombined[quad]=true;
							extracoordlistcombined.push_back(vector<int>());
							extracoordlistcombined.back().push_back(xx);
							extracoordlistcombined.back().push_back(yy);
						}
					} else {
						extraconsist[quad].push_back(-1);
						if (extragrid[xx][yy].GetTileID() % 100 == PATHER_ENDPOINT || extragrid[xx][yy].GetTileID() % 100 == PATHER_STARTPOINT){
							extraconsistcombined.push_back(-1);
							extraquadiscombined[quad]=true;
							extracoordlistcombined.push_back(vector<int>());
							extracoordlistcombined.back().push_back(xx);
							extracoordlistcombined.back().push_back(yy);
						}
					}
					//cout << 3 << endl;
				}
			}
		}
	}
	
	cout << "checking for valid extragrid paths..." << endl;
	
	for (int i=0; i<FreeArea.num_pathers; i++){
		int v=0;
		int o=0;
		int b=0;
		vector<vector<vector<int> > > overcoords = vector<vector<vector<int> > >();
		overcoords.push_back(vector<vector<int> >());
		overcoords.push_back(vector<vector<int> >());
		cout << "started quad " << i << endl;
		if (extraquadiscombined[i]){
			cout << "combined" << endl;
			for (int j=0; j<extraconsistcombined.size(); j++){
				if (extraconsistcombined[j]==0){
					v++;
				}
				if (extraconsistcombined[j]==1){
					o++;
					overcoords[1].push_back(extracoordlistcombined[j]);
				}
				if (extraconsistcombined[j]==-1){
					b++;
					overcoords[0].push_back(extracoordlistcombined[j]);
				}
			}
		} else {
			cout << "secret" << endl;
			for (int j=0; j<extraconsist[i].size(); j++){
				if (extraconsist[i][j]==0){
					v++;
				}
				if (extraconsist[i][j]==1){
					o++;
					overcoords[1].push_back(extracoordlist[i][j]);
				}
				if (extraconsist[i][j]==-1){
					b++;
					overcoords[0].push_back(extracoordlist[i][j]);
				}
			}
		}
		cout << "quad " << i << " gave " << v << "," << b << "," << o << endl;
		if (irandom(3)==0){
			if (extraquadisvalid[i] == 0 && b > 1){
				cout << -1 << endl;
				extraquadisvalid[i] = -1;
			}
			if (extraquadisvalid[i] == 0 && o > 1){
				cout << 1 << endl;
				bool gotem=(overcoords[1].size()>1);
				for (int k=0; k<overcoords[1].size()-1; k++){
					int dist = checkoverpath(overcoords[1][k][0], overcoords[1][k][1], overcoords[1][k+1][0], overcoords[1][k+1][1], absgrid, extragrid, inoutgrid);
					cout << dist << " for quad " << i << endl;
					if (dist < 0) gotem = false;
				}
				
				if (gotem)
					extraquadisvalid[i] = 1;
			}
		} else {
			if (extraquadisvalid[i] == 0 && o > 1){
				cout << 1 << endl;
				bool gotem=(overcoords[1].size()>1);
				for (int k=0; k<overcoords[1].size()-1; k++){
					int dist = checkoverpath(overcoords[1][k][0], overcoords[1][k][1], overcoords[1][k+1][0], overcoords[1][k+1][1], absgrid, extragrid, inoutgrid);
					cout << dist << " for quad " << i << endl;
					if (dist < 0) gotem = false;
				}
				
				if (gotem)
					extraquadisvalid[i] = 1;
			}
			if (extraquadisvalid[i] == 0 && b > 1){
				cout << -1 << endl;
				extraquadisvalid[i] = -1;
			}
		}
		if(extraquadisvalid[i] != 0){
			cout << "building quad map..." << endl;
			if (extraquadisvalid[i] == 1) extraquadmap[i] = getsearchgrid(overcoords[1][0][0], overcoords[1][0][1], extragrid);
			if (extraquadisvalid[i] == -1) extraquadmap[i] = getsearchgrid(overcoords[0][0][0], overcoords[0][0][1], extragrid);
			cout << "built quad map!" << endl;
		}
	}
	
	if (ATTEMPTS < MAXATTEMPTS && (totalsecrets>Area.spawnsecretmax || totalsecrets<Area.spawnsecretmin || numconnections<totalsecrets || issecret[0]==1)) return main(argc, argv); 
	else {
	// draw level from grid
	cout << "Plans completed succesfully!" << endl << "Building tile grid..." << endl;
		for (int yy = 0; yy < height; yy++){
			for (int xx = 0; xx < width; xx++){
				Tile tile=Tile(noone);
				
				if (grid[xx][yy] == FLOOR){
					tile = tile_add(grid, xx, yy);
					if (xx==0||yy==0||xx==width-1||yy==height-1){
						tile = Tile(WALL, xx, yy);
					}
				} else if (grid[xx][yy] == WALL){
					tile = tile_add(grid, xx, yy);//tile_add(bg_wall, 0, 0, CELL_WIDTH, CELL_HEIGHT, xx*CELL_WIDTH, yy*CELL_HEIGHT, 0);
				} else if (grid[xx][yy] == PROP_SINGLE){
					tile = tile_add(grid, xx, yy);//tile_add(bg_prop_tile_1, 0, 0, CELL_WIDTH, CELL_HEIGHT, xx*CELL_WIDTH, yy*CELL_HEIGHT, 0);
				} else if (grid[xx][yy] == PROP_SMALL){
					tile = tile_add(grid, xx, yy);//tile_add(bg_prop_tile_1, 0, 0, CELL_WIDTH, CELL_HEIGHT, xx*CELL_WIDTH, yy*CELL_HEIGHT, 0);
				} else if (grid[xx][yy] == SECRET_FLOOR){
					tile = tile_add(grid, xx, yy);//tile_add(bg_floor_secret, 0, 0, CELL_WIDTH, CELL_HEIGHT, xx*CELL_WIDTH, yy*CELL_HEIGHT, 0);
					if (xx==0||yy==0||xx==width-1||yy==height-1){
						tile = Tile(SECRET_WALL, xx, yy);
					}
					//tile_set_visible(tile, false);
					//hiddentiles[numhiddentiles]=tile;
					numhiddentiles++;
				} else if (grid[xx][yy] == SECRET_WALL){
					tile = tile_add(grid, xx, yy);//tile_add(bg_wall_secret, 0, 0, CELL_WIDTH, CELL_HEIGHT, xx*CELL_WIDTH, yy*CELL_HEIGHT, 0);
					//tile_set_visible(tile, false);
					//hiddentiles[numhiddentiles]=tile;
					numhiddentiles++;
				} else if (grid[xx][yy] == PROP_SINGLE_S){
					tile = tile_add(grid, xx, yy);//tile_add(bg_prop_tile_1s, 0, 0, CELL_WIDTH, CELL_HEIGHT, xx*CELL_WIDTH, yy*CELL_HEIGHT, 0);
					//tile_set_visible(tile, false);
					//hiddentiles[numhiddentiles]=tile;
					numhiddentiles++;
				} else if (grid[xx][yy] == SECRET_ENTRANCE){
					tile = tile_add(grid, xx, yy);//tile_add(bg_wall, 0, 0, CELL_WIDTH, CELL_HEIGHT, xx*CELL_WIDTH, yy*CELL_HEIGHT, 0);
					if (xx==0||yy==0||xx==width-1||yy==height-1){
						tile = Tile(SECRET_WALL, xx, yy);
					}
					//disguisedtiles[numdisguisedtiles]=tile;
					numdisguisedtiles ++;
				}
				if (overgrid[xx][yy]==ORIGIN_ROOMCENTER) tile = Tile(ORIGIN_ROOMCENTER, xx, yy);
				if (inoutgrid[xx][yy]==1) tile = Tile(INDOOR_ROOM, xx, yy);
				if (inoutgrid[xx][yy]==2 && (markgrid[xx][yy]==MARK_DEAD_END || markgrid[xx][yy]==PATHER_ENDPOINT || markgrid[xx][yy]==PATHER_STARTPOINT || markgrid[xx][yy]==PATHER_ENDPOINT_SPECIAL || markgrid[xx][yy]==PATHER_STARTPOINT_SPECIAL)) envirogrid[xx][yy].push_back(Tile(ENVIRO_INDOOR, xx, yy));
				if (markgrid[xx][yy]==MARK_DEAD_END) tile = Tile(MARK_DEAD_END, xx, yy);
				if (markgrid[xx][yy]==PATHER_ENDPOINT) tile = Tile(PATHER_ENDPOINT, xx, yy);
				if (markgrid[xx][yy]==PATHER_STARTPOINT) tile = Tile(PATHER_STARTPOINT, xx, yy);
				if (markgrid[xx][yy]==PATHER_ENDPOINT_SPECIAL) tile = Tile(PATHER_ENDPOINT_SPECIAL, xx, yy);
				if (markgrid[xx][yy]==PATHER_STARTPOINT_SPECIAL) tile = Tile(PATHER_STARTPOINT_SPECIAL, xx, yy);
				if (markgrid[xx][yy]>=PATHER_ENDPOINT) cout << markgrid[xx][yy] << " " << xx << " " << yy << endl;
				if (Area.burrowers > 0 && usingburrowers){
					//cout << "START E" << endl;
					bool usedextra = false;
					if (extragrid[xx][yy].GetTileID() % 100 == PATHER_ENDPOINT || extragrid[xx][yy].GetTileID() % 100 == PATHER_STARTPOINT || extragrid[xx][yy].GetTileID() % 100 == PATHER_STARTPOINT_SPECIAL || extragrid[xx][yy].GetTileID() % 100 == PATHER_ENDPOINT_SPECIAL) {
						//cout << "SPECIAL E" << endl;
						if (absgrid[xx][yy]!=VOID){
							if (absgrid[xx][yy]==WALL && extraquadisvalid[extragrid[xx][yy].GetTileID()/100] == 1){
								tile = Tile(OVERHEAD_ENTER, xx, yy);
								burrowtilegrid[1][xx][yy] = Tile(OVERHEAD_ENTER, xx, yy);
								displacegrid[xx][yy] = -1;
								usedextra = true;
							}
							if ((absgrid[xx][yy]==FLOOR || absgrid[xx][yy]==PROP) && extraquadisvalid[extragrid[xx][yy].GetTileID()/100] == -1){
								tile = Tile(BURROW_ENTER, xx, yy);
								burrowtilegrid[0][xx][yy] = Tile(BURROW_ENTER, xx, yy);
								displacegrid[xx][yy] = -1;
								usedextra = true;
								if (inoutgrid[xx][yy]>0) envirogrid[xx][yy].push_back(Tile(ENVIRO_INDOOR, xx, yy));
							}
						}
					} 
					if (!usedextra) {
						for (int i=0; i<FreeArea.num_pathers; i++){
							//cout << "NORMAL E" << endl;
							if (extraquadmap[i].size() > 0 && extraquadmap[i][xx][yy]>0){
								//cout << "VALID NORMAL E" << endl;
								if ((absgrid[xx][yy]==WALL || absgrid[xx][yy] == VOID || inoutgrid[xx][yy] > 0) && extraquadisvalid[i] == 1){
									if (extragrid[xx][yy].GetTileID() % 100 == PATHER_ENDPOINT || extragrid[xx][yy].GetTileID() % 100 == PATHER_STARTPOINT) {
										burrowtilegrid[1][xx][yy] = Tile(FLOOR, xx, yy);
									} else if (extragrid[xx][yy].GetTileID() % 100 == PATHER_STARTPOINT_SPECIAL || extragrid[xx][yy].GetTileID() % 100 == PATHER_ENDPOINT_SPECIAL) {
										burrowtilegrid[1][xx][yy] = Tile(SECRET_FLOOR, xx, yy);
									} else burrowtilegrid[1][xx][yy] = Tile(extragrid[xx][yy].GetTileID(), xx, yy);
								} else if (extraquadisvalid[i] == 1&&xx>0&&yy>0&&xx<width-1&&yy<height-1) {
									if (extragrid[xx+1][yy].GetTileID()==FLOOR || extragrid[xx-1][yy].GetTileID()==FLOOR || extragrid[xx][yy+1].GetTileID()==FLOOR || extragrid[xx][yy-1].GetTileID()==FLOOR) burrowtilegrid[1][xx][yy] = Tile(WALL, xx, yy);
									if (extragrid[xx+1][yy].GetTileID()==SECRET_FLOOR || extragrid[xx-1][yy].GetTileID()==SECRET_FLOOR || extragrid[xx][yy+1].GetTileID()==SECRET_FLOOR || extragrid[xx][yy-1].GetTileID()==SECRET_FLOOR) burrowtilegrid[1][xx][yy] = Tile(SECRET_WALL, xx, yy);
									
								}
								if (extraquadisvalid[i] == -1){
									if (extragrid[xx][yy].GetTileID() % 100 == PATHER_ENDPOINT || extragrid[xx][yy].GetTileID() % 100 == PATHER_STARTPOINT) {
										burrowtilegrid[0][xx][yy] = Tile(510, xx, yy);
									} else if (extragrid[xx][yy].GetTileID() % 100 == PATHER_STARTPOINT_SPECIAL || extragrid[xx][yy].GetTileID() % 100 == PATHER_ENDPOINT_SPECIAL) {
										burrowtilegrid[0][xx][yy] = Tile(510, xx, yy);
									} else burrowtilegrid[0][xx][yy] = Tile(extragrid[xx][yy].GetTileID(), xx, yy);
									if (extragrid[xx][yy].GetTileID() == VOID&&xx>0&&yy>0&&xx<width-1&&yy<height-1) {
										if (extragrid[xx+1][yy].GetTileID()==FLOOR || extragrid[xx-1][yy].GetTileID()==FLOOR || extragrid[xx][yy+1].GetTileID()==FLOOR || extragrid[xx][yy-1].GetTileID()==FLOOR) burrowtilegrid[0][xx][yy] = Tile(WALL, xx, yy);
										if (extragrid[xx+1][yy].GetTileID()==SECRET_FLOOR || extragrid[xx-1][yy].GetTileID()==SECRET_FLOOR || extragrid[xx][yy+1].GetTileID()==SECRET_FLOOR || extragrid[xx][yy-1].GetTileID()==SECRET_FLOOR) burrowtilegrid[0][xx][yy] = Tile(SECRET_WALL, xx, yy);
									}
								}
							}
						}
						if (!(xx>0&&yy>0&&xx<width-1&&yy<height-1)) {
							burrowtilegrid[0][xx][yy] = Tile(WALL, xx, yy);
							burrowtilegrid[1][xx][yy] = Tile(WALL, xx, yy);
						}
					}
					//cout << "END E" << endl;
				}
				if (tile.GetTileID()!=noone) {
					tilegrid[xx][yy]=tile;
					
					if (usetexturezones){
						if (theme == "g"){
							if (quadgrid[xx][yy] % 6 == 4){
								tilegrid[xx][yy].tfind.push_back("NATURE/DIRTGROUND004");
								tilegrid[xx][yy].treplace.push_back("NATURE/DIRTGROUND009");
							}
							else if (quadgrid[xx][yy] % 3 == 1){
								tilegrid[xx][yy].tfind.push_back("NATURE/DIRTGROUND004");
								tilegrid[xx][yy].treplace.push_back("NATURE/DIRTGROUND003");
							}
							else if (quadgrid[xx][yy] % 3 == 2){
								tilegrid[xx][yy].tfind.push_back("NATURE/DIRTGROUND004");
								tilegrid[xx][yy].treplace.push_back("NATURE/DIRTGROUND005");
							}
						}
					}
				}
				
				/*
				tile = NULL;
				if (quadgrid[xx][yy] == 0){
					tile = tile_add(quadgrid, xx, yy);//tile_add(bg_ul, 0, 0, CELL_WIDTH, CELL_HEIGHT, xx*CELL_WIDTH, yy*CELL_HEIGHT, 0);
				} else if (quadgrid[xx][yy] == 1){
					tile = tile_add(quadgrid, xx, yy);//tile_add(bg_ur, 0, 0, CELL_WIDTH, CELL_HEIGHT, xx*CELL_WIDTH, yy*CELL_HEIGHT, 0);
				} else if (quadgrid[xx][yy] == 2){
					tile = tile_add(quadgrid, xx, yy);//tile_add(bg_dl, 0, 0, CELL_WIDTH, CELL_HEIGHT, xx*CELL_WIDTH, yy*CELL_HEIGHT, 0);
				} else if (quadgrid[xx][yy] == 3){
					tile = tile_add(quadgrid, xx, yy);//tile_add(bg_dr, 0, 0, CELL_WIDTH, CELL_HEIGHT, xx*CELL_WIDTH, yy*CELL_HEIGHT, 0);
				} else if (quadgrid[xx][yy] == ORIGIN_EXTENDED){
					tile = tile_add(quadgrid, xx, yy);//tile_add(bg_extention_secret, 0, 0, CELL_WIDTH, CELL_HEIGHT, xx*CELL_WIDTH, yy*CELL_HEIGHT, 0);
				} else if (quadgrid[xx][yy] == ORIGIN_WALLMEET){
					tile = tile_add(quadgrid, xx, yy);//tile_add(bg_wallmarker, 0, 0, CELL_WIDTH, CELL_HEIGHT, xx*CELL_WIDTH, yy*CELL_HEIGHT, 0);
				} else if (quadgrid[xx][yy] == ORIGIN_EXTENDED_WALL){
					tile = tile_add(quadgrid, xx, yy);//tile_add(bg_reachmarker, 0, 0, CELL_WIDTH, CELL_HEIGHT, xx*CELL_WIDTH, yy*CELL_HEIGHT, 0);
				}  else if (quadgrid[xx][yy] == ORIGIN_DENIED){
					tile = tile_add(quadgrid, xx, yy);//tile_add(bg_denied, 0, 0, CELL_WIDTH, CELL_HEIGHT, xx*CELL_WIDTH, yy*CELL_HEIGHT, 0);
				} 
				
				if (tile!=NULL) tilequadgrid[xx][yy]=tile;
				*/
			}
		}
	}
	for (int yy = 0; yy < height; yy++){
		for (int xx = 0; xx < width; xx++){
			for (int i=0; i < gamegrid[xx][yy].size(); i++){
				gametilegrid[xx][yy].push_back(Tile((300+gamegrid[xx][yy][i]),xx,yy));
			}
		}
	}
	
	if (Area.gamemode == "arena"){
		cout << "counting spawnrooms..." << endl;
		vector<vector<int> > redspawns = vector<vector<int> >();
		vector<vector<int> > bluspawns = vector<vector<int> >();
		
		for (int yy = 0; yy < height; yy++){
			for (int xx = 0; xx < width; xx++){
				if (tilegrid[xx][yy].GetTileID() == PATHER_STARTPOINT){
					bluspawns.push_back(vector<int>());
					bluspawns.back().push_back(xx);
					bluspawns.back().push_back(yy);
				}
				if (tilegrid[xx][yy].GetTileID() == PATHER_ENDPOINT){
					redspawns.push_back(vector<int>());
					redspawns.back().push_back(xx);
					redspawns.back().push_back(yy);
				}
			}
		}
		
		if (redspawns.size() > bluspawns.size() + 1){
			cout << "converting red spawns (" << redspawns.size() << " > " << bluspawns.size() << ")..." << endl;
			for (int i=0; i<(redspawns.size()-bluspawns.size())/2; i++){
				cout << (redspawns.size()-i-1) << "/" << redspawns.size() << endl;
				tilegrid[redspawns[(redspawns.size()-i-1)][0]][redspawns[redspawns.size()-i-1][1]].SetupTileIdentity(PATHER_STARTPOINT);
			}
		} else if (bluspawns.size() > redspawns.size() + 1){
			cout << "converting blu spawns (" << bluspawns.size() << " > " << redspawns.size() << ")..." << endl;
			for (int i=0; i<(bluspawns.size()-redspawns.size())/2; i++){
				tilegrid[bluspawns[i][0]][bluspawns[i][1]].SetupTileIdentity(PATHER_ENDPOINT);
			}
		} else if (redspawns.size() + bluspawns.size() < 2 && ATTEMPTS < MAXATTEMPTS){
			cout << "not enough spawns detected!" << endl;
			return main(argc, argv);
		}
		
		if (redspawns.size() + bluspawns.size() > 2){
			cout << "eliminating excess spawn rooms..." << endl;
			vector<vector<int> > redspawns2 = vector<vector<int> >();
			vector<vector<int> > bluspawns2 = vector<vector<int> >();
			for (int yy = 0; yy < height; yy++){
				for (int xx = 0; xx < width; xx++){
					cout << tilegrid[xx][yy].ltr;
					if (tilegrid[xx][yy].GetTileID() == PATHER_STARTPOINT){
						bluspawns2.push_back(vector<int>());
						bluspawns2.back().push_back(xx);
						bluspawns2.back().push_back(yy);
					}
					if (tilegrid[xx][yy].GetTileID() == PATHER_ENDPOINT){
						redspawns2.push_back(vector<int>());
						redspawns2.back().push_back(xx);
						redspawns2.back().push_back(yy);
					}
				}
				cout << endl;
			}
			if (bluspawns2.size() > 1){
				for (int i=0; i<bluspawns2.size()-1; i++){
					tilegrid[bluspawns2[i][0]][bluspawns2[i][1]].SetupTileIdentity(FLOOR);
					cout << "eliminated blue spawn " << i << endl;
				}
			}
			if (redspawns2.size() > 1){
				for (int i=redspawns2.size()-1; i>0; i--){
					tilegrid[redspawns2[i][0]][redspawns2[i][1]].SetupTileIdentity(FLOOR);
					cout << "eliminated red spawn " << i << endl;
				}
			}
		}
	}
	
	if (Area.gamemode == "ctfALT"){
		cout << "counting spawnrooms..." << endl;
		vector<vector<int> > redspawns = vector<vector<int> >();
		vector<vector<int> > bluspawns = vector<vector<int> >();
		
		for (int yy = 0; yy < height; yy++){
			for (int xx = 0; xx < width; xx++){
				if (tilegrid[xx][yy].GetTileID() == PATHER_STARTPOINT){
					bluspawns.push_back(vector<int>());
					bluspawns.back().push_back(xx);
					bluspawns.back().push_back(yy);
				}
				if (tilegrid[xx][yy].GetTileID() == PATHER_ENDPOINT){
					redspawns.push_back(vector<int>());
					redspawns.back().push_back(xx);
					redspawns.back().push_back(yy);
				}
			}
		}
		
		if (redspawns.size() > bluspawns.size() + 1){
			cout << "converting red spawns (" << redspawns.size() << " > " << bluspawns.size() << ")..." << endl;
			for (int i=0; i<(redspawns.size()-bluspawns.size())/2; i++){
				cout << (redspawns.size()-i-1) << "/" << redspawns.size() << endl;
				tilegrid[redspawns[(redspawns.size()-i-1)][0]][redspawns[redspawns.size()-i-1][1]].SetupTileIdentity(PATHER_STARTPOINT);
			}
		} else if (bluspawns.size() > redspawns.size() + 1){
			cout << "converting blu spawns (" << bluspawns.size() << " > " << redspawns.size() << ")..." << endl;
			for (int i=0; i<(bluspawns.size()-redspawns.size())/2; i++){
				tilegrid[bluspawns[i][0]][bluspawns[i][1]].SetupTileIdentity(PATHER_ENDPOINT);
			}
		} else if (redspawns.size() + bluspawns.size() < 4 && ATTEMPTS < MAXATTEMPTS){
			cout << "not enough spawns detected!" << endl;
			return main(argc, argv);
		}
		
		if (redspawns.size() + bluspawns.size() >= 4){
			cout << "placing flags and eliminating excess spawn rooms..." << endl;
			vector<vector<int> > redspawns2 = vector<vector<int> >();
			vector<vector<int> > bluspawns2 = vector<vector<int> >();
			for (int yy = 0; yy < height; yy++){
				for (int xx = 0; xx < width; xx++){
					cout << tilegrid[xx][yy].ltr;
					if (tilegrid[xx][yy].GetTileID() == PATHER_STARTPOINT){
						bluspawns2.push_back(vector<int>());
						bluspawns2.back().push_back(xx);
						bluspawns2.back().push_back(yy);
					}
					if (tilegrid[xx][yy].GetTileID() == PATHER_ENDPOINT){
						redspawns2.push_back(vector<int>());
						redspawns2.back().push_back(xx);
						redspawns2.back().push_back(yy);
					}
				}
				cout << endl;
			}
			if (bluspawns2.size() > 2){
				for (int i=0; i<bluspawns2.size()-2; i++){
					tilegrid[bluspawns2[i][0]][bluspawns2[i][1]].SetupTileIdentity(FLOOR);
					cout << "eliminated blue spawn " << i << endl;
				}
			}
			if (redspawns2.size() > 2){
				for (int i=redspawns2.size()-1; i>1; i--){
					tilegrid[redspawns2[i][0]][redspawns2[i][1]].SetupTileIdentity(FLOOR);
					cout << "eliminated red spawn " << i << endl;
				}
			}
			cout << "blue dist = " << minpath(bluspawns2[bluspawns2.size()-1][0], bluspawns2[bluspawns2.size()-1][1], bluspawns2[bluspawns2.size()-2][0], bluspawns2[bluspawns2.size()-2][1], absgrid) << endl;
			cout << "red dist = " << minpath(redspawns2[0][0], redspawns2[0][1], redspawns2[1][0], redspawns2[1][1], absgrid) << endl;
			int ddif = (int)((float)minpath(bluspawns2[bluspawns2.size()-1][0], bluspawns2[bluspawns2.size()-1][1], bluspawns2[bluspawns2.size()-2][0], bluspawns2[bluspawns2.size()-2][1], absgrid) - (float)minpath(redspawns2[0][0], redspawns2[0][1], redspawns2[1][0], redspawns2[1][1], absgrid));
			
			//ddif /= (((float)minpath(bluspawns2[bluspawns2.size()-1][0], bluspawns2[bluspawns2.size()-1][1], bluspawns2[bluspawns2.size()-2][0], bluspawns2[bluspawns2.size()-2][1], absgrid) + (float)minpath(redspawns2[0][0], redspawns2[0][1], redspawns2[1][0], redspawns2[1][1], absgrid))/2);
			cout << "total dist = " << ddif << endl;
			
			int ddif2 = (int)((float)minpath(bluspawns2[bluspawns2.size()-1][0], bluspawns2[bluspawns2.size()-1][1], redspawns2[1][0], redspawns2[1][1], absgrid) - (float)minpath(redspawns2[0][0], redspawns2[0][1], bluspawns2[bluspawns2.size()-2][0], bluspawns2[bluspawns2.size()-2][1], absgrid));
			
			//ddif2 /= (((float)minpath(bluspawns2[bluspawns2.size()-1][0], bluspawns2[bluspawns2.size()-1][1], redspawns2[1][0], redspawns2[1][1], absgrid) + (float)minpath(redspawns2[0][0], redspawns2[0][1], bluspawns2[bluspawns2.size()-2][0], bluspawns2[bluspawns2.size()-2][1], absgrid))/2);
			cout << "total dist 2 = " << ddif2 << endl;
			
			
			int ddif3 = ddif2 + ddif;
			if (ddif3 < 0) ddif *= -1;
			
			if (ddif < 0) ddif *= -1;
			if (ddif2 < 0) ddif2 *= -1;
			
			if (ddif3 > 2 || ddif > 3 || ddif2 > 4 || minpath(bluspawns2[bluspawns2.size()-1][0], bluspawns2[bluspawns2.size()-1][1], bluspawns2[bluspawns2.size()-2][0], bluspawns2[bluspawns2.size()-2][1], absgrid) <= 4 ||  minpath(redspawns2[0][0], redspawns2[0][1], redspawns2[1][0], redspawns2[1][1], absgrid) <= 4){
				if (ATTEMPTS < MAXATTEMPTS){
					cout << "distances between spawns and objectives determined to be too little or too different!" << endl << endl << endl;
					return main(argc, argv);
				} else {
					cout << "max attempts" << endl;
				}
			}
			tilegrid[bluspawns2[bluspawns2.size()-2][0]][bluspawns2[bluspawns2.size()-2][1]].SetupTileIdentity(PATHER_ENDPOINT_SPECIAL);
			tilegrid[redspawns2[1][0]][redspawns2[1][1]].SetupTileIdentity(PATHER_STARTPOINT_SPECIAL);
			
			if (doLoS){
				if (bluspawns2[bluspawns2.size()-1][0] == bluspawns2[bluspawns2.size()-2][0] || bluspawns2[bluspawns2.size()-1][1] == bluspawns2[bluspawns2.size()-2][1]){
					int result = checkLoS(bluspawns2[bluspawns2.size()-1][0], bluspawns2[bluspawns2.size()-1][1], bluspawns2[bluspawns2.size()-2][0], bluspawns2[bluspawns2.size()-2][1], absgrid);
					if (result > 0) {
						cout << "Blue spawn has LoS on blue objective!" << endl << endl << endl;
						if (ATTEMPTS < MAXATTEMPTS) return main(argc, argv);
					}
				}
				if (redspawns2[0][0] == redspawns2[1][0] || redspawns2[0][1] == redspawns2[1][1]){
					int result = checkLoS(redspawns2[0][0], redspawns2[0][1], redspawns2[1][0], redspawns2[1][1], absgrid);
					if (result > 0) {
						cout << "Red spawn has LoS on red objective!" << endl << endl << endl;
						if (ATTEMPTS < MAXATTEMPTS) return main(argc, argv);
					}
				}
			}
			
		}
	}
	
	vector<vector<int> > nextquadgrid = vector<vector<int> >();
	ds_grid_set_region(nextquadgrid, 0, 0, width, height, -1);
	int newpaths = removeuseless + Area.num_pathers;
	
	
	if (removeuseless>-1) {
		cout << "removing useless areas" << endl;
		bool searching = true;
		vector<vector<vector<int> > > searchgrid = vector<vector<vector<int> > >();
		vector<int> quadcount = vector<int>();
		vector<vector<bool> > connectsto = vector<vector<bool> >();
		ds_grid_set_region(connectsto, 0, 0, newpaths+1, newpaths+1, false);
		int quadtotal = 0;
		int txyq = xy_pathers + removeuseless * ((float)xy_pathers/(float)pathers);
		vector<int> quadrank = vector<int>();
		for (int i=0; i<newpaths; i++){
			quadrank.push_back(0);
			searchgrid.push_back(vector<vector<int> >());
			quadcount.push_back(0);
			ds_grid_set_region(searchgrid[i], 0, 0, width+1, height+1, -1);
			float fx = (float)width / (float)(txyq*2);
			float fy = (float)height / (float)(txyq*2);
			int gx = i % txyq;
			int gy = (int)(i/txyq);
			cx = (int)(fx * (float)(gx*2+1));
			cy = (int)(fy * (float)(gy*2+1));
			if (tilegrid[cx][cy].GetTileID() != VOID && !removebydoors){
				nextquadgrid[cx][cy]=i;
				searchgrid[i][cx][cy]=2;
			}
		}
		cout << "searching..." << endl;
		if (removebydoors){
			for (int i=0; i<newpaths; i++){
				bool started = false;
				searching = true;
				while (searching){
					searching = false;
					for (int x=1; x<width-1; x++){
						for (int y=1; y<height-1; y++){
							cout << i << "-" << x << "-" << y << endl;
							if (searchgrid[i][x][y]<0&&absgrid[x][y]==FLOOR&&nextquadgrid[x][y]<0){
								if (!started || (
								(searchgrid[i][x+1][y]==2 && inoutgrid[x+1][y]==inoutgrid[x][y])
								||(searchgrid[i][x-1][y]==2 && inoutgrid[x-1][y]==inoutgrid[x][y])
								|| (searchgrid[i][x][y+1]==2 && inoutgrid[x][y+1]==inoutgrid[x][y])
								|| (searchgrid[i][x][y-1]==2 && inoutgrid[x][y-1]==inoutgrid[x][y])
								)){
									searchgrid[i][x][y]=1;
									searching = true;
									started = true;
									//cout << tilegrid[x][y].GetTileID() << endl;
								}/* else if (r%2==0){
									if (searchgrid[i][x+1][y+1]==2||searchgrid[i][x-1][y-1]==2||searchgrid[i][x-1][y+1]==2||searchgrid[i][x+1][y-1]==2){
										searchgrid[i][x][y]=1;
									}
								}*/
							}
						}
					}
					for (int y=1; y<height-1; y++){
						for (int x=1; x<width-1; x++){
							if (searchgrid[i][x][y]==1&&nextquadgrid[x][y]<0){
								searching = true;
								searchgrid[i][x][y]=2;
								nextquadgrid[x][y]=i;
								quadcount[i]++;
								quadtotal++;
								for (int j=0; j<newpaths; j++){
									if (!connectsto[i][j]&&j!=i&&(searchgrid[j][x+1][y]==2||searchgrid[j][x-1][y]==2||searchgrid[j][x][y+1]==2||searchgrid[j][x][y-1]==2)){
										connectsto[i][j]=true;
										connectsto[j][i]=true;
									}
								}
							}
						}
					}
				}
				//cout << quadtotal << endl;
			}
		} else {
			while (searching){
				searching = false;
				for (int i=0; i<newpaths; i++){
					for (int x=1; x<width-1; x++){
						for (int y=1; y<height-1; y++){
							if (searchgrid[i][x][y]<0&&absgrid[x][y]==FLOOR&&nextquadgrid[x][y]<0){
								if (searchgrid[i][x+1][y]==2||searchgrid[i][x-1][y]==2||searchgrid[i][x][y+1]==2||searchgrid[i][x][y-1]==2){
									searchgrid[i][x][y]=1;
									searching = true;
									//cout << tilegrid[x][y].GetTileID() << endl;
								}/* else if (r%2==0){
									if (searchgrid[i][x+1][y+1]==2||searchgrid[i][x-1][y-1]==2||searchgrid[i][x-1][y+1]==2||searchgrid[i][x+1][y-1]==2){
										searchgrid[i][x][y]=1;
									}
								}*/
							}
						}
					}
					for (int y=1; y<height-1; y++){
						for (int x=1; x<width-1; x++){
							if (searchgrid[i][x][y]==1&&nextquadgrid[x][y]<0){
								searching = true;
								if (irandom(5)==3){
									searchgrid[i][x][y]=2;
									nextquadgrid[x][y]=i;
									quadcount[i]++;
									quadtotal++;
									for (int j=0; j<newpaths; j++){
										if (!connectsto[i][j]&&j!=i&&(searchgrid[j][x+1][y]==2||searchgrid[j][x-1][y]==2||searchgrid[j][x][y+1]==2||searchgrid[j][x][y-1]==2)){
											connectsto[i][j]=true;
											connectsto[j][i]=true;
										}
									}
								}
							}
						}
					}
				}
				//cout << quadtotal << endl;
			}
		}
		
		cout << "counted " << quadtotal << " tiles" << endl;
		
		vector<int> connections = vector<int>();
		vector<bool> isgot = vector<bool>();
		vector<bool> istrue = vector<bool>();
		//for (int i=0; i<newpaths; i++){
			for (int i=0; i<newpaths; i++){
				connections.push_back(0);
				isgot.push_back(true);
				istrue.push_back(true);
				for (int yy = 1; yy < height-1 && isgot[i]; yy++){
					for (int xx = 1; xx < width-1 && isgot[i]; xx++){
						if (nextquadgrid[xx][yy]==i){
							if (tilegrid[xx][yy].GetTileID()==PATHER_ENDPOINT || tilegrid[xx][yy].GetTileID()==PATHER_ENDPOINT_SPECIAL || tilegrid[xx][yy].GetTileID()==PATHER_MIDPOINT || tilegrid[xx][yy].GetTileID()==PATHER_MIDPOINT2 || tilegrid[xx][yy].GetTileID()==PATHER_MIDPOINT3 || tilegrid[xx][yy].GetTileID()==PATHER_STARTPOINT || tilegrid[xx][yy].GetTileID()==PATHER_STARTPOINT_SPECIAL || tilegrid[xx][yy].GetTileID()==BURROW_ENTER || tilegrid[xx][yy].GetTileID()==BURROW_EXIT || tilegrid[xx][yy].GetTileID()==OVERHEAD_ENTER || tilegrid[xx][yy].GetTileID()==OVERHEAD_EXIT || (Area.gamemode == "pl" && gamegrid[xx][yy].size()>0)){
								isgot[i] = false;
								istrue[i] = false;
								quadrank[i] = newpaths*2+1;
								cout << i << " is true" << endl;
							}
						}
					}
				}
			}
			if (harshremove){
				for (int repeating=0; repeating<newpaths; repeating++){
					for (int i=0; i<newpaths; i++){
						for (int j=0; j<newpaths; j++){
							for (int k=0; k<newpaths; k++){
								if (!isgot[j] && !isgot[k] && j != k && j != i && k != i && !connectsto[j][k] && connectsto[i][j] && connectsto[i][k]){
									connectsto[j][k]=true;
									connectsto[k][j]=true;
									for (int l=0; l<newpaths; l++){
										if (connectsto[l][k]){
											connectsto[i][l]=true;
											connectsto[j][l]=true;
										}
										if (connectsto[l][j]){
											connectsto[i][l]=true;
											connectsto[k][l]=true;
										}
										if (connectsto[l][i]){
											connectsto[k][l]=true;
											connectsto[j][l]=true;
										}
									}
									if (!isgot[j]&&!isgot[k]){
										isgot[i]=false;
										quadrank[i]=newpaths*2;
									}
								}
							}
						}
					}
				}
			}
		//}
		bool cont = false;
		for (int i=0; i<newpaths; i++){
			for (int j=0; j<newpaths; j++){
				if (i!=j&&!istrue[i]&&!istrue[j]&&!connectsto[i][j]){
					cont = true;
				}
			}
		}
		cout << "cont = " << cont << endl;
		if (cont){
			for (int repeating=1; repeating<=newpaths; repeating++){
				for (int i=0; i<newpaths; i++){
					for (int j=0; j<newpaths; j++){
						if (!isgot[j]&&connectsto[i][j]){
							connections[i]++;
						}
					}
				}
				for (int i=0; i<newpaths; i++){
					if (isgot[i] && connections[i] > 1){
						isgot[i] = false;
						if (quadrank[i]<=0) quadrank[i] = newpaths*2 - repeating;
					}
				}
			}
		} else {
			for (int repeating=1; repeating<=newpaths; repeating++){
				for (int i=0; i<newpaths; i++){
					for (int j=0; j<newpaths; j++){
						if (!isgot[j]&&connectsto[i][j]){
							connections[i]++;
						}
					}
				}
				for (int i=0; i<newpaths; i++){
					if (quadrank[i] <= 0 && connections[i] > 1){
						//isgot[i] = false;
						quadrank[i] = newpaths*2 - repeating;
					}
				}
			}
		}
		for (int repeating=1; repeating<=newpaths; repeating++){
			for (int i=0; i<newpaths; i++){
				for (int j=0; j<newpaths; j++){
					if (!isgot[j]&&connectsto[i][j]){
						connections[i]++;
					}
				}
			}
			for (int i=0; i<newpaths; i++){
				if (quadrank[i] <= 0 && connections[i] >= 1){
					//isgot[i] = false;
					quadrank[i] = newpaths - repeating;
				}
			}
		}
		for (int rank = 0; rank < newpaths*2+1 && (minunremovedspace <= 0 || quadtotal > minunremovedspace); rank++){
			for (int i=0; i<newpaths && (minunremovedspace <= 0 || quadtotal > minunremovedspace); i++){
				if (isgot[i] && quadrank[i]==rank){
					for (int yy = 1; yy < height-1; yy++){
						for (int xx = 1; xx < width-1; xx++){
							if (nextquadgrid[xx][yy]==i){
								if ((nextquadgrid[xx+1][yy] != i && tilegrid[xx+1][yy].GetTileID() != VOID) || (nextquadgrid[xx-1][yy] != i && tilegrid[xx-1][yy].GetTileID() != VOID) || (nextquadgrid[xx][yy+1] != i && tilegrid[xx][yy+1].GetTileID() != VOID) || (nextquadgrid[xx][yy-1] != i && tilegrid[xx][yy-1].GetTileID() != VOID)){
									tilegrid[xx][yy].SetupTileIdentity(WALL);
									tilegrid[xx][yy].ltr = "▽";
								} else {
									tilegrid[xx][yy].SetupTileIdentity(VOID);
									tilegrid[xx][yy].ltr = "▽";
								}
							}
						}
					}
					quadtotal -= quadcount[i];
					cout << "reduced to " << quadtotal << endl;
				}
			}
		}
		if (maxunremovedspace > 0 && quadtotal > maxunremovedspace && ATTEMPTS < MAXATTEMPTS){
			cout << "failed due to too much space!" << endl << endl << endl;
			return main(argc, argv);
		}
			/*
			connections.push_back(0);
			for (int j=0; j<Area.num_pathers; j++){
				if (connectsto[i][j]){
					connections[i]++;
				}
			}
			cout << "area " << i << " has " << connections[i] << " connection(s)" << endl;
			if (connections[i] < 2){
				bool gotem = true;
				for (int yy = 1; yy < height-1 && gotem; yy++){
					for (int xx = 1; xx < width-1 && gotem; xx++){
						if (quadgrid[xx][yy]==i){
							if (tilegrid[xx][yy].GetTileID()==PATHER_ENDPOINT || tilegrid[xx][yy].GetTileID()==PATHER_ENDPOINT_SPECIAL || tilegrid[xx][yy].GetTileID()==PATHER_MIDPOINT || tilegrid[xx][yy].GetTileID()==PATHER_MIDPOINT2 || tilegrid[xx][yy].GetTileID()==PATHER_MIDPOINT3 || tilegrid[xx][yy].GetTileID()==PATHER_STARTPOINT || tilegrid[xx][yy].GetTileID()==PATHER_STARTPOINT_SPECIAL || tilegrid[xx][yy].GetTileID()==BURROW_ENTER || tilegrid[xx][yy].GetTileID()==BURROW_EXIT || tilegrid[xx][yy].GetTileID()==OVERHEAD_ENTER || tilegrid[xx][yy].GetTileID()==OVERHEAD_EXIT){
								gotem = false;
							}
						}
					}
				}
				if (gotem){
					for (int yy = 1; yy < height-1; yy++){
						for (int xx = 1; xx < width-1; xx++){
							if (quadgrid[xx][yy]==i){
								if ((quadgrid[xx+1][yy] != i && tilegrid[xx+1][yy].GetTileID() != VOID) || (quadgrid[xx-1][yy] != i && tilegrid[xx-1][yy].GetTileID() != VOID) || (quadgrid[xx][yy+1] != i && tilegrid[xx][yy+1].GetTileID() != VOID) || (quadgrid[xx][yy-1] != i && tilegrid[xx][yy-1].GetTileID() != VOID)){
									tilegrid[xx][yy].SetupTileIdentity(WALL);
								} else {
									tilegrid[xx][yy].SetupTileIdentity(VOID);
									tilegrid[xx][yy].ltr = "▽";
								}
							}
						}
					}
				}
			}
			*/
	}
	
	cout << "building displacements..." << endl;
	if(Area.displacementrange > 0){
		for (int yy = 1; yy < height-1; yy++){
			for (int xx = 1; xx < width-1; xx++)
				{tilegrid[xx][yy].dispinfo = vector<vector<int> >();
				for (int i=0; i<5; i++){
					tilegrid[xx][yy].dispinfo.push_back(vector<int>());
					for (int j=0; j<5; j++){
						tilegrid[xx][yy].dispinfo[i].push_back(displacegrid[xx][yy]);
					}
				}
				if (tilegrid[xx][yy].GetTileID() != VOID && displacegrid[xx][yy]>=0){
					
					if (xx < width / 2 && yy >= height / 2){
						for (int i=0; i<3; i++){
							for (int j=0; j<3; j++){
								tilegrid[xx][yy].dispinfo[i*2][j*2] = borderthing(displacegrid[xx][yy] * displacementstrength,displacegrid[xx+j-1][yy] * displacementstrength,displacegrid[xx][yy-i+1] * displacementstrength,displacegrid[xx+j-1][yy-i+1] * displacementstrength);
								//cout << i*2 << "," << j*2 << " = " << tilegrid[xx][yy].dispinfo[i*2][j*2] << endl;
							}
						}
						tilegrid[xx][yy].dispinfo[1][1]=tilegrid[xx][yy].dispinfo[4][4];
						tilegrid[xx][yy].dispinfo[4][4]=tilegrid[xx][yy].dispinfo[0][0];
						tilegrid[xx][yy].dispinfo[0][0]=tilegrid[xx][yy].dispinfo[1][1];
					} else if (xx >= width / 2 && yy >= height / 2){
						for (int i=0; i<3; i++){
							for (int j=0; j<3; j++){
								tilegrid[xx][yy].dispinfo[i*2][j*2] = borderthing(displacegrid[xx][yy] * displacementstrength,displacegrid[xx+j-1][yy] * displacementstrength,displacegrid[xx][yy+i-1] * displacementstrength,displacegrid[xx+j-1][yy+i-1] * displacementstrength);
								//cout << i*2 << "," << j*2 << " = " << tilegrid[xx][yy].dispinfo[i*2][j*2] << endl;
							}
						}
					} else if (xx >= width / 2 && yy < height / 2){
						for (int i=0; i<3; i++){
							for (int j=0; j<3; j++){
								tilegrid[xx][yy].dispinfo[i*2][j*2] = borderthing(displacegrid[xx][yy] * displacementstrength,displacegrid[xx-j+1][yy] * displacementstrength,displacegrid[xx][yy+i-1] * displacementstrength,displacegrid[xx-j+1][yy+i-1] * displacementstrength);
								//cout << i*2 << "," << j*2 << " = " << tilegrid[xx][yy].dispinfo[i*2][j*2] << endl;
							}
						}
						tilegrid[xx][yy].dispinfo[1][1]=tilegrid[xx][yy].dispinfo[4][4];
						tilegrid[xx][yy].dispinfo[4][4]=tilegrid[xx][yy].dispinfo[0][0];
						tilegrid[xx][yy].dispinfo[0][0]=tilegrid[xx][yy].dispinfo[1][1];
					} else {
						for (int i=0; i<3; i++){
							for (int j=0; j<3; j++){
								tilegrid[xx][yy].dispinfo[i*2][j*2] = borderthing(displacegrid[xx][yy] * displacementstrength,displacegrid[xx-j+1][yy] * displacementstrength,displacegrid[xx][yy-i+1] * displacementstrength,displacegrid[xx-j+1][yy-i+1] * displacementstrength);
								//cout << i*2 << "," << j*2 << " = " << tilegrid[xx][yy].dispinfo[i*2][j*2] << endl;
							}
						}
					}
					
					/*
					tilegrid[xx][yy].dispinfo[0][0] = borderthing(displacegrid[xx][yy] * displacementstrength,displacegrid[xx+2-1][yy] * displacementstrength,displacegrid[xx][yy-2+1] * displacementstrength,displacegrid[xx+2-1][yy-2+1] * displacementstrength);
					tilegrid[xx][yy].dispinfo[4][4] = borderthing(displacegrid[xx][yy] * displacementstrength,displacegrid[xx+0-1][yy] * displacementstrength,displacegrid[xx][yy-0+1] * displacementstrength,displacegrid[xx+0-1][yy-0+1] * displacementstrength);
					*/
					/*
					tilegrid[xx][yy].dispinfo[4][4] = borderthing(displacegrid[xx][yy] * displacementstrength,displacegrid[xx-1][yy] * displacementstrength,displacegrid[xx][yy+1] * displacementstrength,displacegrid[xx-1][yy+1] * displacementstrength);
					tilegrid[xx][yy].dispinfo[4][0] = borderthing(displacegrid[xx][yy] * displacementstrength,displacegrid[xx-1][yy] * displacementstrength,displacegrid[xx][yy-1] * displacementstrength,displacegrid[xx-1][yy-1] * displacementstrength);
					tilegrid[xx][yy].dispinfo[0][4] = borderthing(displacegrid[xx][yy] * displacementstrength,displacegrid[xx+1][yy] * displacementstrength,displacegrid[xx][yy+1] * displacementstrength,displacegrid[xx+1][yy+1] * displacementstrength);
					tilegrid[xx][yy].dispinfo[0][0] = borderthing(displacegrid[xx][yy] * displacementstrength,displacegrid[xx+1][yy] * displacementstrength,displacegrid[xx][yy-1] * displacementstrength,displacegrid[xx+1][yy-1] * displacementstrength);
					*/
					
					/*
					tilegrid[xx][yy].dispinfo[2][0] = borderthing(displacegrid[xx][yy],displacegrid[xx][yy],displacegrid[xx][yy-1],displacegrid[xx][yy-1]) * displacementstrength;
					tilegrid[xx][yy].dispinfo[0][2] = borderthing(displacegrid[xx][yy],displacegrid[xx-1][yy],displacegrid[xx][yy],displacegrid[xx-1][yy]) * displacementstrength;
					tilegrid[xx][yy].dispinfo[2][2] = borderthing(displacegrid[xx][yy],displacegrid[xx][yy],displacegrid[xx][yy],displacegrid[xx][yy]) * displacementstrength;
					tilegrid[xx][yy].dispinfo[4][2] = borderthing(displacegrid[xx][yy],displacegrid[xx+1][yy],displacegrid[xx][yy],displacegrid[xx+1][yy]) * displacementstrength;
					tilegrid[xx][yy].dispinfo[2][4] = borderthing(displacegrid[xx][yy],displacegrid[xx][yy],displacegrid[xx][yy+1],displacegrid[xx][yy+1]) * displacementstrength;
					*/
					
					tilegrid[xx][yy].dispinfo[2][0] = (tilegrid[xx][yy].dispinfo[4][0] + tilegrid[xx][yy].dispinfo[0][0]) / 2;
					tilegrid[xx][yy].dispinfo[0][2] = (tilegrid[xx][yy].dispinfo[0][4] + tilegrid[xx][yy].dispinfo[0][0]) / 2;
					tilegrid[xx][yy].dispinfo[2][4] = (tilegrid[xx][yy].dispinfo[4][4] + tilegrid[xx][yy].dispinfo[0][4]) / 2;
					tilegrid[xx][yy].dispinfo[4][2] = (tilegrid[xx][yy].dispinfo[4][4] + tilegrid[xx][yy].dispinfo[4][0]) / 2;
					
					
					//tilegrid[xx][yy].dispinfo[2][0] = borderthing(displacegrid[xx][yy] * displacementstrength, displacegrid[xx][yy-1] * displacementstrength);
					
					
					tilegrid[xx][yy].dispinfo[0][1] = (tilegrid[xx][yy].dispinfo[0][0] + tilegrid[xx][yy].dispinfo[0][2]) / 2;
					tilegrid[xx][yy].dispinfo[4][1] = (tilegrid[xx][yy].dispinfo[4][0] + tilegrid[xx][yy].dispinfo[4][2]) / 2;
					tilegrid[xx][yy].dispinfo[0][3] = (tilegrid[xx][yy].dispinfo[0][4] + tilegrid[xx][yy].dispinfo[0][2]) / 2;
					tilegrid[xx][yy].dispinfo[4][3] = (tilegrid[xx][yy].dispinfo[4][4] + tilegrid[xx][yy].dispinfo[4][2]) / 2;
					tilegrid[xx][yy].dispinfo[1][0] = (tilegrid[xx][yy].dispinfo[0][0] + tilegrid[xx][yy].dispinfo[2][0]) / 2;
					tilegrid[xx][yy].dispinfo[1][4] = (tilegrid[xx][yy].dispinfo[0][4] + tilegrid[xx][yy].dispinfo[2][4]) / 2;
					tilegrid[xx][yy].dispinfo[3][0] = (tilegrid[xx][yy].dispinfo[4][0] + tilegrid[xx][yy].dispinfo[2][0]) / 2;
					tilegrid[xx][yy].dispinfo[3][4] = (tilegrid[xx][yy].dispinfo[4][4] + tilegrid[xx][yy].dispinfo[2][4]) / 2;
					
					
					tilegrid[xx][yy].dispinfo[1][1] = (tilegrid[xx][yy].dispinfo[0][0] + tilegrid[xx][yy].dispinfo[2][2]) / 2;
					tilegrid[xx][yy].dispinfo[3][3] = (tilegrid[xx][yy].dispinfo[4][4] + tilegrid[xx][yy].dispinfo[2][2]) / 2;
					tilegrid[xx][yy].dispinfo[1][3] = (tilegrid[xx][yy].dispinfo[0][4] + tilegrid[xx][yy].dispinfo[2][2]) / 2;
					tilegrid[xx][yy].dispinfo[3][1] = (tilegrid[xx][yy].dispinfo[4][0] + tilegrid[xx][yy].dispinfo[2][2]) / 2;
					
					
					tilegrid[xx][yy].dispinfo[2][1] = (tilegrid[xx][yy].dispinfo[2][0] + tilegrid[xx][yy].dispinfo[2][2]) / 2;
					tilegrid[xx][yy].dispinfo[2][3] = (tilegrid[xx][yy].dispinfo[2][4] + tilegrid[xx][yy].dispinfo[2][2]) / 2;
					tilegrid[xx][yy].dispinfo[1][2] = (tilegrid[xx][yy].dispinfo[0][2] + tilegrid[xx][yy].dispinfo[2][2]) / 2;
					tilegrid[xx][yy].dispinfo[3][2] = (tilegrid[xx][yy].dispinfo[4][2] + tilegrid[xx][yy].dispinfo[2][2]) / 2;
					/*
					tilegrid[xx][yy].dispinfo[0][0] = borderthing(displacegrid[xx][yy],displacegrid[xx-1][yy],displacegrid[xx][yy-1],displacegrid[xx-1][yy-1]);
					tilegrid[xx][yy].dispinfo[2][0] = borderthing(displacegrid[xx][yy],displacegrid[xx][yy],displacegrid[xx][yy-1],displacegrid[xx][yy-1]);
					tilegrid[xx][yy].dispinfo[4][0] = borderthing(displacegrid[xx][yy],displacegrid[xx+1][yy],displacegrid[xx][yy-1],displacegrid[xx+1][yy-1]);
					tilegrid[xx][yy].dispinfo[0][2] = borderthing(displacegrid[xx][yy],displacegrid[xx-1][yy],displacegrid[xx][yy],displacegrid[xx-1][yy]);
					tilegrid[xx][yy].dispinfo[0][4] = borderthing(displacegrid[xx][yy],displacegrid[xx-1][yy],displacegrid[xx][yy+1],displacegrid[xx-1][yy+1]);
					tilegrid[xx][yy].dispinfo[2][2] = borderthing(displacegrid[xx][yy],displacegrid[xx][yy],displacegrid[xx][yy],displacegrid[xx][yy]);
					tilegrid[xx][yy].dispinfo[4][2] = borderthing(displacegrid[xx][yy],displacegrid[xx+1][yy],displacegrid[xx][yy],displacegrid[xx+1][yy]);
					tilegrid[xx][yy].dispinfo[2][4] = borderthing(displacegrid[xx][yy],displacegrid[xx][yy],displacegrid[xx][yy+1],displacegrid[xx][yy+1]);
					tilegrid[xx][yy].dispinfo[4][4] = borderthing(displacegrid[xx][yy],displacegrid[xx+1][yy],displacegrid[xx][yy+1],displacegrid[xx+1][yy+1]);
					*/
					
					if (tilegrid[xx][yy].GetTileID() == FLOOR || tilegrid[xx][yy].GetTileID() == SECRET_FLOOR || tilegrid[xx][yy].GetTileID() == SECRET_ENTRANCE){
						envirogrid[xx][yy].push_back(Tile(ENVIRO_OUTDOOR, xx, yy));
						envirogrid[xx][yy].back().dispinfo = tilegrid[xx][yy].dispinfo;
						
						
						if (usetexturezones){
							envirogrid[xx][yy].back().tfind = tilegrid[xx][yy].tfind;
							envirogrid[xx][yy].back().treplace = tilegrid[xx][yy].treplace;
						}
						
						//envirogrid[xx][yy].back().ltr = to_string(displacegrid[xx][yy]);
					}
				}
			}
		}
	}
	
	//cout << "gmcoords: " << gmx1 << " " << gmy1 << " " << gmx2 << " " << gmy2 << endl;
	cout<< "Complete!" << endl;
	/*
	cout << tilegrid[gmx1][gmy1].ltr << endl;
	cout << tilegrid[gmx2][gmy2].ltr << endl;
	cout << tilegrid[gmx3][gmy3].ltr << endl;
	cout << tilegrid[gmx4][gmy4].ltr << endl;
	cout << markgrid[gmx1][gmy1] << endl;
	cout << markgrid[gmx2][gmy2] << endl;
	cout << markgrid[gmx3][gmy3] << endl;
	cout << markgrid[gmx4][gmy4] << endl;
	*/
	if (Area.gamemode=="ctf"||Area.gamemode=="2cp"){
		tilegrid[gmx1][gmy1] = Tile(PATHER_STARTPOINT_SPECIAL, gmx1, gmy1);
		tilegrid[gmx2][gmy2] = Tile(PATHER_ENDPOINT_SPECIAL, gmx2, gmy2);
		tilegrid[gmx3][gmy3] = Tile(PATHER_STARTPOINT, gmx3, gmy3);
		tilegrid[gmx4][gmy4] = Tile(PATHER_ENDPOINT, gmx4, gmy4);
	} else if (Area.gamemode=="pl"){
		tilegrid[gmx1][gmy1] = Tile(PATHER_MIDPOINT, gmx1, gmy1);
		tilegrid[gmx2][gmy2] = Tile(PATHER_MIDPOINT2, gmx2, gmy2);
		tilegrid[gmx3][gmy3] = Tile(PATHER_MIDPOINT3, gmx3, gmy3);
		tilegrid[gmx1][gmy1].gdi = gmv1 + 300;
		tilegrid[gmx2][gmy2].gdi = gmv2 + 300;
		tilegrid[gmx3][gmy3].gdi = gmv3 + 300;
	}
	
	
	
	
	for (int y=0; y<height; y++){
		cout << endl;
		for (int x=0; x<width; x++){
			if (tilegrid[x][y].ltr == " " && hallgrid[x][y]>0){
				if (hallgrid[x][y]>1){
					switch(hallgrid[x][y]){
						case 3:
							tilegrid[x][y].SetupTileIdentity(803);
							break;
						case 4:
							tilegrid[x][y].SetupTileIdentity(804);
							break;
						case 5:
							tilegrid[x][y].SetupTileIdentity(805);
							break;
						case 2:
							tilegrid[x][y].SetupTileIdentity(802);
							break;
					}
				}
				else {
				int walker = pathergrid[x][y][PATH_UP]*500 + pathergrid[x][y][PATH_DOWN]*50 + pathergrid[x][y][PATH_RIGHT]*5 + pathergrid[x][y][PATH_LEFT]/2;
				switch(walker){
					case 11:
						tilegrid[x][y].SetupTileIdentity(500);
						break;
					case 1100:
						tilegrid[x][y].SetupTileIdentity(501);
						break;
					case 101:
						tilegrid[x][y].SetupTileIdentity(502);
						break;
					case 1010:
						tilegrid[x][y].SetupTileIdentity(503);
						break;
					case 110:
						tilegrid[x][y].SetupTileIdentity(504);
						break;
					case 1001:
						tilegrid[x][y].SetupTileIdentity(505);
						break;
					case 1011:
						tilegrid[x][y].SetupTileIdentity(506);
						break;
					case 111:
						tilegrid[x][y].SetupTileIdentity(507);
						break;
					case 1110:
						tilegrid[x][y].SetupTileIdentity(508);
						break;
					case 1101:
						tilegrid[x][y].SetupTileIdentity(509);
						break;
					case 1111:
						tilegrid[x][y].SetupTileIdentity(510);
						break;
					default:
						//cout << walker/5;
						tilegrid[x][y].ltr = "!";
						break;
					}
				}
			}
			cout << tilegrid[x][y].ltr;
		}
		
		cout << " | ";
		
		for (int xx=0; xx<width; xx++){
			if (displacegrid[xx][y] >= 0) cout << displacegrid[xx][y];
			else cout << " ";
		}
		
		cout << " | ";
		for (int xx=0; xx<width; xx++){
			if (quadgrid[xx][y] >= 0 && quadgrid[xx][y] <= 9) cout << quadgrid[xx][y];
			else if (quadgrid[xx][y] > 9) cout << "?";
			else cout << " ";
		}
		
		
	}
	
	if (removeuseless > -1) {
		for (int y=0; y<height; y++){
			cout << endl;
			for (int xx=0; xx<width; xx++){
				if (nextquadgrid[xx][y] >= 0 && nextquadgrid[xx][y] <= 9) cout << nextquadgrid[xx][y];
				else if (nextquadgrid[xx][y] > 9) cout << nextquadgrid[xx][y] % 10;
				else cout << " ";
			}
		}
	}
	
	cout << endl;
	if (Area.burrowers > 0 && usingburrowers){
		cout << endl;
		for (int y=0; y<height; y++){
			cout << endl;
			for (int x=0; x<width; x++){
				cout << burrowtilegrid[1][x][y].ltr;
			}
			cout << " | ";
			for (int xx=0; xx<width; xx++){
				cout << burrowtilegrid[0][xx][y].ltr;
			}
		}
	}
	/*
	for (int y=0; y<height; y++){
		cout << endl;
		for (int x=0; x<width; x++){
			cout << extragrid[y][x].ltr;
		}
	}
	*/
	/*
	for (int y=0; y<height; y++){
		cout << endl;
		for (int x=0; x<width; x++){
			cout << tilegrid[x][y].ltr;
		}
		cout << " | ";
		for (int xx=0; xx<width; xx++){
			if (quadgrid[xx][y] >= 0 && quadgrid[xx][y] <= 9) cout << quadgrid[xx][y];
			else if (quadgrid[xx][y] > 9) cout << "?";
			else cout << " ";
		}
	}
	*/
	cout << endl;
	string pin;
	cin >> pin;
	if (pin == "settings" || pin == "build"){
		cout << "spawnsecretmin=" << Area.spawnsecretmin << ";" << endl;
		cout << "spawnsecretmax=" << Area.spawnsecretmax << ";" << endl;
		cout << endl;
		cout << "odds=" << Area.odds << ";" << endl;
		cout << "num_pathers=" << Area.num_pathers << ";" << endl;
		cout << "pather_loop=" << Area.pather_loop << ";" << endl;
		cout << "pather_jump=" << Area.pather_jump << ";" << endl;
		cout << "use_jump=" << Area.use_jump << ";" << endl;
		cout << "pather_noturn_min=" << Area.pather_noturn_min << ";" << endl;
		cout << "pather_noturn_max=" << Area.pather_noturn_max << ";" << endl;
		cout << endl;
		cout << "room_start_odds=" << Area.room_start_odds << ";" << endl;
		cout << "room_end_odds=" << Area.room_end_odds << ";" << endl;
		cout << "room_turn_odds=" << Area.room_turn_odds << ";" << endl;
		cout << "room_x_max=" << Area.room_x_max << ";" << endl;
		cout << "room_y_max=" << Area.room_y_max << ";" << endl;
		cout << "allow_room_overlap=" << Area.allow_room_overlap << ";" << endl;
		cout << endl;
		cout << "fix_loop=" << Area.fix_loop << ";" << endl;
		cout << "fix_loop_secret_extender=" << Area.fix_loop_secret_extender << ";" << endl;
		cout << "fix_loop_by_tile=" << Area.fix_loop_by_tile << ";" << endl;
		cout << endl;
		cout << "wall_thickness=" << Area.wall_thickness << ";" << endl;
		cout << endl;
		cout << "detect_deadend=" << Area.detect_deadend << ";" << endl;
		cout << endl;
		cout << endl;
		cout << "single_remove_odds=" << Area.single_remove_odds << ";" << endl;
		cout << "single_prop_odds=" << Area.single_prop_odds << ";" << endl;
	}
	if (pin == "build"){
		BuildMap(tilegrid, gametilegrid, envirogrid, burrowtilegrid, Area);
	}
	
	
	
	return 0;
}
