#include <iostream>
#include <string>
#include <string.h>
#include <map>
#include <vector>
#include <cassert>
#include <cstdlib>
#include <math.h>

#include "util.cpp"

class Side{
	public:
		Side(){}
		Side(int p1, int p2, int p3, int p4, int p5, int p6, int p7, int p8, int p9,
		string m="DEV/DEV_MEASUREWALL01A", string uaxis="", string vaxis="", string rotation = "0", string lightmapscale="16", string smoothing_groups="0")
		vector<vector<float> > plane;
		string material;
		string uaxis;
		string vaxis;
		string rotation;
		string lightmapscale;
		string smoothing_groups;
};

class Solid{
	public:
		Solid(){}
		vector<Side> sides;
		void PrintOut(std::ostream& ostr, int& id, int x, int y) {
			ostr << "\tsolid" << endl << "\t{" << endl << "\t\t\"id\" \"" << id << "\"" << endl;
			for (int side=0; side < sides.size(); side++){
				id ++;
				ostr << "\t\tside" << endl << "\t\t{" << endl << "\t\t\t\"id\" \"" << id << "\"" << endl;
				ostr << "\t\t\t\"plane\" \"";
				for (int s=0; s<3; s++){
					ostr << "(";
					vector<int> pv = sides[side].plane[s];
					ostr << (pv[0]+x*CELL_WIDTH) << " " << (pv[1]+y*CELL_HEIGHT) << " " << pv[2] << ")";
					if (s < 2) ostr << " ";
				}
				ostr << "\"" << endl;
				ostr << "\t\t\t\"material\" \"" << sides[side].material << "\"" << endl;
				ostr << "\t\t\t\"uaxis\" \"" << sides[side].uaxis << "\"" << endl;
				ostr << "\t\t\t\"vaxis\" \"" << sides[side].vaxis << "\"" << endl;
				ostr << "\t\t\t\"rotation\" \"" << sides[side].rotation << "\"" << endl;
				ostr << "\t\t\t\"lightmapscale\" \"" << sides[side].lightmapscale << "\"" << endl;
				ostr << "\t\t\t\"smoothing_groups\" \"" << sides[side].smoothing_groups << "\"" << endl;
				ostr << "\t\t}" << endl;
			}
			
			
			
		}
};

