//cd C:/Users/Tobias/Google\ Drive/Maps/generation
//g++ main.cpp -o test.exe -Wall -g

#include <iostream>
#include <fstream>
#include <string>
#include <string.h>
#include <map>
#include <vector>
#include <cassert>
#include <cstdlib>
#include <math.h>
#include <time.h>

#include "tile.h"

int SUBATTEMPTS = 0;

void ds_grid_set_region(vector<vector<int> > &grid, int x1, int y1, int x2, int y2, int filler){
	while (grid.size() <= x2) grid.push_back(vector<int>());
	for (int x=x1; x<=x2; x++){
		while (grid[x].size() <= y2) grid[x].push_back(filler);
		for (int y=y1; y<=y2; y++){
			grid[x][y]=filler;
		}
	}
}
void ds_grid_set_region(vector<vector<Tile> > &grid, int x1, int y1, int x2, int y2, int filler){
	while (grid.size() <= x2) grid.push_back(vector<Tile>());
	for (int x=x1; x<=x2; x++){
		while (grid[x].size() <= y2) grid[x].push_back(Tile(filler));
		for (int y=y1; y<=y2; y++){
			grid[x][y]=Tile(filler, x, y);
		}
	}
}
void ds_grid_set_region(vector<vector<bool> > &grid, int x1, int y1, int x2, int y2, bool filler){
	while (grid.size() <= x2) grid.push_back(vector<bool>());
	for (int x=x1; x<=x2; x++){
		while (grid[x].size() <= y2) grid[x].push_back(filler);
		for (int y=y1; y<=y2; y++){
			grid[x][y]=filler;
		}
	}
}
Tile tile_add(vector<vector<int> > grid, int x, int y){
	return Tile(grid[x][y],x,y);
}

vector<vector<Tile> > GetFreeGrid(LevelSettings Area){
	
	SUBATTEMPTS++;
	
	// we need this for later
	int totalsecrets=0;

	int numhiddentiles=0;
	vector<Tile> hiddentiles= vector<Tile>();
	int numdisguisedtiles=0;
	vector<Tile> disguisedtiles= vector<Tile>();

	// the odds variable for changing direction
	int odds = Area.odds;

	// the number of pathers to use
	int pathers = Area.num_pathers;
	int xy_pathers = sqrt(pathers);
	/*
	//resize room
	int room_width = (CELL_WIDTH/16)*720;
	int room_height = (CELL_HEIGHT/16)*720;

	// set grid dimensions
	int width = room_width / CELL_WIDTH;
	int height = room_height / CELL_HEIGHT;
	*/
	cout << width << " " << height << endl;
	// set jump vars
	int maxjumps=Area.pather_jump;
	bool jumpy=Area.use_jump;
	
	cout<< "making grids..." << endl;
	
	// create grid
	vector<vector<int> > grid = vector<vector<int> >();
	vector<vector<int> > quadgrid = vector<vector<int> >();
	vector<vector<int> > absgrid = vector<vector<int> >();
	vector<vector<int> > congrid = vector<vector<int> >();
	vector<vector<int> > overgrid = vector<vector<int> >();
	vector<vector<int> > markgrid = vector<vector<int> >();
	vector<vector<vector<int> > > gamegrid = vector<vector<vector<int> > >();
	vector<int> issecret = vector<int>();
	vector<vector<Tile> > tilegrid = vector<vector<Tile> >();
	vector<vector<vector<Tile> > > gametilegrid = vector<vector<vector<Tile> > >();
	vector<vector<Tile> > tilequadgrid = vector<vector<Tile> >();
	vector<vector<vector<int> > > pathergrid = vector<vector<vector<int> > >();
	
	vector<vector<int> > inoutgrid = vector<vector<int> >();
	vector<vector<int> > displacegrid = vector<vector<int> >();
	vector<vector<int> > burrowgrid = vector<vector<int> >();
	vector<vector<vector<Tile> > > envirogrid = vector<vector<vector<Tile> > >();
	
	cout<< "filling grids..." << endl;
	// fill grid with void
	ds_grid_set_region(grid, 0, 0, width, height, VOID);
	ds_grid_set_region(absgrid, 0, 0, width, height, VOID);
	ds_grid_set_region(quadgrid, 0, 0, width, height, VOID);
	ds_grid_set_region(congrid, 0, 0, width, height, 0);
	ds_grid_set_region(overgrid, 0, 0, width, height, VOID);
	ds_grid_set_region(markgrid, 0, 0, width, height, VOID);
	cout<<"filling tile grids..."<<endl;
	ds_grid_set_region(tilegrid, 0, 0, width, height, noone);
	ds_grid_set_region(tilequadgrid, 0, 0, width, height, noone);
	ds_grid_set_region(inoutgrid, 0, 0, width, height, -1);
	ds_grid_set_region(displacegrid, 0, 0, width, height, -1);
	ds_grid_set_region(burrowgrid, 0, 0, width, height, VOID);
	for (int i=0; i <= pathers; i++){
		issecret.push_back(0);
	}
	while (pathergrid.size() <= width) pathergrid.push_back(vector<vector<int> >());
	for (int x=0; x<=width; x++){
		while (pathergrid[x].size() <= height) pathergrid[x].push_back(vector<int>());
		for (int y=0; y<=height; y++){
			while (pathergrid[x][y].size() <= 4) pathergrid[x][y].push_back(0);
		}
	}
	while (gamegrid.size() <= width) gamegrid.push_back(vector<vector<int> >());
	for (int x=0; x<=width; x++){
		while (gamegrid[x].size() <= height) gamegrid[x].push_back(vector<int>());
		for (int y=0; y<=height; y++){
			//while (gamegrid[x][y].size() <= 4) gamegrid[x][y].push_back(vector<int>());
		}
	}
	while (gametilegrid.size() <= width) gametilegrid.push_back(vector<vector<Tile> >());
	for (int x=0; x<=width; x++){
		while (gametilegrid[x].size() <= height) gametilegrid[x].push_back(vector<Tile>());
		for (int y=0; y<=height; y++){
			//while (gametilegrid[x][y].size() <= 4) gametilegrid[x][y].push_back(vector<Tile>());
		}
	}
	while (envirogrid.size() <= width) envirogrid.push_back(vector<vector<Tile> >());
	for (int x=0; x<=width; x++){
		while (envirogrid[x].size() <= height) envirogrid[x].push_back(vector<Tile>());
		for (int y=0; y<=height; y++){
			//while (envirogrid[x][y].size() <= 4) envirogrid[x][y].push_back(vector<Tile>());
		}
	}
	
	

	// randomize the world
	randomize();
	cout<< "setting up controller..." << endl;
	// create the controller in center of grid
	int cx = width / (xy_pathers*2);
	int cy = height / (xy_pathers*2);
	/*
	//create the player
	instance_create(cx*CELL_WIDTH+CELL_WIDTH/2, cy*CELL_HEIGHT+CELL_HEIGHT/2, obj_player1);
	*/
	// give the controller a random direction
	int cdir = irandom(3);
	// create the level using controllers ("pathers")
	int pp;
	int gmx1;
	int gmy1;
	int gmv1;
	int gmx2;
	int gmy2;
	int gmv2;
	int gmx3;
	int gmy3;
	int gmv3;
	int gmx4;
	int gmy4;
	int gmv4;
	int gmp=0;
	bool gms1=false;
	bool gms2=false;
	bool gms3=false;
	for (int p=0; p<pathers; p++){
		pp=p;
		cout<< "starting pather " << p << "..." << endl;
		cx = width / (xy_pathers*2);
		cy = height / (xy_pathers*2);
		int gx = p % xy_pathers;
		int gy = (int)(p/xy_pathers);
		cx *= gx*2+1;
		cy *= gy*2+1;
		int jumps=0;
		if (irandom(Area.room_start_odds)==Area.room_start_odds){
			int rx=irandom(Area.room_x_max-1)+1;
			int ry=irandom(Area.room_y_max-1)+1;
			overgrid[cx][cy] == ORIGIN_ROOMCENTER;
			for (int xx=cx-rx; xx<cx+rx+1; xx++){
				for (int yy=cy-ry; yy<cy+ry; yy++){
					if (xx > -1 && yy > -1 && xx < width && yy < height){
						grid[xx][yy]=FLOOR;
						if (quadgrid[xx][yy] == VOID) quadgrid[xx][yy] = pp;
						if (overgrid[xx][yy] != ORIGIN_ROOMCENTER) overgrid[xx][yy]=ORIGIN_ROOMGEN;
					}
				}
			}
		}
		if (groupspawns==1){
			if (cy > height/2) 
				if (markgrid[cx][cy] < PATHER_ENDPOINT) markgrid[cx][cy]=PATHER_STARTPOINT;
			else
				if (markgrid[cx][cy] < PATHER_ENDPOINT) markgrid[cx][cy]=PATHER_ENDPOINT;
		} else if (groupspawns==2){
			if (cx > width/2) 
				if (markgrid[cx][cy] < PATHER_ENDPOINT) markgrid[cx][cy]=PATHER_STARTPOINT;
			else
				if (markgrid[cx][cy] < PATHER_ENDPOINT) markgrid[cx][cy]=PATHER_ENDPOINT;
		}
		else if (markgrid[cx][cy] < PATHER_ENDPOINT) markgrid[cx][cy]=PATHER_STARTPOINT;
		if (p==0 && (Area.gamemode=="2cp"||Area.gamemode=="ctf")){
			markgrid[cx][cy] += 2;
			cout << markgrid[cx][cy] << endl;
			gmx1 = cx;
			gmy1 = cy;
			if (cy > height/2) 
				gms1 = true;
			else
				gms2 = true;
		} else if (p==0 && Area.gamemode=="pl"){
			markgrid[cx][cy]=PATHER_STARTPOINT_SPECIAL;
		}
		//cout << cx << " " << cy << endl;
		cout<< "beginning pather loop..." << endl;
		for (int repeating = 0; repeating < Area.pather_loop; repeating ++){
			//cout << repeating << endl;
			//place a floor tile at the controller position
			if (Area.gamemode=="pl"&&p==0){
				gmp++;
				
				if (!gms1 && repeating >= Area.pather_loop/4){
					gms1=true;
					gmx1=cx;
					gmy1=cy;
					gmv1=gmp;
				} else if (!gms2 && repeating >= Area.pather_loop/2){
					gms2=true;
					gmx2=cx;
					gmy2=cy;
					gmv2=gmp;
				} else if (!gms3 && repeating >= (Area.pather_loop*3)/4){
					gms3=true;
					gmx3=cx;
					gmy3=cy;
					gmv3=gmp;
				} else {
					gamegrid[cx][cy].push_back(gmp);
				}
			}
			if (!jumpy || grid[cx][cy]!=PLACEHOLDER) grid[cx][cy] = FLOOR;    //ds_grid_set(grid, cx, cy, FLOOR);
			if (jumpy && grid[cx][cy]==PLACEHOLDER){
				grid[cx][cy] = DROPTILE;
			}
			
			if (irandom(Area.room_turn_odds)==Area.room_turn_odds){
				//cout << "rr ";
				int rx=irandom(Area.room_x_max-1)+1;
				int ry=irandom(Area.room_y_max-1)+1;
				overgrid[cx][cy] == ORIGIN_ROOMCENTER;
				if (cx-rx-1 > -1 && cy-ry-1 > -1 && cx+rx+1 < width && cy+ry+1 < height){
					if (Area.allow_room_overlap || (
						overgrid[cx-rx][cy-ry]!=ORIGIN_ROOMGEN && overgrid[cx+rx][cy-ry]!=ORIGIN_ROOMGEN && overgrid[cx-rx][cy+ry]!=ORIGIN_ROOMGEN && overgrid[cx+rx][cy+ry]!=ORIGIN_ROOMGEN
						&& overgrid[cx-rx-1][cy-ry-1]!=ORIGIN_ROOMGEN && overgrid[cx+rx+1][cy-ry-1]!=ORIGIN_ROOMGEN && overgrid[cx-rx-1][cy+ry+1]!=ORIGIN_ROOMGEN && overgrid[cx+rx+1][cy+ry+1]!=ORIGIN_ROOMGEN
						&& overgrid[cx-rx-1][cy]!=ORIGIN_ROOMGEN && overgrid[cx+rx+1][cy]!=ORIGIN_ROOMGEN && overgrid[cx][cy+ry+1]!=ORIGIN_ROOMGEN && overgrid[cx][cy+ry-1]!=ORIGIN_ROOMGEN)){
							for (int xx=cx-rx; xx<cx+rx+1; xx++){
								for (int yy=cy-ry; yy<cy+ry; yy++){
									if (xx > -1 && yy > -1 && xx < width && yy < height){
										grid[xx][yy]=FLOOR;
										if (quadgrid[xx][yy] == VOID) quadgrid[xx][yy] = p;
										if (overgrid[xx][yy] != ORIGIN_ROOMCENTER) overgrid[xx][yy]=ORIGIN_ROOMGEN;
									}
								}
							}
						
					}
				}
			}
			if (quadgrid[cx][cy] == VOID) quadgrid[cx][cy] = p;
			//cout << "1" << endl;
			
			//randomize direction
			if (irandom(odds) == odds ){//|| jumps==maxjumps
				//cout << "od ";
				cdir = irandom(3);/*
				if (cdir==1 && jumps==maxjumps){
					while (cdir==1){
						cdir = irandom(3);
					}
				}*/
			}
			//cout << "2" << endl;
			if (jumpy && cdir==1){
				jumps ++;
			} else if (jumpy && grid[cx][cy+1]==VOID){
				jumps=0;
				grid[cx][cy+1]=PLACEHOLDER;
			}
			//cout << "3" << endl;
			//move controller
			int xdir = cos ((cdir*90)*M_PI/180);//lengthdir_x(1, cdir*90)
			int ydir = sin ((cdir*90)*M_PI/180);//lengthdir_y(1, cdir*90)
			/*
			if (p==1 && Area.gamemode=="2cp"){
				if (cy+ydir > height/2) ydir = ydir * -1;
			}
			if (p==2 && Area.gamemode=="2cp"){
				if (cy+ydir < height/2) ydir = ydir * -1;
			}
			*/
			pathergrid[cx][cy][cdir]=2;
			cx += xdir;
			cy += ydir;
			pathergrid[cx][cy][(cdir+2)%4]=2;
			//cout << "4" << endl;
			//make sure controller doesn't move outside the grid
			if (cx < 1) cx = 1;
			else if (cx > width-2) cx = width - 2;
			if (cy < 1) cy = 1;
			else if (cy > height-2) cy = height - 2;
			//cx = clamp(cx, 1, width-2);
			//cy = clamp(cy, 1, height-2);
		}
		cout << "finished pather loop..."<<endl;
		if (irandom(Area.room_end_odds)==Area.room_end_odds){
			int rx=irandom(Area.room_x_max-1)+1;
			int ry=irandom(Area.room_y_max-1)+1;
			overgrid[cx][cy] = ORIGIN_ROOMCENTER;
			for (int xx=cx-rx; xx<cx+rx+1; xx++){
				for (int yy=cy-ry; yy<cy+ry; yy++){
					if (xx > -1 && yy > -1 && xx < width && yy < height){
						grid[xx][yy]=FLOOR;
						if (quadgrid[xx][yy] == VOID) quadgrid[xx][yy] = pp;
						if (overgrid[xx][yy] != ORIGIN_ROOMCENTER) overgrid[xx][yy]=ORIGIN_ROOMGEN;
					}
				}
			}
		}
		if (groupspawns==1){
			if (cy > height/2) 
				if (markgrid[cx][cy] < PATHER_ENDPOINT) markgrid[cx][cy]=PATHER_STARTPOINT;
			else
				if (markgrid[cx][cy] < PATHER_ENDPOINT) markgrid[cx][cy]=PATHER_ENDPOINT;
		} else if (groupspawns==2){
			if (cx > width/2) 
				if (markgrid[cx][cy] < PATHER_ENDPOINT) markgrid[cx][cy]=PATHER_STARTPOINT;
			else
				if (markgrid[cx][cy] < PATHER_ENDPOINT) markgrid[cx][cy]=PATHER_ENDPOINT;
		}
		else markgrid[cx][cy]=PATHER_ENDPOINT;
		if (p==0 && (Area.gamemode=="2cp"||Area.gamemode=="ctf")){
			markgrid[cx][cy] += 2;
			gmx2 = cx;
			gmy2 = cy;
			if (cy > height/2 && gms1){
				cout << "restarting for 2cp point things " << cy << " " << gmx1 << endl;
				return GetFreeGrid(Area);
			}
			else if (cy < height/2 && gms2){
				cout << "restarting for 2cp point things " << cy << " " << gmx1 << endl;
				return GetFreeGrid(Area);
			}
		} else if (p==0 && Area.gamemode=="pl"){
			markgrid[cx][cy]=PATHER_ENDPOINT_SPECIAL;
		}
		if (p==1 && (Area.gamemode=="2cp"||Area.gamemode=="ctf")){
			gmx3 = cx;
			gmy3 = cy;
		}
		if (p==2 && (Area.gamemode=="2cp"||Area.gamemode=="ctf")){
			gmx4 = cx;
			gmy4 = cy;
		}
	}
	cout << "finished pathers!" << endl;

	/*
	if (Area.gamemode!="2cp"&&Area.gamemode!="ctf"){
		if (noplloops==2){
		cout << "fixing up silly cart paths" << endl;
			for (int x=0; x<width; x++){
				for (int y=0; y<height; y++){
					if (gamegrid[x][y].size()>1){
						int kos = gamegrid[x][y][0]+1;
						int kosc = gamegrid[x][y][1]-gamegrid[x][y][0];
						if ((kos < gmv1+1+kosc || kos > gmv1-1-kosc)
							&&(kos < gmv2+1+kosc || kos > gmv2-1-kosc)
							&&(kos < gmv3+1+kosc || kos > gmv3-1-kosc)
							&&(kos > 1+kosc)
						){
							cout << ".";
							for (int xx=0; xx<width; xx++){
								for (int yy=0; yy<height; yy++){
									for (int ii=0; ii<gamegrid[xx][yy].size(); ii++){
										if (gamegrid[xx][yy][ii]>=kos&&gamegrid[xx][yy][ii]<=kos+kosc-1){
											gamegrid[xx][yy].erase(gamegrid[xx][yy].begin()+ii);
										}
									}
								}
							}
							for (int xx=0; xx<width; xx++){
								for (int yy=0; yy<height; yy++){
									for (int ii=0; ii<gamegrid[xx][yy].size(); ii++){
										if (gamegrid[xx][yy][ii]>kos){
											gamegrid[xx][yy][ii]-=kosc;
										}
									}
								}
							}
							if (gmv1 > kos) gmv1-=kosc;
							if (gmv2 > kos) gmv2-=kosc;
							if (gmv3 > kos) gmv3-=kosc;
						}
					}
				}
			}
			cout << endl;
		} else if (noplloops==1){
		cout << "fixing up silly cart paths" << endl;
			for (int repeating=0; repeating < 4; repeating++){
				cout << " " << repeating;
				for (int x=0; x<width; x++){
					for (int y=0; y<height; y++){
						if (gamegrid[x][y].size()>1){
							for (int i=0; i<gamegrid[x][y].size()-1; i++){
								if (gamegrid[x][y][i]+2==gamegrid[x][y][i+1]){
									int kos = gamegrid[x][y][i]+1;
									if ((kos < gmv1-3 || kos > gmv1+3)
										&&(kos < gmv2-3 || kos > gmv2+3)
										&&(kos < gmv3-3 || kos > gmv3+3)
										&&(kos > 3 && kos < Area.pather_loop-3)
									){
										cout << ".";
										for (int xx=0; xx<width; xx++){
											for (int yy=0; yy<height; yy++){
												for (int ii=0; ii<gamegrid[xx][yy].size(); ii++){
													if (gamegrid[xx][yy][ii]==kos||gamegrid[xx][yy][ii]==kos+1){
														gamegrid[xx][yy].erase(gamegrid[xx][yy].begin()+ii);
													}
												}
											}
										}
										for (int xx=0; xx<width; xx++){
											for (int yy=0; yy<height; yy++){
												for (int ii=0; ii<gamegrid[xx][yy].size(); ii++){
													if (gamegrid[xx][yy][ii]>kos){
														gamegrid[xx][yy][ii]-=2;
													}
												}
											}
										}
										if (gmv1 > kos) gmv1-=2;
										if (gmv2 > kos) gmv2-=2;
										if (gmv3 > kos) gmv3-=2;
									}
								}
							}
						}
					}
				}
			}
			cout << endl;
		}
		cout << "fixing up really close spawns " << endl;
		int record=1;
		vector<vector<int> > rc = vector<vector<int> >();
		vector<vector<int> > bc = vector<vector<int> >();
		for (int x=0; x<width; x++){
			for (int y=0; y<height; y++){
				if (markgrid[x][y]==PATHER_STARTPOINT){
					bc.push_back(vector<int>());
					bc.back().push_back(x);
					bc.back().push_back(y);
				} else if (markgrid[x][y]==PATHER_ENDPOINT){
					rc.push_back(vector<int>());
					rc.back().push_back(x);
					rc.back().push_back(y);
				}
			}
		}
		cout << "fixing up really close spawns (p2)" << endl;
		while (rc.size()>2&&bc.size()>2&&record<100*HYPERSCALE){
			record++;
			for (int r=0; r<rc.size()&&rc.size()>2&&bc.size()>2; r++){
				for (int b=0; b<bc.size()&&rc.size()>2&&bc.size()>2; b++){
					if(minpath(rc[r][0], rc[r][1], bc[b][0], bc[b][1], grid)<=record){
						markgrid[rc[r][0]][rc[r][1]]=0;
						markgrid[bc[b][0]][bc[b][1]]=0;
						rc.erase(rc.begin()+r);
						bc.erase(bc.begin()+b);
						cout << record << " " << endl;
					}
				}
			}
		}
		cout << endl;
	}
	*/
	// determine connections
	/*
	var ultour=0;
	var ultodl=0;
	var urtodr=0;
	var dltodr=0;
	var ultodr=0;
	var urtodl=0;
	for (var yy = 1; yy < height-1; yy++){
		for (var xx = 1; xx < width-1; xx++){
			if (quadgrid[xx, yy] == 1){
				 if (quadgrid[xx+1, yy] == 2) ultour=1;
				 if (quadgrid[xx-1, yy] == 2) ultour=1;
				 if (quadgrid[xx, yy+1] == 2) ultour=1;
				 if (quadgrid[xx, yy-1] == 2) ultour=1;
				 if (quadgrid[xx+1, yy] == 3) ultodl=1;
				 if (quadgrid[xx-1, yy] == 3) ultodl=1;
				 if (quadgrid[xx, yy+1] == 3) ultodl=1;
				 if (quadgrid[xx, yy-1] == 3) ultodr=1;
				 if (quadgrid[xx+1, yy] == 4) ultodr=1;
				 if (quadgrid[xx-1, yy] == 4) ultodr=1;
				 if (quadgrid[xx, yy+1] == 4) ultodr=1;
				 if (quadgrid[xx, yy-1] == 4) ultodr=1;
			} else if (quadgrid[xx, yy] == 4){
				 if (quadgrid[xx+1, yy] == 2) urtodr=1;
				 if (quadgrid[xx-1, yy] == 2) urtodr=1;
				 if (quadgrid[xx, yy+1] == 2) urtodr=1;
				 if (quadgrid[xx, yy-1] == 2) urtodr=1;
				 if (quadgrid[xx+1, yy] == 3) dltodr=1;
				 if (quadgrid[xx-1, yy] == 3) dltodr=1;
				 if (quadgrid[xx, yy+1] == 3) dltodr=1;
				 if (quadgrid[xx, yy-1] == 3) dltodr=1;
			} else if (quadgrid[xx, yy] == 2){
				 if (quadgrid[xx+1, yy] == 3) urtodl=1;
				 if (quadgrid[xx-1, yy] == 3) urtodl=1;
				 if (quadgrid[xx, yy+1] == 3) urtodl=1;
				 if (quadgrid[xx, yy-1] == 3) urtodl=1;
			}
		}
	}
	var uls=0;
	var urs=0;
	var dls=0;
	var drs=0;
	if (ultour+ultodl+ultodr==0) uls=1;
	if (ultour+urtodl+urtodr==0) urs=1;
	if (urtodl+ultodl+dltodr==0) dls=1;
	if (ultodr+urtodr+dltodr==0) drs=1;
	*/

	cout<< "fixing up placeholders..." << endl;
	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){
			if (jumpy){
				if (grid[xx][yy]==PLACEHOLDER) grid[xx][yy]=VOID;
			}
			if (quadgrid[xx][yy]>-1){
				for (int i = 0; i < 7; i++){
					int xxx = xx;
					int yyy = yy;
					if (i < 4) xxx += (i-1);
					if (i > 3) yyy += (i-5);
					if (quadgrid[xxx][yyy]>-1){
						congrid[quadgrid[xx][yy]][quadgrid[xxx][yyy]]=1;
						congrid[quadgrid[xxx][yyy]][quadgrid[xx][yy]]=1;
					}
				}
			}
		}
	}
	cout<< "planning secrets..." << endl;
	//determine secrets
	for (int xp=0; xp<pathers; xp++){
		issecret[xp] = 1;
		for (int yp=0; yp<pathers; yp++){
			if (xp != yp){
				if (congrid[xp][yp]==1) issecret[xp] = 0;
			}
		}
		if (issecret[xp]==1) totalsecrets++;
	}
	cout<< "planning walls..." << endl;
	// add walls
	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){
			if (grid[xx][yy] == FLOOR) {
				if (grid[xx+1][yy] != FLOOR) {
					grid[xx+1][yy] = WALL;
				}
				if (grid[xx-1][yy] != FLOOR) {
					grid[xx-1][yy] = WALL;
				}
				if (grid[xx][yy+1] != FLOOR) {
					grid[xx][yy+1] = WALL;
				}
				if (grid[xx][yy-1] != FLOOR) {
					grid[xx][yy-1] = WALL;
				}
			}
		}
	}
	
	if (Area.wall_thickness>1){
    for (int i=0; i<Area.wall_thickness-1; i++){
        for (int yy = 1; yy < height-1; yy++){
            for (int xx = 1; xx < width-1; xx++){
                if (grid[xx][yy] == WALL) {
                    if (grid[xx+1][yy] == VOID) {
                        grid[xx+1][yy] = PLACEHOLDER;
                    }
                    if (grid[xx-1][yy] == VOID) {
                        grid[xx-1][yy] = PLACEHOLDER;
                    }
                    if (grid[xx][yy+1] == VOID) {
                        grid[xx][yy+1] = PLACEHOLDER;
                    }
                    if (grid[xx][yy-1] == VOID) {
                        grid[xx][yy-1] = PLACEHOLDER;
                    }
                }
            }
        }
        for (int yy = 1; yy < height-1; yy++){
            for (int xx = 1; xx < width-1; xx++){
                if (grid[xx][yy]==PLACEHOLDER) grid[xx][yy]=WALL;
            }
        }
    }
}
	
	cout<< "building secrets..." << endl;
	// create secrets
	int numconnections=0;
	for (int yy = 0; yy < height; yy++){
		for (int xx = 0; xx < width; xx++){
			int issec=0;
			int adnonsec=0;
			for (int i = 0; i < 7; i++){
				int xxx = xx;
				int yyy = yy;
				if (i < 4) xxx += (i-1);
				if (i > 3) yyy += (i-5);
				if (xxx > -1 && yyy > -1 && xxx < width && yyy < height){
					if (quadgrid[xxx][yyy] > -1){
						while (issecret.size() < quadgrid[xxx][yyy]) issecret.push_back(0);
						if (issecret[quadgrid[xxx][yyy]] == 1){
							issec=1;
						} else {
							adnonsec=1;
						}
					}
				}
			}
			if (issec==1){
				if(grid[xx][yy]==FLOOR) grid[xx][yy] = SECRET_FLOOR;
				if(grid[xx][yy]==WALL) {
					if (adnonsec==1) {
						grid[xx][yy] = SECRET_ENTRANCE;
						numconnections ++;
					}
					if (adnonsec!=1) grid[xx][yy] = SECRET_WALL;
				}
			}
		}
	}
	
	for(int repeating=0; repeating<Area.fix_loop; repeating++){
		cout<< "expanding secrecy..." << endl;
		//if there are not enough secret room connections, expand the secret room a bit
		if (totalsecrets>0){
			if (numconnections<totalsecrets*2){
				for (int yy = 0; yy < height; yy++){
					for (int xx = 0; xx < width; xx++){
						if(grid[xx][yy]==SECRET_WALL){
							int conr=0;
							int conv=0;
							int cons=0;
							for (int i = 0; i < 7; i++){
								int xxx = xx;
								int yyy = yy;
								if (i < 4) xxx += (i-1);
								if (i > 3) yyy += (i-5);
								if (xxx > -1 && yyy > -1 && xxx < width && yyy < height){
									if (grid[xxx][yyy]==VOID) conv=1;
									if (grid[xxx][yyy]==SECRET_FLOOR) cons=1;
									if (grid[xxx][yyy]==WALL) {
										conr=1;
										if (grid[xxx+1][yyy]==VOID) conv=1;
										if (grid[xxx-1][yyy]==VOID) conv=1;
										if (grid[xxx][yyy+1]==VOID) conv=1;
										if (grid[xxx][yyy-1]==VOID) conv=1;
									}
								}
							}
							if (conr+cons==2){
								if (conv==0){
									for (int i = 0; i < 7; i++){
										int xxx = xx;
										int yyy = yy;
										if (i < 4) xxx += (i-1);
										if (i > 3) yyy += (i-5);
										if (xxx > -1 && yyy > -1 && xxx < width && yyy < height){
											//if (grid[xxx][yyy]==WALL) quadgrid[xxx][yyy]=ORIGIN_WALLMEET;
											if (grid[xxx][yyy]==WALL) grid[xxx][yyy]=SECRET_ENTRANCE;
										}
									}
									grid[xx][yy]=SECRET_FLOOR;
									//quadgrid[xx][yy]=ORIGIN_WALLMEET;
									numconnections++;
								}
							}
						}
					}
				}
			}
			if (numconnections<totalsecrets*2){
				for (int yy = 0; yy < height; yy++){
					for (int xx = 0; xx < width; xx++){
						if(grid[xx][yy]==VOID){
							int cons=0;
							int conr=0;
							for (int i = 0; i < 7; i++){
								int xxx = xx;
								int yyy = yy;
								if (i < 4) xxx += (i-1);
								if (i > 3) yyy += (i-5);
								if (xxx > 0 && yyy > 0 && xxx < width-1 && yyy < height-1){
									if (grid[xxx][yyy] == SECRET_WALL){
										if (grid[xxx+1][yyy]==SECRET_FLOOR) cons=1;
										if (grid[xxx-1][yyy]==SECRET_FLOOR) cons=1;
										if (grid[xxx][yyy+1]==SECRET_FLOOR) cons=1;
										if (grid[xxx][yyy-1]==SECRET_FLOOR) cons=1;
									}
									if (grid[xxx][yyy] == WALL){
										if (grid[xxx+1][yyy]==FLOOR) conr=1;
										if (grid[xxx-1][yyy]==FLOOR) conr=1;
										if (grid[xxx][yyy+1]==FLOOR) conr=1;
										if (grid[xxx][yyy-1]==FLOOR) conr=1;
									}
								}
							}
							if (cons+conr==2){
								for (int i = 0; i < 7; i++){
									int xxx = xx;
									int yyy = yy;
									if (i < 4) xxx += (i-1);
									if (i > 3) yyy += (i-5);
									if (xxx > -1 && yyy > -1 && xxx < width && yyy < height){
										if (grid[xxx][yyy]==WALL) quadgrid[xxx][yyy]=ORIGIN_EXTENDED_WALL;
										if (grid[xxx][yyy]==WALL) grid[xxx][yyy]=SECRET_ENTRANCE;
										if (grid[xxx][yyy]==SECRET_WALL) grid[xxx][yyy]=SECRET_FLOOR;
										if (grid[xxx][yyy]==VOID) grid[xxx][yyy]=SECRET_WALL;
									}
								}
								grid[xx][yy]=SECRET_FLOOR;
								numconnections++;
							}
						}
					}
				}
				for (int yy = 1; yy < height-1; yy++){
					for (int xx = 1; xx < width-1; xx++){
						if (grid[xx][yy] == SECRET_FLOOR) {
							if (grid[xx+1][yy] == VOID) {
								grid[xx+1][yy] = SECRET_WALL;
							}
							if (grid[xx-1][yy] == VOID) {
								grid[xx-1][yy] = SECRET_WALL;
							}
							if (grid[xx][yy+1] == VOID) {
								grid[xx][yy+1] = SECRET_WALL;
							}
							if (grid[xx][yy-1] == VOID) {
								grid[xx][yy-1] = SECRET_WALL;
							}
						}
						if (grid[xx][yy] == SECRET_ENTRANCE) {
							if (grid[xx+1][yy] == VOID) {
								grid[xx+1][yy] = SECRET_WALL;
							}
							if (grid[xx-1][yy] == VOID) {
								grid[xx-1][yy] = SECRET_WALL;
							}
							if (grid[xx][yy+1] == VOID) {
								grid[xx][yy+1] = SECRET_WALL;
							}
							if (grid[xx][yy-1] == VOID) {
								grid[xx][yy-1] = SECRET_WALL;
							}
						}
						if (grid[xx][yy] == FLOOR) {
							if (grid[xx+1][yy] == VOID) {
								grid[xx+1][yy] = WALL;
							}
							if (grid[xx-1][yy] == VOID) {
								grid[xx-1][yy] = WALL;
							}
							if (grid[xx][yy+1] == VOID) {
								grid[xx][yy+1] = WALL;
							}
							if (grid[xx][yy-1] == VOID) {
								grid[xx][yy-1] = WALL;
							}
							if (grid[xx+1][yy] == SECRET_FLOOR) {
								grid[xx+1][yy] = FLOOR;
							}
							if (grid[xx-1][yy] == SECRET_FLOOR) {
								grid[xx-1][yy] = FLOOR;
							}
							if (grid[xx][yy+1] == SECRET_FLOOR) {
								grid[xx][yy+1] = FLOOR;
							}
							if (grid[xx][yy-1] == SECRET_FLOOR) {
								grid[xx][yy-1] = FLOOR;
							}
							if (grid[xx+1][yy] == SECRET_WALL) {
								grid[xx+1][yy] = WALL;
							}
							if (grid[xx-1][yy] == SECRET_WALL) {
								grid[xx-1][yy] = WALL;
							}
							if (grid[xx][yy+1] == SECRET_WALL) {
								grid[xx][yy+1] = WALL;
							}
							if (grid[xx][yy-1] == SECRET_WALL) {
								grid[xx][yy-1] = WALL;
							}
						}
					}
				}
		
			}
		}
		cout<< "fixing up secrets..." << endl;
		for(int repeating2=0; repeating2<Area.fix_loop_secret_extender; repeating2++){
			for (int yy = 1; yy < height-1; yy++){
				for (int xx = 1; xx < width-1; xx++){
					if (grid[xx][yy] == SECRET_FLOOR) {
						if (quadgrid[xx][yy] == 0){
							for (int i = 0; i < 7; i++){
								int xxx = xx;
								int yyy = yy;
								if (i < 4) xxx += (i-1);
								if (i > 3) yyy += (i-5);
								if (xxx > -1 && yyy > -1 && xxx < width && yyy < height){
									if (quadgrid[xxx][yyy]>=0){
										if (issecret[quadgrid[xxx][yyy]]==1) quadgrid[xx][yy]=ORIGIN_EXTENDED;
									} else if (quadgrid[xxx][yyy]==ORIGIN_EXTENDED){
										quadgrid[xx][yy]=ORIGIN_EXTENDED;
									}
								}
							}
						}
					}
				}
			}
		}
		cout<< "correcting tiles..." << endl;
		for (int repeating2=0; repeating2<Area.fix_loop_by_tile;repeating2++){
			for (int yy = 1; yy < height-1; yy++){
				for (int xx = 1; xx < width-1; xx++){
					int conns=0;
					int connr=0;
					int connv=0;
					int conne=0;
					if (grid[xx+1][yy] == FLOOR) {
						connr=1;
					}
					if (grid[xx-1][yy] == FLOOR) {
						connr=1;
					}
					if (grid[xx][yy+1] == FLOOR) {
						connr=1;
					}
					if (grid[xx][yy-1] == FLOOR) {
						connr=1;
					}
					if (grid[xx+1][yy] == SECRET_FLOOR) {
						conns=1;
					}
					if (grid[xx-1][yy] == SECRET_FLOOR) {
						conns=1;
					}
					if (grid[xx][yy+1] == SECRET_FLOOR) {
						conns=1;
					}
					if (grid[xx][yy-1] == SECRET_FLOOR) {
						conns=1;
					}
					if (grid[xx+1][yy] == SECRET_ENTRANCE) {
						conne=1;
					}
					if (grid[xx-1][yy] == SECRET_ENTRANCE) {
						conne=1;
					}
					if (grid[xx][yy+1] == SECRET_ENTRANCE) {
						conne=1;
					}
					if (grid[xx][yy-1] == SECRET_ENTRANCE) {
						conne=1;
					}
					if (grid[xx+1][yy] == VOID) {
						connv=1;
					}
					if (grid[xx-1][yy] == VOID) {
						connv=1;
					}
					if (grid[xx][yy+1] == VOID) {
						connv=1;
					}
					if (grid[xx][yy-1] == VOID) {
						connv=1;
					}
					if (grid[xx][yy] == SECRET_FLOOR) {
						if (quadgrid[xx][yy]==0) {
							grid[xx][yy]=SECRET_WALL;
							quadgrid[xx][yy]=ORIGIN_DENIED;
						} else if (quadgrid[xx][yy]==ORIGIN_EXTENDED) {
							if (conns==0) grid[xx][yy] = SECRET_WALL;
							if (conns==0) quadgrid[xx][yy] = ORIGIN_DENIED;
						}
					}
					if (grid[xx][yy] == SECRET_FLOOR) {
						if (grid[xx+1][yy] == VOID) {
							grid[xx+1][yy] = SECRET_WALL;
						}
						if (grid[xx-1][yy] == VOID) {
							grid[xx-1][yy] = SECRET_WALL;
						}
						if (grid[xx][yy+1] == VOID) {
							grid[xx][yy+1] = SECRET_WALL;
						}
						if (grid[xx][yy-1] == VOID) {
							grid[xx][yy-1] = SECRET_WALL;
						}
					}
					if (grid[xx][yy] == SECRET_ENTRANCE) {
						if (conns+connr < 2){
							grid[xx][yy]=SECRET_WALL;
						}
					}
					if (grid[xx][yy] == SECRET_ENTRANCE) {
						if (grid[xx+1][yy] == VOID) {
							grid[xx+1][yy] = SECRET_WALL;
						}
						if (grid[xx-1][yy] == VOID) {
							grid[xx-1][yy] = SECRET_WALL;
						}
						if (grid[xx][yy+1] == VOID) {
							grid[xx][yy+1] = SECRET_WALL;
						}
						if (grid[xx][yy-1] == VOID) {
							grid[xx][yy-1] = SECRET_WALL;
						}
					}
					if (grid[xx][yy] == FLOOR) {
						if (grid[xx+1][yy] == VOID) {
							grid[xx+1][yy] = WALL;
						}
						if (grid[xx-1][yy] == VOID) {
							grid[xx-1][yy] = WALL;
						}
						if (grid[xx][yy+1] == VOID) {
							grid[xx][yy+1] = WALL;
						}
						if (grid[xx][yy-1] == VOID) {
							grid[xx][yy-1] = WALL;
						}
						if (grid[xx+1][yy] == SECRET_FLOOR) {
							grid[xx+1][yy] = FLOOR;
						}
						if (grid[xx-1][yy] == SECRET_FLOOR) {
							grid[xx-1][yy] = FLOOR;
						}
						if (grid[xx][yy+1] == SECRET_FLOOR) {
							grid[xx][yy+1] = FLOOR;
						}
						if (grid[xx][yy-1] == SECRET_FLOOR) {
							grid[xx][yy-1] = FLOOR;
						}
						if (grid[xx+1][yy] == SECRET_WALL) {
							grid[xx+1][yy] = WALL;
						}
						if (grid[xx-1][yy] == SECRET_WALL) {
							grid[xx-1][yy] = WALL;
						}
						if (grid[xx][yy+1] == SECRET_WALL) {
							grid[xx][yy+1] = WALL;
						}
						if (grid[xx][yy-1] == SECRET_WALL) {
							grid[xx][yy-1] = WALL;
						}
					}
					if (grid[xx][yy] == WALL) {
						
						if (conns+connr == 2){
							if (connv==0) grid[xx][yy]=SECRET_ENTRANCE;
						}
					}
					if (grid[xx][yy] == SECRET_WALL){
						if (conns+conne==0){
							grid[xx][yy]=VOID;
						}
					}
				}
			}
		}
	}
	
	
	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){
			if (grid[xx][yy] == WALL && irandom(Area.single_remove_odds) == Area.single_remove_odds){
				if (grid[xx+1][yy] == FLOOR && grid[xx-1][yy] == FLOOR && grid[xx][yy+1] == FLOOR && grid[xx][yy-1] == FLOOR && grid[xx+1][yy+1] == FLOOR && grid[xx-1][yy+1] == FLOOR && grid[xx+1][yy-1] == FLOOR && grid[xx-1][yy-1] == FLOOR){
					grid[xx][yy]=FLOOR;
					quadgrid[xx][yy]=ORIGIN_DENIED;
				}
			}
			if (grid[xx][yy] == SECRET_WALL && irandom(Area.single_remove_odds) == Area.single_remove_odds){
				if (grid[xx+1][yy] == SECRET_FLOOR && grid[xx-1][yy] == SECRET_FLOOR && grid[xx][yy+1] == SECRET_FLOOR && grid[xx][yy-1] == SECRET_FLOOR && grid[xx+1][yy+1] == SECRET_FLOOR && grid[xx-1][yy+1] == SECRET_FLOOR && grid[xx+1][yy-1] == SECRET_FLOOR && grid[xx-1][yy-1] == SECRET_FLOOR){
					grid[xx][yy]=SECRET_FLOOR;
					quadgrid[xx][yy]=ORIGIN_DENIED;
				}
			}
		}
	}
	cout << "building adjacency grids..." << endl;
	vector<vector<int> > adj_floor = vector<vector<int> >();
	vector<vector<int> > adj_sfloor = vector<vector<int> >();
	vector<vector<int> > adj_afloor = vector<vector<int> >();
	vector<vector<int> > adj_wall = vector<vector<int> >();
	vector<vector<int> > adj_swall = vector<vector<int> >();
	vector<vector<int> > adj_awall = vector<vector<int> >();
	vector<vector<int> > adj_void = vector<vector<int> >();

	ds_grid_set_region(adj_floor, 0, 0, width, height, 0);
	ds_grid_set_region(adj_sfloor, 0, 0, width, height, 0);
	ds_grid_set_region(adj_afloor, 0, 0, width, height, 0);
	ds_grid_set_region(adj_wall, 0, 0, width, height, 0);
	ds_grid_set_region(adj_swall, 0, 0, width, height, 0);
	ds_grid_set_region(adj_awall, 0, 0, width, height, 0);
	ds_grid_set_region(adj_void, 0, 0, width, height, 0);


	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){
			for (int i = 1; i < 7; i++){
				int xxx = xx;
				int yyy = yy;
				if (i < 4) xxx += (i-2);
				if (i > 3) yyy += (i-5);
				if (xxx > -1 && yyy > -1 && xxx < width && yyy < height){
					if (xxx != xx || yyy != yy){
						if (grid[xxx][yyy]==WALL) adj_wall[xx][yy]+=1;
						if (grid[xxx][yyy]==SECRET_WALL) adj_swall[xx][yy]+=1;
						if (grid[xxx][yyy]==WALL || grid[xxx][yyy]==SECRET_WALL) adj_awall[xx][yy]+=1;
						if (grid[xxx][yyy]==FLOOR) adj_floor[xx][yy]+=1;
						if (grid[xxx][yyy]==SECRET_FLOOR) adj_sfloor[xx][yy]+=1;
						if (grid[xxx][yyy]==FLOOR || grid[xxx][yyy]==SECRET_FLOOR) adj_afloor[xx][yy]+=1;
						if (grid[xxx][yyy]==VOID) adj_void[xx][yy]+=1;
					}
				}
			}
		}
	}

	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){      
			if (grid[xx][yy]==FLOOR || grid[xx][yy]==SECRET_FLOOR){
				if (adj_awall[xx][yy]==3 && adj_afloor[xx][yy]==1){
					int dedir=VOID;
					//quadgrid[xx][yy]=ORIGIN_WALLMEET;
					for (int i = 1; i < 7; i++){
						int xxx = xx;
						int yyy = yy;
						if (i < 4) xxx += (i-2);
						if (i > 3) yyy += (i-5);
						if (xxx > -1 && yyy > -1 && xxx < width && yyy < height){
							if (xxx != xx || yyy != yy){
								if (grid[xxx][yyy]==grid[xx][yy]){
									dedir=i;
								}
							}
						}
					}
					if (dedir!=VOID){
						int dirx=0;
						int diry=0;
						if (dedir < 4) dirx += (dedir-2);
						if (dedir > 3) diry += (dedir-5);
						bool isded=true;
						for(int i=1; i<=Area.detect_deadend; i++){
							if (xx+i*dirx > -1 && yy+i*diry > -1 && xx+i*dirx < width && yy+i*diry < height){
								if (!burrowendstoentrances) quadgrid[xx+i*dirx][yy+i*diry]=ORIGIN_DENIED;
								if (adj_afloor[xx+i*dirx][yy+i*diry]!=2) isded=false;
							}
						}
						if (isded && markgrid[xx][yy] < PATHER_ENDPOINT) {
							if (burrowendstoentrances) markgrid[xx][yy]=PATHER_ENDPOINT;
							else markgrid[xx][yy]=MARK_DEAD_END;
						}
					}
				}
			}
			if (grid[xx][yy]==WALL){
				if (adj_wall[xx][yy]+adj_floor[xx][yy]==4) markgrid[xx][yy]=MARK_NOT_EDGE;
			}
		}
	}
	
	for (int repeating=0; repeating<Area.wall_thickness+1; repeating++){
		for (int yy = 1; yy < height-1; yy++){
			for (int xx = 1; xx < width-1; xx++){
				if (grid[xx][yy]==WALL){
					bool voided=false;
					for (int i = 1; i < 7; i++){
						int xxx = xx;
						int yyy = yy;
						if (i < 4) xxx += (i-2);
						if (i > 3) yyy += (i-5);
						if (xxx > -1 && yyy > -1 && xxx < width && yyy < height){
							if (xxx != xx || yyy != yy){
								if (grid[xxx][yyy]==VOID || markgrid[xxx][yyy]==MARK_VOIDCON || markgrid[xxx][yyy]==MARK_NONEDGE_VOIDCON) voided=true;
							}
						}
					}
					if (voided){
						if (markgrid[xx][yy]!=MARK_NOT_EDGE) markgrid[xx][yy]=MARK_VOIDCON;
						if (markgrid[xx][yy]==MARK_NOT_EDGE) markgrid[xx][yy]=MARK_NONEDGE_VOIDCON;
					}
				}
			}
		}
	}
	/*
	cout<< "planning prop placement..." << endl;
	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){
			if (grid[xx][yy] == WALL && irandom(Area.single_prop_odds) == Area.single_prop_odds){
				if (grid[xx+1][yy] == FLOOR && grid[xx-1][yy] == FLOOR && grid[xx][yy+1] == FLOOR && grid[xx][yy-1] == FLOOR && grid[xx+1][yy+1] == FLOOR && grid[xx-1][yy+1] == FLOOR && grid[xx+1][yy-1] == FLOOR && grid[xx-1][yy-1] == FLOOR && (Area.gamemode != "pl" || (gamegrid[xx+1][yy].size() <= 0 && gamegrid[xx-1][yy].size() <= 0 && gamegrid[xx][yy+1].size() <= 0 && gamegrid[xx][yy-1].size() <= 0))) grid[xx][yy]=PROP_SINGLE;
			}
			if (grid[xx][yy] == SECRET_WALL && irandom(Area.single_prop_odds) == Area.single_prop_odds){
				if (grid[xx+1][yy] == SECRET_FLOOR && grid[xx-1][yy] == SECRET_FLOOR && grid[xx][yy+1] == SECRET_FLOOR && grid[xx][yy-1] == SECRET_FLOOR && grid[xx+1][yy+1] == SECRET_FLOOR && grid[xx-1][yy+1] == SECRET_FLOOR && grid[xx+1][yy-1] == SECRET_FLOOR && grid[xx-1][yy-1] == SECRET_FLOOR && (Area.gamemode != "pl" || (gamegrid[xx+1][yy].size() <= 0 && gamegrid[xx-1][yy].size() <= 0 && gamegrid[xx][yy+1].size() <= 0 && gamegrid[xx][yy-1].size() <= 0))) grid[xx][yy]=PROP_SINGLE_S;
			}
		}
	}
	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){
			if (grid[xx][yy] == FLOOR && irandom(Area.spawn_prop_odds) == Area.spawn_prop_odds && (Area.gamemode != "pl" || gamegrid[xx][yy].size() <= 0)){
				if (grid[xx+1][yy] == FLOOR && grid[xx-1][yy] == FLOOR && grid[xx][yy+1] == FLOOR && grid[xx][yy-1] == FLOOR && grid[xx+1][yy+1] == FLOOR && grid[xx-1][yy+1] == FLOOR && grid[xx+1][yy-1] == FLOOR && grid[xx-1][yy-1] == FLOOR && (Area.gamemode != "pl" || (gamegrid[xx+1][yy].size() <= 0 && gamegrid[xx-1][yy].size() <= 0 && gamegrid[xx][yy+1].size() <= 0 && gamegrid[xx][yy-1].size() <= 0))) grid[xx][yy]=PROP_SINGLE;
			}
			if (grid[xx][yy] == SECRET_FLOOR && irandom(Area.spawn_prop_odds) == Area.spawn_prop_odds && (Area.gamemode != "pl" || gamegrid[xx][yy].size() <= 0)){
				if (grid[xx+1][yy] == SECRET_FLOOR && grid[xx-1][yy] == SECRET_FLOOR && grid[xx][yy+1] == SECRET_FLOOR && grid[xx][yy-1] == SECRET_FLOOR && grid[xx+1][yy+1] == SECRET_FLOOR && grid[xx-1][yy+1] == SECRET_FLOOR && grid[xx+1][yy-1] == SECRET_FLOOR && grid[xx-1][yy-1] == SECRET_FLOOR && (Area.gamemode != "pl" || (gamegrid[xx+1][yy].size() <= 0 && gamegrid[xx-1][yy].size() <= 0 && gamegrid[xx][yy+1].size() <= 0 && gamegrid[xx][yy-1].size() <= 0))) grid[xx][yy]=PROP_SINGLE_S;
			}
		}
	}
	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){
			if (grid[xx][yy] == FLOOR && irandom(Area.single_prop_odds) == Area.small_prop_odds && (Area.gamemode != "pl" || gamegrid[xx][yy].size() <= 0)){
				int adjwalls = 0;
				int adjfloor = 0;
				if (grid[xx+1][yy+1] != FLOOR || (grid[xx+1][yy] != FLOOR || grid[xx][yy+1] != FLOOR)) adjwalls++;
				if (grid[xx-1][yy-1] != FLOOR || (grid[xx-1][yy] != FLOOR || grid[xx][yy-1] != FLOOR)) adjwalls++;
				if (grid[xx+1][yy-1] != FLOOR || (grid[xx+1][yy] != FLOOR || grid[xx][yy-1] != FLOOR)) adjwalls++;
				if (grid[xx-1][yy+1] != FLOOR || (grid[xx-1][yy] != FLOOR || grid[xx][yy+1] != FLOOR)) adjwalls++;
				
				if (grid[xx+1][yy+1] == FLOOR || (grid[xx+1][yy] == FLOOR || grid[xx][yy+1] == FLOOR)) adjfloor++;
				if (grid[xx-1][yy-1] == FLOOR || (grid[xx-1][yy] == FLOOR || grid[xx][yy-1] == FLOOR)) adjfloor++;
				if (grid[xx+1][yy-1] == FLOOR || (grid[xx+1][yy] == FLOOR || grid[xx][yy-1] == FLOOR)) adjfloor++;
				if (grid[xx-1][yy+1] == FLOOR || (grid[xx-1][yy] == FLOOR || grid[xx][yy+1] == FLOOR)) adjfloor++;
				
				if ( adjwalls < 2 && adjfloor >= 2){
					grid[xx][yy]=PROP_SMALL;
				}
			}
			if (grid[xx][yy] == SECRET_FLOOR && irandom(Area.single_prop_odds) == Area.small_prop_odds && (Area.gamemode != "pl" || gamegrid[xx][yy].size() <= 0)){
				int adjwalls = 0;
				int adjfloor = 0;
				if (grid[xx+1][yy+1] != SECRET_FLOOR || (grid[xx+1][yy] != SECRET_FLOOR || grid[xx][yy+1] != SECRET_FLOOR)) adjwalls++;
				if (grid[xx-1][yy-1] != SECRET_FLOOR || (grid[xx-1][yy] != SECRET_FLOOR || grid[xx][yy-1] != SECRET_FLOOR)) adjwalls++;
				if (grid[xx+1][yy-1] != SECRET_FLOOR || (grid[xx+1][yy] != SECRET_FLOOR || grid[xx][yy-1] != SECRET_FLOOR)) adjwalls++;
				if (grid[xx-1][yy+1] != SECRET_FLOOR || (grid[xx-1][yy] != SECRET_FLOOR || grid[xx][yy+1] != SECRET_FLOOR)) adjwalls++;
				
				if (grid[xx+1][yy+1] == SECRET_FLOOR || (grid[xx+1][yy] == SECRET_FLOOR || grid[xx][yy+1] == SECRET_FLOOR)) adjfloor++;
				if (grid[xx-1][yy-1] == SECRET_FLOOR || (grid[xx-1][yy] == SECRET_FLOOR || grid[xx][yy-1] == SECRET_FLOOR)) adjfloor++;
				if (grid[xx+1][yy-1] == SECRET_FLOOR || (grid[xx+1][yy] == SECRET_FLOOR || grid[xx][yy-1] == SECRET_FLOOR)) adjfloor++;
				if (grid[xx-1][yy+1] == SECRET_FLOOR || (grid[xx-1][yy] == SECRET_FLOOR || grid[xx][yy+1] == SECRET_FLOOR)) adjfloor++;
				
				if ( adjwalls < 2 && adjfloor >= 2){
					grid[xx][yy]=PROP_SMALL;
				}
			}
		}
	}
	*/
	cout << "thinking sbout movement..." << endl;
	for (int yy = 0; yy < height; yy++){
		for (int xx = 0; xx < width; xx++){
			if (grid[xx][yy] == FLOOR){
				absgrid[xx][yy] = FLOOR;
			} else if (grid[xx][yy] == WALL){
				absgrid[xx][yy] = WALL;
			} else if (grid[xx][yy] == PROP_SINGLE){
				absgrid[xx][yy] = PROP;
			} else if (grid[xx][yy] == SECRET_FLOOR){
				absgrid[xx][yy] = FLOOR;
			} else if (grid[xx][yy] == SECRET_WALL){
				absgrid[xx][yy] = WALL;
			} else if (grid[xx][yy] == PROP_SINGLE_S){
				absgrid[xx][yy] = PROP;
			} else if (grid[xx][yy] == SECRET_ENTRANCE){
				absgrid[xx][yy] = FLOOR;
			} else if (grid[xx][yy] == PROP_SMALL){
				absgrid[xx][yy] = PROP;
			}
		}
	}
	
	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){
			if (pathergrid[xx][yy][PYM]&&absgrid[xx][yy-1]==WALL){
				pathergrid[xx][yy][PYM]=0;
			}
			if (pathergrid[xx][yy][PYP]&&absgrid[xx][yy+1]==WALL){
				pathergrid[xx][yy][PYP]=0;
			}
			if (pathergrid[xx][yy][PXM]&&absgrid[xx+1][yy]==WALL){
				pathergrid[xx][yy][PXM]=0;
			}
			if (pathergrid[xx][yy][PXP]&&absgrid[xx-1][yy]==WALL){
				pathergrid[xx][yy][PXP]=0;
			}
		}
	}
	for (int yy = 1; yy < height-1; yy++){
		pathergrid[1][yy][PATH_LEFT]=0;
		pathergrid[width-2][yy][PATH_RIGHT]=0;
	}
	for (int xx = 1; xx < width-1; xx++){
		pathergrid[xx][1][PATH_UP]=0;
		pathergrid[xx][height-2][PATH_DOWN]=0;
	}
	
	vector<vector<int> > hallgrid = vector<vector<int> >();
	ds_grid_set_region(hallgrid, 0, 0, width, height, 0);
	cout << "(sub) working out halls..." << endl;
	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){
			//cout << xx << "," << yy << endl;
			if (absgrid[xx][yy]==FLOOR && (pathergrid[xx][yy][0]+pathergrid[xx][yy][1]+pathergrid[xx][yy][2]+pathergrid[xx][yy][3]>0)){
				
				int adjwalls = 0;
				if (absgrid[xx+1][yy+1]==WALL || (absgrid[xx+1][yy]==WALL || absgrid[xx][yy+1]==WALL)) adjwalls++;
				if (absgrid[xx-1][yy-1]==WALL || (absgrid[xx-1][yy]==WALL || absgrid[xx][yy-1]==WALL)) adjwalls++;
				if (absgrid[xx+1][yy-1]==WALL || (absgrid[xx+1][yy]==WALL || absgrid[xx][yy-1]==WALL)) adjwalls++;
				if (absgrid[xx-1][yy+1]==WALL || (absgrid[xx-1][yy]==WALL || absgrid[xx][yy+1]==WALL)) adjwalls++;
				/*
				bool got1=false;
				bool got2=false;
				bool got3=false;
				bool got4=false;
				if (pathergrid[xx+1][yy+1][0]+pathergrid[xx+1][yy+1][1]+pathergrid[xx+1][yy+1][2]+pathergrid[xx+1][yy+1][3]>0) got1=true;
				if (pathergrid[xx-1][yy-1][0]+pathergrid[xx-1][yy-1][1]+pathergrid[xx-1][yy-1][2]+pathergrid[xx-1][yy-1][3]>0) got2=true;
				if (pathergrid[xx+1][yy+1][0]+pathergrid[xx+1][yy+1][1]+pathergrid[xx+1][yy+1][2]+pathergrid[xx+1][yy+1][3]>0) got3=true;
				if (pathergrid[xx-1][yy-1][0]+pathergrid[xx-1][yy-1][1]+pathergrid[xx-1][yy-1][2]+pathergrid[xx-1][yy-1][3]>0) got4=true;
				*/
				//cout << adj_awall[xx][yy] << " " << adjwalls << endl;
				if (adjwalls==4){
					hallgrid[xx][yy]=1;
				}
				
				/*
				if (!(
				(pathergrid[xx][yy][1]==0&&absgrid[xx][yy-1]!=WALL)||
				(pathergrid[xx][yy][3]==0&&absgrid[xx][yy+1]!=WALL)||
				(pathergrid[xx][yy][2]==0&&absgrid[xx+1][yy]!=WALL)||
				(pathergrid[xx][yy][0]==0&&absgrid[xx-1][yy]!=WALL)
				)) hallgrid[xx][yy]=1;
				*/
			}
		}
	}
	cout << "(sub) halls p2" << endl;
	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){
			if (hallgrid[xx][yy]>0){
				if (absgrid[xx][yy]==WALL) hallgrid[xx][yy]=0;
			}
		}
	}
	cout << "(sub) halls p3" << endl;
	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){
			if (hallgrid[xx][yy]>0){
				if (hallgrid[xx+1][yy]==0&&hallgrid[xx-1][yy]==0&&hallgrid[xx][yy+1]==0&&hallgrid[xx][yy-1]==0) hallgrid[xx][yy]=0;
				else {
					if (pathergrid[xx][yy][PYM]&&hallgrid[xx][yy-1]==0&&absgrid[xx][yy-1]!=WALL){
						hallgrid[xx][yy]=2;
					}
					if (pathergrid[xx][yy][PYP]&&hallgrid[xx][yy+1]==0&&absgrid[xx][yy+1]!=WALL){
						hallgrid[xx][yy]=4;
					}
					if (pathergrid[xx][yy][PXP]&&hallgrid[xx+1][yy]==0&&absgrid[xx+1][yy]!=WALL){
						hallgrid[xx][yy]=5;
					}
					if (pathergrid[xx][yy][PXM]&&hallgrid[xx-1][yy]==0&&absgrid[xx-1][yy]!=WALL){
						hallgrid[xx][yy]=3;
					}
				}
			}
		}
	}
	
	cout << "(sub) inout stuff" << endl;
	
	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){
			if (inoutgrid[xx][yy]<0){
				if (absgrid[xx][yy]==WALL || hallgrid[xx][yy]>0){
					inoutgrid[xx][yy]=2;
				}
			}
		}
	}
	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){
			if (inoutgrid[xx][yy]<0){
				if (absgrid[xx][yy]==FLOOR && inoutgrid[xx-1][yy]>0 && inoutgrid[xx][yy-1]>0){
					int xxx = xx;
					bool cont = true;
					while (xxx < width-1 && cont){
						xxx++;
						if(absgrid[xxx][yy]!=FLOOR || inoutgrid[xxx][yy-1]<2){
							cont = false;
						}
					}
					cont = true;
					bool gotem = false;
					int yyy = yy;
					while (yyy < height-1 && cont){
						gotem = true;
						yyy++;
						for (int xxxx=xx; xxxx < xxx; xxxx++){
							if (inoutgrid[xxxx][yyy]<2) gotem=false;
							if (absgrid[xxxx][yyy]!=FLOOR || inoutgrid[xxxx][yyy]>0) {
								cont = false;
							}
						}
						if (!gotem && (inoutgrid[xx-1][yyy]<2 || inoutgrid[xxx][yyy]<2)){
							cont = false;
						}
					}
					if (gotem) {
						for (int xxxx = xx; xxxx < xxx; xxxx++){
							for (int yyyy = yy; yyyy < yyy; yyyy++){
								inoutgrid[xxxx][yyyy] = 1;
							}
						}
					}
				}
			}
		}
	}
	cout << "(sub) inout stuff 2" << endl;
	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){
			if (inoutgrid[xx][yy]<0){
				if (absgrid[xx][yy]==FLOOR) inoutgrid[xx][yy]=0;
				if (Area.displacementrange > 0 && displacementstrength > 0 && absgrid[xx][yy] != PROP && markgrid[xx][yy] != PATHER_ENDPOINT && markgrid[xx][yy] != PATHER_STARTPOINT && markgrid[xx][yy] != PATHER_ENDPOINT_SPECIAL && markgrid[xx][yy] != PATHER_STARTPOINT_SPECIAL && markgrid[xx][yy] != PATHER_MIDPOINT && markgrid[xx][yy] != PATHER_MIDPOINT2 && markgrid[xx][yy] != PATHER_MIDPOINT3 && (Area.gamemode != "pl" || gamegrid[xx][yy].size() <= 0)) displacegrid[xx][yy] = irandom(Area.displacementrange);
			}
		}
	}
	
	cout << "(sub) inout stuff 3" << endl;
	for (int yy = 1; yy < height-1; yy++){
		for (int xx = 1; xx < width-1; xx++){
			if (displacegrid[xx][yy]>0){
				if ((displacegrid[xx+1][yy]<0 && absgrid[xx+1][yy] != WALL) || (displacegrid[xx-1][yy]<0 && absgrid[xx-1][yy] != WALL) || (displacegrid[xx][yy+1]<0 && absgrid[xx][yy+1] != WALL) || (displacegrid[xx][yy-1]<0 && absgrid[xx][yy-1] != WALL)){
					displacegrid[xx][yy]=0;
				}
			}
		}
	}
	
	cout << "(sub) checking for secret balance" << endl;
	//if (SUBATTEMPTS < MAXATTEMPTS && (totalsecrets>Area.spawnsecretmax || totalsecrets<Area.spawnsecretmin || numconnections<totalsecrets || issecret[0]==1)) return GetFreeGrid(Area); 
	//else {
	// draw level from grid
	cout<< "(sub) Plans completed succesfully!" << endl << "Building tile grid..." << endl;
		for (int yy = 0; yy < height; yy++){
			for (int xx = 0; xx < width; xx++){
				Tile tile=Tile(noone);
				
				if (grid[xx][yy] == FLOOR){
					tile = tile_add(grid, xx, yy);
					if (xx==0||yy==0||xx==width-1||yy==height-1){
						tile = Tile(WALL, xx, yy);
					}
				} else if (grid[xx][yy] == WALL){
					tile = tile_add(grid, xx, yy);//tile_add(bg_wall, 0, 0, CELL_WIDTH, CELL_HEIGHT, xx*CELL_WIDTH, yy*CELL_HEIGHT, 0);
				} else if (grid[xx][yy] == PROP_SINGLE){
					tile = tile_add(grid, xx, yy);//tile_add(bg_prop_tile_1, 0, 0, CELL_WIDTH, CELL_HEIGHT, xx*CELL_WIDTH, yy*CELL_HEIGHT, 0);
				} else if (grid[xx][yy] == PROP_SMALL){
					tile = tile_add(grid, xx, yy);//tile_add(bg_prop_tile_1, 0, 0, CELL_WIDTH, CELL_HEIGHT, xx*CELL_WIDTH, yy*CELL_HEIGHT, 0);
				} else if (grid[xx][yy] == SECRET_FLOOR){
					tile = tile_add(grid, xx, yy);//tile_add(bg_floor_secret, 0, 0, CELL_WIDTH, CELL_HEIGHT, xx*CELL_WIDTH, yy*CELL_HEIGHT, 0);
					if (xx==0||yy==0||xx==width-1||yy==height-1){
						tile = Tile(SECRET_WALL, xx, yy);
					}
					//tile_set_visible(tile, false);
					//hiddentiles[numhiddentiles]=tile;
					numhiddentiles++;
				} else if (grid[xx][yy] == SECRET_WALL){
					tile = tile_add(grid, xx, yy);//tile_add(bg_wall_secret, 0, 0, CELL_WIDTH, CELL_HEIGHT, xx*CELL_WIDTH, yy*CELL_HEIGHT, 0);
					//tile_set_visible(tile, false);
					//hiddentiles[numhiddentiles]=tile;
					numhiddentiles++;
				} else if (grid[xx][yy] == PROP_SINGLE_S){
					tile = tile_add(grid, xx, yy);//tile_add(bg_prop_tile_1s, 0, 0, CELL_WIDTH, CELL_HEIGHT, xx*CELL_WIDTH, yy*CELL_HEIGHT, 0);
					//tile_set_visible(tile, false);
					//hiddentiles[numhiddentiles]=tile;
					numhiddentiles++;
				} else if (grid[xx][yy] == SECRET_ENTRANCE){
					tile = tile_add(grid, xx, yy);//tile_add(bg_wall, 0, 0, CELL_WIDTH, CELL_HEIGHT, xx*CELL_WIDTH, yy*CELL_HEIGHT, 0);
					if (xx==0||yy==0||xx==width-1||yy==height-1){
						tile = Tile(SECRET_WALL, xx, yy);
					}
					//disguisedtiles[numdisguisedtiles]=tile;
					numdisguisedtiles ++;
				}
				if (overgrid[xx][yy]==ORIGIN_ROOMCENTER) tile = Tile(ORIGIN_ROOMCENTER, xx, yy);
				if (inoutgrid[xx][yy]==1) tile = Tile(INDOOR_ROOM, xx, yy);
				if (inoutgrid[xx][yy]==2 && (markgrid[xx][yy]==MARK_DEAD_END || markgrid[xx][yy]==PATHER_ENDPOINT || markgrid[xx][yy]==PATHER_STARTPOINT || markgrid[xx][yy]==PATHER_ENDPOINT_SPECIAL || markgrid[xx][yy]==PATHER_STARTPOINT_SPECIAL)) envirogrid[xx][yy].push_back(Tile(ENVIRO_INDOOR, xx, yy));
				if (markgrid[xx][yy]==MARK_DEAD_END) tile = Tile(MARK_DEAD_END, xx, yy);
				if (markgrid[xx][yy]==PATHER_ENDPOINT) tile = Tile(PATHER_ENDPOINT+100*quadgrid[xx][yy], xx, yy);
				if (markgrid[xx][yy]==PATHER_STARTPOINT) tile = Tile(PATHER_STARTPOINT+100*quadgrid[xx][yy], xx, yy);
				if (markgrid[xx][yy]==PATHER_ENDPOINT_SPECIAL || (markgrid[xx][yy]==PATHER_ENDPOINT && (grid[xx][yy] == SECRET_ENTRANCE || grid[xx][yy] == SECRET_FLOOR || grid[xx][yy] == SECRET_WALL) )) tile = Tile(PATHER_ENDPOINT_SPECIAL+100*quadgrid[xx][yy], xx, yy);
				if (markgrid[xx][yy]==PATHER_STARTPOINT_SPECIAL || (markgrid[xx][yy]==PATHER_STARTPOINT && (grid[xx][yy] == SECRET_ENTRANCE || grid[xx][yy] == SECRET_FLOOR || grid[xx][yy] == SECRET_WALL) )) tile = Tile(PATHER_STARTPOINT_SPECIAL+100*quadgrid[xx][yy], xx, yy);
				if (markgrid[xx][yy]>=PATHER_ENDPOINT) cout << markgrid[xx][yy] << " " << xx << " " << yy << endl;
				if (tile.GetTileID()!=noone) {
					tilegrid[xx][yy]=tile;
					
					if (usetexturezones){
						if (theme == "g"){
							if (quadgrid[xx][yy] % 6 == 4){
								tilegrid[xx][yy].tfind.push_back("NATURE/DIRTGROUND004");
								tilegrid[xx][yy].treplace.push_back("NATURE/DIRTGROUND009");
							}
							else if (quadgrid[xx][yy] % 3 == 1){
								tilegrid[xx][yy].tfind.push_back("NATURE/DIRTGROUND004");
								tilegrid[xx][yy].treplace.push_back("NATURE/DIRTGROUND003");
							}
							else if (quadgrid[xx][yy] % 3 == 2){
								tilegrid[xx][yy].tfind.push_back("NATURE/DIRTGROUND004");
								tilegrid[xx][yy].treplace.push_back("NATURE/DIRTGROUND005");
							}
						}
					}
				}
				
				/*
				tile = NULL;
				if (quadgrid[xx][yy] == 0){
					tile = tile_add(quadgrid, xx, yy);//tile_add(bg_ul, 0, 0, CELL_WIDTH, CELL_HEIGHT, xx*CELL_WIDTH, yy*CELL_HEIGHT, 0);
				} else if (quadgrid[xx][yy] == 1){
					tile = tile_add(quadgrid, xx, yy);//tile_add(bg_ur, 0, 0, CELL_WIDTH, CELL_HEIGHT, xx*CELL_WIDTH, yy*CELL_HEIGHT, 0);
				} else if (quadgrid[xx][yy] == 2){
					tile = tile_add(quadgrid, xx, yy);//tile_add(bg_dl, 0, 0, CELL_WIDTH, CELL_HEIGHT, xx*CELL_WIDTH, yy*CELL_HEIGHT, 0);
				} else if (quadgrid[xx][yy] == 3){
					tile = tile_add(quadgrid, xx, yy);//tile_add(bg_dr, 0, 0, CELL_WIDTH, CELL_HEIGHT, xx*CELL_WIDTH, yy*CELL_HEIGHT, 0);
				} else if (quadgrid[xx][yy] == ORIGIN_EXTENDED){
					tile = tile_add(quadgrid, xx, yy);//tile_add(bg_extention_secret, 0, 0, CELL_WIDTH, CELL_HEIGHT, xx*CELL_WIDTH, yy*CELL_HEIGHT, 0);
				} else if (quadgrid[xx][yy] == ORIGIN_WALLMEET){
					tile = tile_add(quadgrid, xx, yy);//tile_add(bg_wallmarker, 0, 0, CELL_WIDTH, CELL_HEIGHT, xx*CELL_WIDTH, yy*CELL_HEIGHT, 0);
				} else if (quadgrid[xx][yy] == ORIGIN_EXTENDED_WALL){
					tile = tile_add(quadgrid, xx, yy);//tile_add(bg_reachmarker, 0, 0, CELL_WIDTH, CELL_HEIGHT, xx*CELL_WIDTH, yy*CELL_HEIGHT, 0);
				}  else if (quadgrid[xx][yy] == ORIGIN_DENIED){
					tile = tile_add(quadgrid, xx, yy);//tile_add(bg_denied, 0, 0, CELL_WIDTH, CELL_HEIGHT, xx*CELL_WIDTH, yy*CELL_HEIGHT, 0);
				} 
				
				if (tile!=NULL) tilequadgrid[xx][yy]=tile;
				*/
			}
		}
	//}
	for (int yy = 0; yy < height; yy++){
		for (int xx = 0; xx < width; xx++){
			for (int i=0; i < gamegrid[xx][yy].size(); i++){
				gametilegrid[xx][yy].push_back(Tile((300+gamegrid[xx][yy][i]),xx,yy));
			}
		}
	}
	
	if(Area.displacementrange > 0){
		for (int yy = 1; yy < height-1; yy++){
			for (int xx = 1; xx < width-1; xx++)
				{tilegrid[xx][yy].dispinfo = vector<vector<int> >();
				for (int i=0; i<5; i++){
					tilegrid[xx][yy].dispinfo.push_back(vector<int>());
					for (int j=0; j<5; j++){
						tilegrid[xx][yy].dispinfo[i].push_back(displacegrid[xx][yy]);
					}
				}
				if (tilegrid[xx][yy].GetTileID() != VOID && displacegrid[xx][yy]>=0){
					
					if (xx < width / 2 && yy >= height / 2){
						for (int i=0; i<3; i++){
							for (int j=0; j<3; j++){
								tilegrid[xx][yy].dispinfo[i*2][j*2] = borderthing(displacegrid[xx][yy] * displacementstrength,displacegrid[xx+j-1][yy] * displacementstrength,displacegrid[xx][yy-i+1] * displacementstrength,displacegrid[xx+j-1][yy-i+1] * displacementstrength);
								//cout << i*2 << "," << j*2 << " = " << tilegrid[xx][yy].dispinfo[i*2][j*2] << endl;
							}
						}
						tilegrid[xx][yy].dispinfo[1][1]=tilegrid[xx][yy].dispinfo[4][4];
						tilegrid[xx][yy].dispinfo[4][4]=tilegrid[xx][yy].dispinfo[0][0];
						tilegrid[xx][yy].dispinfo[0][0]=tilegrid[xx][yy].dispinfo[1][1];
					} else if (xx >= width / 2 && yy >= height / 2){
						for (int i=0; i<3; i++){
							for (int j=0; j<3; j++){
								tilegrid[xx][yy].dispinfo[i*2][j*2] = borderthing(displacegrid[xx][yy] * displacementstrength,displacegrid[xx+j-1][yy] * displacementstrength,displacegrid[xx][yy+i-1] * displacementstrength,displacegrid[xx+j-1][yy+i-1] * displacementstrength);
								//cout << i*2 << "," << j*2 << " = " << tilegrid[xx][yy].dispinfo[i*2][j*2] << endl;
							}
						}
					} else if (xx >= width / 2 && yy < height / 2){
						for (int i=0; i<3; i++){
							for (int j=0; j<3; j++){
								tilegrid[xx][yy].dispinfo[i*2][j*2] = borderthing(displacegrid[xx][yy] * displacementstrength,displacegrid[xx-j+1][yy] * displacementstrength,displacegrid[xx][yy+i-1] * displacementstrength,displacegrid[xx-j+1][yy+i-1] * displacementstrength);
								//cout << i*2 << "," << j*2 << " = " << tilegrid[xx][yy].dispinfo[i*2][j*2] << endl;
							}
						}
						tilegrid[xx][yy].dispinfo[1][1]=tilegrid[xx][yy].dispinfo[4][4];
						tilegrid[xx][yy].dispinfo[4][4]=tilegrid[xx][yy].dispinfo[0][0];
						tilegrid[xx][yy].dispinfo[0][0]=tilegrid[xx][yy].dispinfo[1][1];
					} else {
						for (int i=0; i<3; i++){
							for (int j=0; j<3; j++){
								tilegrid[xx][yy].dispinfo[i*2][j*2] = borderthing(displacegrid[xx][yy] * displacementstrength,displacegrid[xx-j+1][yy] * displacementstrength,displacegrid[xx][yy-i+1] * displacementstrength,displacegrid[xx-j+1][yy-i+1] * displacementstrength);
								//cout << i*2 << "," << j*2 << " = " << tilegrid[xx][yy].dispinfo[i*2][j*2] << endl;
							}
						}
					}
					
					/*
					tilegrid[xx][yy].dispinfo[0][0] = borderthing(displacegrid[xx][yy] * displacementstrength,displacegrid[xx+2-1][yy] * displacementstrength,displacegrid[xx][yy-2+1] * displacementstrength,displacegrid[xx+2-1][yy-2+1] * displacementstrength);
					tilegrid[xx][yy].dispinfo[4][4] = borderthing(displacegrid[xx][yy] * displacementstrength,displacegrid[xx+0-1][yy] * displacementstrength,displacegrid[xx][yy-0+1] * displacementstrength,displacegrid[xx+0-1][yy-0+1] * displacementstrength);
					*/
					/*
					tilegrid[xx][yy].dispinfo[4][4] = borderthing(displacegrid[xx][yy] * displacementstrength,displacegrid[xx-1][yy] * displacementstrength,displacegrid[xx][yy+1] * displacementstrength,displacegrid[xx-1][yy+1] * displacementstrength);
					tilegrid[xx][yy].dispinfo[4][0] = borderthing(displacegrid[xx][yy] * displacementstrength,displacegrid[xx-1][yy] * displacementstrength,displacegrid[xx][yy-1] * displacementstrength,displacegrid[xx-1][yy-1] * displacementstrength);
					tilegrid[xx][yy].dispinfo[0][4] = borderthing(displacegrid[xx][yy] * displacementstrength,displacegrid[xx+1][yy] * displacementstrength,displacegrid[xx][yy+1] * displacementstrength,displacegrid[xx+1][yy+1] * displacementstrength);
					tilegrid[xx][yy].dispinfo[0][0] = borderthing(displacegrid[xx][yy] * displacementstrength,displacegrid[xx+1][yy] * displacementstrength,displacegrid[xx][yy-1] * displacementstrength,displacegrid[xx+1][yy-1] * displacementstrength);
					*/
					
					/*
					tilegrid[xx][yy].dispinfo[2][0] = borderthing(displacegrid[xx][yy],displacegrid[xx][yy],displacegrid[xx][yy-1],displacegrid[xx][yy-1]) * displacementstrength;
					tilegrid[xx][yy].dispinfo[0][2] = borderthing(displacegrid[xx][yy],displacegrid[xx-1][yy],displacegrid[xx][yy],displacegrid[xx-1][yy]) * displacementstrength;
					tilegrid[xx][yy].dispinfo[2][2] = borderthing(displacegrid[xx][yy],displacegrid[xx][yy],displacegrid[xx][yy],displacegrid[xx][yy]) * displacementstrength;
					tilegrid[xx][yy].dispinfo[4][2] = borderthing(displacegrid[xx][yy],displacegrid[xx+1][yy],displacegrid[xx][yy],displacegrid[xx+1][yy]) * displacementstrength;
					tilegrid[xx][yy].dispinfo[2][4] = borderthing(displacegrid[xx][yy],displacegrid[xx][yy],displacegrid[xx][yy+1],displacegrid[xx][yy+1]) * displacementstrength;
					*/
					
					tilegrid[xx][yy].dispinfo[2][0] = (tilegrid[xx][yy].dispinfo[4][0] + tilegrid[xx][yy].dispinfo[0][0]) / 2;
					tilegrid[xx][yy].dispinfo[0][2] = (tilegrid[xx][yy].dispinfo[0][4] + tilegrid[xx][yy].dispinfo[0][0]) / 2;
					tilegrid[xx][yy].dispinfo[2][4] = (tilegrid[xx][yy].dispinfo[4][4] + tilegrid[xx][yy].dispinfo[0][4]) / 2;
					tilegrid[xx][yy].dispinfo[4][2] = (tilegrid[xx][yy].dispinfo[4][4] + tilegrid[xx][yy].dispinfo[4][0]) / 2;
					
					
					//tilegrid[xx][yy].dispinfo[2][0] = borderthing(displacegrid[xx][yy] * displacementstrength, displacegrid[xx][yy-1] * displacementstrength);
					
					
					tilegrid[xx][yy].dispinfo[0][1] = (tilegrid[xx][yy].dispinfo[0][0] + tilegrid[xx][yy].dispinfo[0][2]) / 2;
					tilegrid[xx][yy].dispinfo[4][1] = (tilegrid[xx][yy].dispinfo[4][0] + tilegrid[xx][yy].dispinfo[4][2]) / 2;
					tilegrid[xx][yy].dispinfo[0][3] = (tilegrid[xx][yy].dispinfo[0][4] + tilegrid[xx][yy].dispinfo[0][2]) / 2;
					tilegrid[xx][yy].dispinfo[4][3] = (tilegrid[xx][yy].dispinfo[4][4] + tilegrid[xx][yy].dispinfo[4][2]) / 2;
					tilegrid[xx][yy].dispinfo[1][0] = (tilegrid[xx][yy].dispinfo[0][0] + tilegrid[xx][yy].dispinfo[2][0]) / 2;
					tilegrid[xx][yy].dispinfo[1][4] = (tilegrid[xx][yy].dispinfo[0][4] + tilegrid[xx][yy].dispinfo[2][4]) / 2;
					tilegrid[xx][yy].dispinfo[3][0] = (tilegrid[xx][yy].dispinfo[4][0] + tilegrid[xx][yy].dispinfo[2][0]) / 2;
					tilegrid[xx][yy].dispinfo[3][4] = (tilegrid[xx][yy].dispinfo[4][4] + tilegrid[xx][yy].dispinfo[2][4]) / 2;
					
					
					tilegrid[xx][yy].dispinfo[1][1] = (tilegrid[xx][yy].dispinfo[0][0] + tilegrid[xx][yy].dispinfo[2][2]) / 2;
					tilegrid[xx][yy].dispinfo[3][3] = (tilegrid[xx][yy].dispinfo[4][4] + tilegrid[xx][yy].dispinfo[2][2]) / 2;
					tilegrid[xx][yy].dispinfo[1][3] = (tilegrid[xx][yy].dispinfo[0][4] + tilegrid[xx][yy].dispinfo[2][2]) / 2;
					tilegrid[xx][yy].dispinfo[3][1] = (tilegrid[xx][yy].dispinfo[4][0] + tilegrid[xx][yy].dispinfo[2][2]) / 2;
					
					
					tilegrid[xx][yy].dispinfo[2][1] = (tilegrid[xx][yy].dispinfo[2][0] + tilegrid[xx][yy].dispinfo[2][2]) / 2;
					tilegrid[xx][yy].dispinfo[2][3] = (tilegrid[xx][yy].dispinfo[2][4] + tilegrid[xx][yy].dispinfo[2][2]) / 2;
					tilegrid[xx][yy].dispinfo[1][2] = (tilegrid[xx][yy].dispinfo[0][2] + tilegrid[xx][yy].dispinfo[2][2]) / 2;
					tilegrid[xx][yy].dispinfo[3][2] = (tilegrid[xx][yy].dispinfo[4][2] + tilegrid[xx][yy].dispinfo[2][2]) / 2;
					/*
					tilegrid[xx][yy].dispinfo[0][0] = borderthing(displacegrid[xx][yy],displacegrid[xx-1][yy],displacegrid[xx][yy-1],displacegrid[xx-1][yy-1]);
					tilegrid[xx][yy].dispinfo[2][0] = borderthing(displacegrid[xx][yy],displacegrid[xx][yy],displacegrid[xx][yy-1],displacegrid[xx][yy-1]);
					tilegrid[xx][yy].dispinfo[4][0] = borderthing(displacegrid[xx][yy],displacegrid[xx+1][yy],displacegrid[xx][yy-1],displacegrid[xx+1][yy-1]);
					tilegrid[xx][yy].dispinfo[0][2] = borderthing(displacegrid[xx][yy],displacegrid[xx-1][yy],displacegrid[xx][yy],displacegrid[xx-1][yy]);
					tilegrid[xx][yy].dispinfo[0][4] = borderthing(displacegrid[xx][yy],displacegrid[xx-1][yy],displacegrid[xx][yy+1],displacegrid[xx-1][yy+1]);
					tilegrid[xx][yy].dispinfo[2][2] = borderthing(displacegrid[xx][yy],displacegrid[xx][yy],displacegrid[xx][yy],displacegrid[xx][yy]);
					tilegrid[xx][yy].dispinfo[4][2] = borderthing(displacegrid[xx][yy],displacegrid[xx+1][yy],displacegrid[xx][yy],displacegrid[xx+1][yy]);
					tilegrid[xx][yy].dispinfo[2][4] = borderthing(displacegrid[xx][yy],displacegrid[xx][yy],displacegrid[xx][yy+1],displacegrid[xx][yy+1]);
					tilegrid[xx][yy].dispinfo[4][4] = borderthing(displacegrid[xx][yy],displacegrid[xx+1][yy],displacegrid[xx][yy+1],displacegrid[xx+1][yy+1]);
					*/
					
					if (tilegrid[xx][yy].GetTileID() == FLOOR || tilegrid[xx][yy].GetTileID() == SECRET_FLOOR || tilegrid[xx][yy].GetTileID() == SECRET_ENTRANCE){
						envirogrid[xx][yy].push_back(Tile(ENVIRO_OUTDOOR, xx, yy));
						envirogrid[xx][yy].back().dispinfo = tilegrid[xx][yy].dispinfo;
						
						
						if (usetexturezones){
							envirogrid[xx][yy].back().tfind = tilegrid[xx][yy].tfind;
							envirogrid[xx][yy].back().treplace = tilegrid[xx][yy].treplace;
						}
						
						//envirogrid[xx][yy].back().ltr = to_string(displacegrid[xx][yy]);
					}
				}
			}
		}
	}
	
	//cout << "gmcoords: " << gmx1 << " " << gmy1 << " " << gmx2 << " " << gmy2 << endl;
	//cout<< "Complete!" << endl;
	/*
	cout << tilegrid[gmx1][gmy1].ltr << endl;
	cout << tilegrid[gmx2][gmy2].ltr << endl;
	cout << tilegrid[gmx3][gmy3].ltr << endl;
	cout << tilegrid[gmx4][gmy4].ltr << endl;
	cout << markgrid[gmx1][gmy1] << endl;
	cout << markgrid[gmx2][gmy2] << endl;
	cout << markgrid[gmx3][gmy3] << endl;
	cout << markgrid[gmx4][gmy4] << endl;
	*/
	cout << "burrows and overheads grid built!" << endl;
	for (int y=0; y<height; y++){
		cout << endl;
		for (int x=0; x<width; x++){
			
			if (tilegrid[x][y].ltr == " " && hallgrid[x][y]>0 && ((tilegrid[x][y].GetTileID() != SECRET_FLOOR && tilegrid[x][y].GetTileID() != SECRET_WALL) || theme!="g")){
				if (hallgrid[x][y]>1){
					switch(hallgrid[x][y]){
						case 3:
							tilegrid[x][y].SetupTileIdentity(803);
							break;
						case 4:
							tilegrid[x][y].SetupTileIdentity(804);
							break;
						case 5:
							tilegrid[x][y].SetupTileIdentity(805);
							break;
						case 2:
							tilegrid[x][y].SetupTileIdentity(802);
							break;
					}
				}
				else {
				int walker = pathergrid[x][y][PATH_UP]*500 + pathergrid[x][y][PATH_DOWN]*50 + pathergrid[x][y][PATH_RIGHT]*5 + pathergrid[x][y][PATH_LEFT]/2;
				switch(walker){
					case 11:
						tilegrid[x][y].SetupTileIdentity(500);
						break;
					case 1100:
						tilegrid[x][y].SetupTileIdentity(501);
						break;
					case 101:
						tilegrid[x][y].SetupTileIdentity(502);
						break;
					case 1010:
						tilegrid[x][y].SetupTileIdentity(503);
						break;
					case 110:
						tilegrid[x][y].SetupTileIdentity(504);
						break;
					case 1001:
						tilegrid[x][y].SetupTileIdentity(505);
						break;
					case 1011:
						tilegrid[x][y].SetupTileIdentity(506);
						break;
					case 111:
						tilegrid[x][y].SetupTileIdentity(507);
						break;
					case 1110:
						tilegrid[x][y].SetupTileIdentity(508);
						break;
					case 1101:
						tilegrid[x][y].SetupTileIdentity(509);
						break;
					case 1111:
						tilegrid[x][y].SetupTileIdentity(510);
						break;
					default:
						//cout << walker/5;
						tilegrid[x][y].ltr = "!";
						break;
					}
				}
			}
			
		cout << tilegrid[x][y].ltr;
		}
		
		cout << " | ";
		
		for (int xx=0; xx<width; xx++){
			if (displacegrid[xx][y] >= 0) cout << displacegrid[xx][y];
			else cout << " ";
		}
		
		cout << " | ";
		for (int xx=0; xx<width; xx++){
			if (quadgrid[xx][y] >= 0 && quadgrid[xx][y] <= 9) cout << quadgrid[xx][y];
			else if (quadgrid[xx][y] > 9) cout << "?";
			else cout << " ";
		}
	}
	return tilegrid;
}