#include <iostream>
#include <fstream>
#include <string>
#include <string.h>
#include <map>
#include <vector>
#include <cassert>
#include <cstdlib>
#include <math.h>
#include <time.h>

#include "util.cpp"
#include "settings.cpp"
const float HYPERSCALE = (float(width+height)/2.0)/40.0;

const int VOID = -4;
const int PLACEHOLDER = -2;
const int FLOOR = 1;
const int WALL = 2;
const int DROPTILE = 3;
const int PROP = 4;
const int SECRET_FLOOR = 5;
const int SECRET_WALL = 6;
const int SECRET_ENTRANCE = 7;
const int ORIGIN_EXTENDED_WALL = 8;
const int ORIGIN_DENIED = -8;
const int ORIGIN_WALLMEET = 9;
const int ORIGIN_EXTENDED = 10;
const int PROP_SINGLE = 11;
const int PROP_SINGLE_S = 12;
const int MARK_DEAD_END = 13;
const int MARK_NOT_EDGE = 14;
const int MARK_VOIDCON = 15;
const int MARK_NONEDGE_VOIDCON = 16;
const int PATHER_ENDPOINT = 17;
const int PATHER_STARTPOINT = 18;
const int PATHER_STARTPOINT_SPECIAL=19;
const int PATHER_ENDPOINT_SPECIAL=20;
const int PATHER_MIDPOINT=21;
const int PATHER_MIDPOINT2=22;
const int PATHER_MIDPOINT3=23;
const int ORIGIN_ROOMGEN = 25;
const int ORIGIN_ROOMCENTER = 26;
const int PROP_SMALL = 27;
const int INDOOR_ROOM = 28;
const int ENVIRO_INDOOR = 29;
const int ENVIRO_OUTDOOR = 30;
const int BURROW_ENTER = 31;
const int BURROW_EXIT = 32;
const int OVERHEAD_ENTER = 33;
const int OVERHEAD_EXIT = 34;
const int noone = 0;
const int PATH_UP = 3;
const int PATH_RIGHT = 0;
const int PATH_DOWN = 1;
const int PATH_LEFT = 2;
const int PXP = 2;
const int PXM = 0;
const int PYP = 1;
const int PYM = 3;
//const int CELL_WIDTH = 256;
//const int CELL_HEIGHT = 256;
const int CELL_WIDTH = tile_size;
const int CELL_HEIGHT = tile_size;
//const int width = 40 * HYPERSCALE;
//const int height = 40 * HYPERSCALE;

class Tile{
	public:
		Tile(int identity){
			SetupTileIdentity(identity);
		}
		Tile(int identity, int _x, int _y){
			SetupTileIdentity(identity);
			x=_x;
			y=_y;
		}
		void SetupTileIdentity(int identity){
			tileID=identity;
			switch(identity){
				case noone:
					ltr = "#";
					break;
				case VOID:
					ltr = "V";
					break;
				case PLACEHOLDER:
					ltr = "#";
					break;
				case FLOOR:
					ltr = " ";
					break;
				case WALL:
					ltr = "■";
					break;
				case PROP:
					ltr = "P";
					break;
				case PROP_SINGLE:
					ltr = "P";
					break;
				case PROP_SINGLE_S:
					ltr = "P";
					break;
				case PROP_SMALL:
					ltr = "p";
					break;
				case SECRET_FLOOR:
					ltr = " ";
					break;
				case SECRET_WALL:
					ltr = "X";
					break;
				case SECRET_ENTRANCE:
					ltr = "?";
					break;
				case PATHER_ENDPOINT:
					ltr = "R";
					break;
				case PATHER_STARTPOINT:
					ltr = "B";
					break;
				case PATHER_ENDPOINT_SPECIAL:
					ltr = "5";
					break;
				case PATHER_STARTPOINT_SPECIAL:
					ltr = "1";
					break;
				case PATHER_MIDPOINT:
					ltr = "2";
					break;
				case PATHER_MIDPOINT2:
					ltr = "3";
					break;
				case PATHER_MIDPOINT3:
					ltr = "4";
					break;
				case MARK_DEAD_END:
					ltr = "E";
					break;
				case ORIGIN_ROOMCENTER:
					ltr = "C";
					break;
				case INDOOR_ROOM:
					ltr = "/";
					break;
				case ENVIRO_INDOOR:
					ltr = "/";
					break;
				case ENVIRO_OUTDOOR:
					ltr = "\\";
					break;
				case BURROW_ENTER:
					ltr = "↓";
					break;
				case BURROW_EXIT:
					ltr = "↓";
					break;
				case OVERHEAD_ENTER:
					ltr = "↑";
					break;
				case OVERHEAD_EXIT:
					ltr = "↑";
					break;
				case 803:
					ltr = "╟";
					break;
				case 804:
					ltr = "╧";
					break;
				case 805:
					ltr = "╢";
					break;
				case 802:
					ltr = "╤";
					break;
				case 500:
					ltr = "─";
					break;
				case 501:
					ltr = "│";
					break;
				case 502:
					ltr = "┐";
					break;
				case 503:
					ltr = "└";
					break;
				case 504:
					ltr = "┌";
					break;
				case 505:
					ltr = "┘";
					break;
				case 506:
					ltr = "┴";
					break;
				case 507:
					ltr = "┬";
					break;
				case 508:
					ltr = "├";
					break;
				case 509:
					ltr = "┤";
					break;
				case 510:
					ltr = "┼";
					break;
				default:
					ltr = "*";
					cout << "unknown tile id " << identity << " applied" << endl;
					break;
				
			}
		}
		int GetTileID() {return tileID;}
		int GetX() {return x;}
		int GetY() {return y;}
		int GetZ() {return z;}
		void SetZ(int _z) {z=_z;}
		string ltr;
		void PrintOut(ofstream& offstream, ofstream& entstream, string prefab, int& id){
			ifstream inp1(prefab.c_str());
			cout << prefab << endl;
			//assert(inp1.good());
			//ofstream offstream("offstream.txt");
			string pin;
			bool insolid = false;
			bool inentity = false;
			bool innormals = false;
			bool indistances = false;
			int coundown = 0;
			//int id = 20;
			bool marked = false;
			//int x=5;
			//int y=1;
			while (inp1>>pin){
				//if (coundown<0)count=0;
				if ((pin == "solid"||pin=="group") && !inentity){
					insolid = true;
				}
				if (pin == "entity"){
					inentity = true;
				}
				if (pin == "normals"){
					innormals = true;
					indistances = false;
				}
				if (pin == "distances"){
					innormals = true;
					indistances = false;
				}
				if (insolid && !inentity){
					if (pin == "}") coundown--;
					for (int i=0; i<=coundown; i++)
						offstream << "\t";
					if (pin == "{") coundown++;
					if (coundown==0&&pin!="solid"&&pin!="group") insolid=false;
					if (pin == "\"id\""){
						offstream << pin << " ";
						inp1 >> pin;
						pin = "\"";
						offstream << pin << id;
						id++;
						marked = true;
					}
					else if (pin == "\"groupid\""){
						offstream << pin << " ";
						inp1 >> pin;
						pin = "\"";
						offstream << pin << id;
						id++;
						marked = true;
					}
					else if (pin == "\"plane\""){
						offstream << pin << " \"";
						for (int i=0; i<3; i++){
							inp1 >> pin;
							int val;
							string pin2 = pin.substr(pin.find("(")+1);
							val = to_int(pin2.c_str());
							val += ((x-width/2)*CELL_WIDTH);
							offstream << "(" << val;
							if (TOINTDEC>0){
								offstream << "." << TOINTDEC;
							}
							offstream << " ";
							
							inp1 >> pin;
							val = to_int(pin.c_str());
							val += ((y-height/2)*CELL_HEIGHT);
							offstream << val;
							if (TOINTDEC>0){
								offstream << "." << TOINTDEC;
							}
							offstream << " ";
							
							inp1 >> pin;
							pin2 = pin.substr(0,pin.find(")"));
							val = to_int(pin2.c_str());
							//val += ((x-width/2)*CELL_WIDTH);
							offstream << val;
							if (TOINTDEC>0){
								offstream << "." << TOINTDEC;
							}
							offstream << ")";
							if (i<2) offstream << " ";
						}
						pin = "\"";
						marked = true;
					}
					else if (pin == "normals"){
						offstream << pin << " ";
						offstream << endl;
						for (int i=0; i<=coundown; i++)
							offstream << "\t";
						inp1 >> pin;
						offstream << pin << endl;
						if (pin == "}") coundown--;
						if (pin == "{") coundown++;
						for (int i=0; i<=coundown; i++)
							offstream << "\t";
						/*
						for (int i=0; i<=coundown; i++)
							offstream << "\t";
						//if (!marked){
							getline(inp1,pin);
							getline(inp1,pin);
							offstream << pin;
						//}
						offstream << endl;
						if (pin == "}") coundown--;
						if (pin == "{") coundown++;
						if (coundown==0&&pin!="solid"&&pin!="group") insolid=false;
//						offstream << pin << " ";
						//if (!marked){
							getline(inp1,pin);
							offstream << pin;
						//}
						offstream << endl;
						*/
						
						for (int i=0; i<5; i++){
							inp1 >> pin;
							offstream << pin << " \"";
							for (int j=0; j<5; j++){
								if (j > 0) offstream << " ";
								offstream << "0 0 ";
								//cout << dispinfo[i][j];
								if (dispinfo[i][j] > 0){
									offstream << "1";
								} else if (dispinfo[i][j] < 0){
									offstream << "-1" ;
								} else {
									offstream << "0";
								}
								inp1 >> pin;
								inp1 >> pin;
								inp1 >> pin;
							}
							pin = "\"";
							
							offstream << pin << " ";
							//if (!marked){
								getline(inp1,pin);
								offstream << pin;
							//}
							offstream << endl;
							if (pin == "}") coundown--;
							for (int i=0; i<=coundown; i++)
								offstream << "\t";
							if (pin == "{") coundown++;
						}
						coundown--;
						//getline(inp1,pin);
						//marked = true;
					}
					else if (pin == "distances"){
						offstream << pin << " ";
						offstream << endl;
						for (int i=0; i<=coundown; i++)
							offstream << "\t";
						inp1 >> pin;
						offstream << pin << endl;
						if (pin == "}") coundown--;
						if (pin == "{") coundown++;
						for (int i=0; i<=coundown; i++)
							offstream << "\t";
						/*
						offstream << pin << " ";
						//if (!marked){
							getline(inp1,pin);
							offstream << pin;
						//}
						//offstream << endl;
						if (pin == "}") coundown--;
						for (int i=0; i<=coundown; i++)
							offstream << "\t";
						if (pin == "{") coundown++;
						if (coundown==0&&pin!="solid"&&pin!="group") insolid=false;
						offstream << pin << " ";
						//if (!marked){
							getline(inp1,pin);
							offstream << pin;
						//}
						offstream << endl;
						if (pin == "}") coundown--;
						for (int i=0; i<=coundown; i++)
							offstream << "\t";
						if (pin == "{") coundown++;
						if (coundown==0&&pin!="solid"&&pin!="group") insolid=false;
						*/
						
						for (int i=0; i<5; i++){
							inp1 >> pin;
							offstream << pin << " \"";
							for (int j=0; j<5; j++){
								if (j > 0) offstream << " ";
								if (dispinfo[i][j] < 0){
									offstream << (-1 * dispinfo[i][j]);
								} else {
									offstream << dispinfo[i][j];
								}
								inp1 >> pin;
							}
							pin = "\"";
							
							offstream << pin << " ";
							//if (!marked){
								getline(inp1,pin);
								offstream << pin;
							//}
							offstream << endl;
							if (pin == "}") coundown--;
							for (int i=0; i<=coundown; i++)
								offstream << "\t";
							if (pin == "{") coundown++;
							if (coundown==0&&pin!="solid"&&pin!="group") insolid=false;
						}
						
						//getline(inp1,pin);
						marked = true;
								
					} else if (pin == "\"material\"" && tfind.size() > 0){
						offstream << pin;
						
						inp1 >> pin;
						for (int i = 0; i < tfind.size() && i < treplace.size(); i++){
							if (pin=="\"" + tfind[i] + "\""){
								offstream << "\"" + treplace[i];
								pin = "\"";
								marked = true;
							}
						}
					} else {
						marked = false;
					}
					offstream << pin << " ";
					if (!marked){
						getline(inp1,pin);
						offstream << pin;
					}
					offstream << endl;
				}
				if (inentity){
					if (pin == "}") coundown--;
					for (int i=0; i<=coundown; i++)
						entstream << "\t";
					if (pin == "{") coundown++;
					if (coundown==0&&pin!="entity") inentity=false;
					if (pin == "\"id\""){
						entstream << pin << " ";
						inp1 >> pin;
						pin = "\"";
						entstream << pin << id;
						id++;
						marked = true;
					} else if (pin == "\"origin\""){
						entstream << pin << " \"";
						inp1 >> pin;
						int val;
						string pin2 = pin.substr(pin.find("\"")+1);
						val = to_int(pin2.c_str());
						val += ((x-width/2)*CELL_WIDTH);
						//entstream << val << " ";
						entstream << val;
						if (TOINTDEC>0){
							entstream << "." << TOINTDEC;
						}
						entstream << " ";
						
						inp1 >> pin;
						val = to_int(pin.c_str());
						//cout << val << " @ y= " << y << "becomes ";
						val += ((y-height/2)*CELL_HEIGHT);
						//cout << val << endl;
						//entstream << val << " ";
						entstream << val;
						if (TOINTDEC>0){
							entstream << "." << TOINTDEC;
						}
						entstream << " ";
						
						inp1 >> pin;
						pin2 = pin.substr(0,pin.find("\""));
						val = to_int(pin2.c_str());
						//val += ((x-width/2)*CELL_WIDTH);
						entstream << val;
						if (TOINTDEC>0){
							entstream << "." << TOINTDEC;
						}
						pin = "\"";
						marked = true;
					} else if (pin == "\"plane\""){
						entstream << pin << " \"";
						for (int i=0; i<3; i++){
							inp1 >> pin;
							int val;
							string pin2 = pin.substr(pin.find("(")+1);
							val = to_int(pin2.c_str());
							val += ((x-width/2)*CELL_WIDTH);
							//entstream << "(" << val << " ";
							entstream << "(" << val;
							if (TOINTDEC>0){
								entstream << "." << TOINTDEC;
							}
							entstream << " ";
							
							inp1 >> pin;
							val = to_int(pin.c_str());
							val += ((y-height/2)*CELL_HEIGHT);
							//entstream << val << " ";
							entstream << val;
							if (TOINTDEC>0){
								entstream << "." << TOINTDEC;
							}
							entstream << " ";
							
							inp1 >> pin;
							pin2 = pin.substr(0,pin.find(")"));
							val = to_int(pin2.c_str());
							//val += ((x-width/2)*CELL_WIDTH);
							//entstream << val << ")";
							entstream << val;
							if (TOINTDEC>0){
								entstream << "." << TOINTDEC;
							}
							entstream << ")";
							if (i<2) entstream << " ";
						}
						pin = "\"";
						marked = true;
					} else if (pin == "\"target\""){
						entstream << pin;
						
						inp1 >> pin;
						if (pin=="\"sspl_path_cp_one1\""||pin=="\"sspl_path_B_1\""||pin=="\"sspl_path_C_1\""||pin=="\"sspl_path_D_1\""){
							entstream << "\"sspl_path_" << (gdi+1);
							pin = "\"";
						marked = true;
						}
					} else if (pin == "\"targetname\""){
						entstream << pin;
						
						inp1 >> pin;
						if (pin=="\"sspl_path_A_1\""||pin=="\"sspl_path_cp_one1\""||pin=="\"sspl_path_cp_two1\""||pin=="\"sspl_path_cp_three1\""||pin=="\"sspl_path_end\""){
							entstream << "\"sspl_path_" << gdi;
							pin = "\"";
							marked = true;
						}
						if (pin == "\"door_any_large_1\"" || pin == "\"door_any_smallA_1\"" || pin == "\"door_blue_small_1b\""){
							entstream << "\"door_any_generic_" << (x+y*width);
							pin = "\"";
							marked = true;
						}
					}  else if (pin == "\"parentname\""){
						entstream << pin;
						
						inp1 >> pin;
						if (pin == "\"door_any_large_1\"" || pin == "\"door_any_smallA_1\"" || pin == "\"door_blue_small_1b\""){
							entstream << "\"door_any_generic_" << (x+y*width);
							pin = "\"";
							marked = true;
						}
					} else if (pin == "\"OnStartTouch\"" || pin == "\"OnEndTouchAll\"" || pin == "\"OnStartTouchAll\""){
						entstream << pin;
						
						inp1 >> pin;
						string s2 = "\"door_blue_small_1b";
						size_t found = pin.find(s2);
						if (found!=string::npos){
							//std::cout << "first 'needle' found at: " << found << '\n';
							entstream << "\"door_any_generic_" << (x+y*width);
							pin = pin.substr(found + s2.length());
							marked = true;
						}
						s2 = "\"door_any_large_1";
						found = pin.find(s2);
						if (found!=string::npos){
							//std::cout << "first 'needle' found at: " << found << '\n';
							entstream << "\"door_any_generic_" << (x+y*width);
							pin = pin.substr(found + s2.length());
							marked = true;
						}
						s2 = "\"door_any_smallA_1";
						found = pin.find(s2);
						if (found!=string::npos){
							//std::cout << "first 'needle' found at: " << found << '\n';
							entstream << "\"door_any_generic_" << (x+y*width);
							pin = pin.substr(found + s2.length());
							marked = true;
						}
					} else {
						marked = false;
					}
					entstream << pin << " ";
					if (!marked){
						getline(inp1,pin);
						entstream << pin;
					}
					entstream << endl;
				}
			}
		}
		void PrintEnt(ofstream& offstream, ofstream& entstream, string prefab, int& id){
			ifstream inp1(prefab.c_str());
			cout << prefab << endl;
			//assert(inp1.good());
			//ofstream offstream("offstream.txt");
			string pin;
			bool inentity = false;
			int coundown = 0;
			//int id = 20;
			bool marked = false;
			//int x=5;
			//int y=1;
			while (inp1>>pin){
				if (pin == "entity"){
					inentity = true;
				}
				if (inentity){
					if (pin == "}") coundown--;
					for (int i=0; i<=coundown; i++)
						entstream << "\t";
					if (pin == "{") coundown++;
					if (coundown==0&&pin!="entity") inentity=false;
					if (pin == "\"id\""){
						entstream << pin << " ";
						inp1 >> pin;
						pin = "\"";
						entstream << pin << id;
						id++;
						marked = true;
					} else if (pin == "\"origin\""){
						entstream << pin << " \"";
						inp1 >> pin;
						int val;
						string pin2 = pin.substr(pin.find("\"")+1);
						val = to_int(pin2.c_str());
						val += ((x-width/2)*CELL_WIDTH);
						entstream << val;
						if (TOINTDEC>0){
							entstream << "." << TOINTDEC;
						}
						entstream << " ";
						
						inp1 >> pin;
						val = to_int(pin.c_str());
						//cout << val << " @ y= " << y << "becomes ";
						val += ((y-height/2)*CELL_HEIGHT);
						//cout << val << endl;
						entstream << val;
						if (TOINTDEC>0){
							entstream << "." << TOINTDEC;
						}
						entstream << " ";
						
						inp1 >> pin;
						pin2 = pin.substr(0,pin.find("\""));
						val = to_int(pin2.c_str());
						//val += ((x-width/2)*CELL_WIDTH);
						entstream << val;
						if (TOINTDEC>0){
							entstream << "." << TOINTDEC;
						}
						entstream << " ";
						pin = "\"";
						marked = true;
					} else if (pin == "\"plane\""){
						entstream << pin << " \"";
						for (int i=0; i<3; i++){
							inp1 >> pin;
							int val;
							string pin2 = pin.substr(pin.find("(")+1);
							val = to_int(pin2.c_str());
							val += ((x-width/2)*CELL_WIDTH);
							//entstream << "(" << val << " ";
							entstream << "(" << val;
							if (TOINTDEC>0){
								entstream << "." << TOINTDEC;
							}
							entstream << " ";
							
							inp1 >> pin;
							val = to_int(pin.c_str());
							val += ((y-height/2)*CELL_HEIGHT);
							//entstream << "(" << val << " ";
							entstream << val;
							if (TOINTDEC>0){
								entstream << "." << TOINTDEC;
							}
							entstream << " ";
							
							inp1 >> pin;
							pin2 = pin.substr(0,pin.find(")"));
							val = to_int(pin2.c_str());
							//val += ((x-width/2)*CELL_WIDTH);
							//entstream << val << ")";
							entstream << val;
							if (TOINTDEC>0){
								entstream << "." << TOINTDEC;
							}
							entstream << ")";
							if (i<2) entstream << " ";
						}
						pin = "\"";
						marked = true;
					} else if (pin == "\"target\""){
						entstream << pin;
						
						inp1 >> pin;
						if (pin=="\"sspl_path_cp_one1\""||pin=="\"sspl_path_B_1\""||pin=="\"sspl_path_C_1\""||pin=="\"sspl_path_D_1\""){
							entstream << "\"sspl_path_" << (tileID+1);
							pin = "\"";
						marked = true;
						}
					} else if (pin == "\"targetname\""){
						entstream << pin;
						
						inp1 >> pin;
						if (pin=="\"sspl_path_A_1\""||pin=="\"sspl_path_cp_one1\""||pin=="\"sspl_path_cp_two1\""||pin=="\"sspl_path_cp_three1\""||pin=="\"sspl_path_end\""){
							entstream << "\"sspl_path_" << tileID;
							pin = "\"";
							marked = true;
						}
					} else {
						marked = false;
					}
					entstream << pin << " ";
					if (!marked){
						getline(inp1,pin);
						entstream << pin;
					}
					entstream << endl;
				}
			}
		}
		int gdi;
		vector<vector<int> > dispinfo;
		vector<string> tfind = vector<string>();
		vector<string> treplace = vector<string>();
	private:
		int tileID;
		int x;
		int y;
		int z;
};
/*while (inp1>>pin){
				if (pin == "solid"){
					insolid = true;
				}
				if (pin == "entity"){
					inentity = true;
				}
				if (insolid){
					if (pin == "}") coundown--;
					if (pin == "{" || pin == "}" || pin == "solid" || pin == "side" || pin == "\"id\"" || pin == "\"plane\"" || pin == "\"material\"" || pin == "\"uaxis\"" || pin == "\"vaxis\"" || pin == "\"rotation\"" || pin == "\"lightmapscale\"" || pin == "\"smoothing_groups\"" || pin == "\"color\"" || pin == "\"visgroupshown\"" || pin == "\"visgroupautoshown\""){
						offstream << endl;
						for (int i=0; i<=coundown; i++)
							offstream << "\t";
					}
					if (pin == "{") coundown++;
					if (coundown==0&&pin!="solid") insolid=false;
					if (pin == "\"id\""){
						offstream << pin << " ";
						inp1 >> pin;
						pin = "\"";
						offstream << pin << id;
						id++;
					}
					if (pin == "\"plane\""){
						offstream << pin << " \"";
						for (int i=0; i<3; i++){
							inp1 >> pin;
							int val;
							string pin2 = pin.substr(pin.find("(")+1);
							val = to_int(pin2.c_str());
							val += ((x-width/2)*CELL_WIDTH);
							offstream << "(" << val << " ";
							
							inp1 >> pin;
							val = to_int(pin.c_str());
							val += ((y-height/2)*CELL_HEIGHT);
							offstream << val << " ";
							
							inp1 >> pin;
							pin2 = pin.substr(0,pin.find(")"));
							val = to_int(pin2.c_str());
							//val += ((x-width/2)*CELL_WIDTH);
							offstream << val << ")";
							if (i<2) offstream << " ";
						}
						pin = "\"";
					}
					offstream << pin << " ";
				}
				if (inentity){
					if (pin == "}") coundown--;
					if (pin == "{" || pin == "}" || pin == "entity" || pin == "editor" || pin == "\"id\"" || pin == "\"classname\"" || pin == "\"angles\"" || pin == "\"TeamNum\"" || pin == "\"origin\"" || pin == "\"logicalpos\"" || pin == "\"lightmapscale\"" || pin == "\"smoothing_groups\"" || pin == "\"color\"" || pin == "\"visgroupshown\"" || pin == "\"visgroupautoshown\"" || pin == "\"AutoMaterialize\"" || pin == "\"fademindist\"" || pin == "\"fadescale\"" || pin == "\"lightmapresolutionx\"" || pin == "\"lightmapresolutiony\"" || pin == "\"model\"" || pin == "\"skin\"" || pin == "\"solid\""){
						entstream << endl;
						for (int i=0; i<=coundown; i++)
							entstream << "\t";
					}
					if (pin == "{") coundown++;
					if (coundown==0&&pin!="entity") inentity=false;
					if (pin == "\"id\""){
						entstream << pin << " ";
						inp1 >> pin;
						pin = "\"";
						entstream << pin << id;
						id++;
					}
					if (pin == "\"origin\""){
						entstream << pin << " \"";
						inp1 >> pin;
						int val;
						string pin2 = pin.substr(pin.find("\"")+1);
						val = to_int(pin2.c_str());
						val += ((x-width/2)*CELL_WIDTH);
						entstream << val << " ";
						
						inp1 >> pin;
						val = to_int(pin.c_str());
						val += ((y-height/2)*CELL_HEIGHT);
						entstream << val << " ";
						
						inp1 >> pin;
						pin2 = pin.substr(0,pin.find("\""));
						val = to_int(pin2.c_str());
						//val += ((x-width/2)*CELL_WIDTH);
						entstream << val;
						pin = "\"";
					}
					entstream << pin << " ";
				}
			}*/
class LevelSettings{
	public:
		LevelSettings(const string s = "lolnope"){
			if (s=="cluttered"){
				spawnsecretmin=0;
				spawnsecretmax=1;

				odds=1;//1
				num_pathers=4;//4 NOTE: must be a square number
				pather_loop=250;//250
				pather_jump=3;//BROKEN, ignore
				use_jump=false;//BROKEN, always set to false
				pather_noturn_min=0;//0
				pather_noturn_max=20;//20

				room_start_odds=100;//100//1
				room_end_odds=100;//100//0
				room_turn_odds=100;//100//5
				room_x_max=2;//2
				room_y_max=2;//2
				allow_room_overlap=false;//false

				fix_loop=3;//3
				fix_loop_secret_extender=5;//5
				fix_loop_by_tile=3;//3

				wall_thickness=1;//1

				detect_deadend=3;//3


				single_remove_odds=3;
				single_prop_odds=0;
				spawn_prop_odds=irandom(10);
				small_prop_odds=irandom(7);
				
				burrowers = 0;
				displacementrange = irandom(10);
				
				gamemode = "arena";
			} else if (s=="building"){
				spawnsecretmin=0;
				spawnsecretmax=1;

				odds=5;//1
				num_pathers=4;//4 NOTE: must be a square number
				pather_loop=250;//250
				pather_jump=3;//BROKEN, ignore
				use_jump=false;//BROKEN, always set to false
				pather_noturn_min=irandom(3);//0
				pather_noturn_max=20;//20

				room_start_odds=2;//100//1
				room_end_odds=0;//100//0
				room_turn_odds=5;//100//5
				room_x_max=2;//2
				room_y_max=2;//2
				allow_room_overlap=false;//false

				fix_loop=3;//3
				fix_loop_secret_extender=5;//5
				fix_loop_by_tile=3;//3

				wall_thickness=1;//1

				detect_deadend=3;//3


				single_remove_odds=8;
				single_prop_odds=0;
				spawn_prop_odds=irandom(6);
				small_prop_odds=irandom(6);
				
				burrowers = 0;
				displacementrange = irandom(10);
				
				gamemode = "arena";
			}  else if (s=="sbuilding"){
				spawnsecretmin=0;
				spawnsecretmax=1;

				odds=7;//1
				num_pathers=9;//4 NOTE: must be a square number
				pather_loop=50;//250
				pather_jump=3;//BROKEN, ignore
				use_jump=false;//BROKEN, always set to false
				pather_noturn_min=irandom(2)+1;//0
				pather_noturn_max=20;//20

				room_start_odds=100;//100//1
				room_end_odds=100;//100//0
				room_turn_odds=5;//100//5
				room_x_max=2;//2
				room_y_max=2;//2
				allow_room_overlap=false;//false

				fix_loop=3;//3
				fix_loop_secret_extender=5;//5
				fix_loop_by_tile=3;//3

				wall_thickness=1;//1

				detect_deadend=2;//3


				single_remove_odds=38;
				single_prop_odds=irandom(1);
				spawn_prop_odds=irandom(2);
				small_prop_odds=irandom(2)+1;
				
				burrowers = 2;
				displacementrange = irandom(10);
				
				gamemode = "arena";
			} else if (s=="propspam"){
				spawnsecretmin=0;
				spawnsecretmax=1;

				odds=7;//1
				num_pathers=9;//4 NOTE: must be a square number
				pather_loop=50;//250
				pather_jump=3;//BROKEN, ignore
				use_jump=false;//BROKEN, always set to false
				pather_noturn_min=irandom(2)+1;//0
				pather_noturn_max=20;//20

				room_start_odds=100;//100//1
				room_end_odds=100;//100//0
				room_turn_odds=5;//100//5
				room_x_max=2;//2
				room_y_max=2;//2
				allow_room_overlap=false;//false

				fix_loop=3;//3
				fix_loop_secret_extender=5;//5
				fix_loop_by_tile=3;//3

				wall_thickness=1;//1

				detect_deadend=2;//3


				single_remove_odds=38;
				single_prop_odds=0;
				spawn_prop_odds=1;
				small_prop_odds=0;
				
				burrowers = 2;
				displacementrange = irandom(10);
				
				gamemode = "arena";
			}  else if (s=="areathings"){
				spawnsecretmin=0;
				spawnsecretmax=1;

				odds=irandom(3,1);//1
				num_pathers=4;//4 NOTE: must be a square number
				pather_loop=irandom(250,200);//250
				pather_jump=3;//BROKEN, ignore
				use_jump=false;//BROKEN, always set to false
				pather_noturn_min=irandom(2);//0
				pather_noturn_max=20;//20

				room_start_odds=0;//100//1
				room_end_odds=0;//100//0
				room_turn_odds=10;//100//5
				room_x_max=irandom(4,2);//2
				room_y_max=irandom(4,2);//2
				allow_room_overlap=true;//false

				fix_loop=3;//3
				fix_loop_secret_extender=5;//5
				fix_loop_by_tile=3;//3

				wall_thickness=1;//1

				detect_deadend=3;//3


				single_remove_odds=8;
				single_prop_odds=0;
				spawn_prop_odds=irandom(10);
				small_prop_odds=irandom(7);
				
				burrowers = 0;
				displacementrange = irandom(10);
				
				gamemode = "arena";
			} else if (s=="spooky"){
				srand (time(NULL));
				spawnsecretmin=0;
				spawnsecretmax=5;

				odds=irandom(5,3);//1
				num_pathers=irandom(3,1);//4 NOTE: must be a square number
				num_pathers=num_pathers*num_pathers;
				pather_loop=irandom(950/num_pathers,700/num_pathers);//250
				pather_jump=3;//BROKEN, ignore
				use_jump=false;//BROKEN, always set to false
				pather_noturn_min=irandom(4);//0
				pather_noturn_max=irandom(20,5);//20

				room_start_odds=irandom(20);//100//1
				room_end_odds=irandom(20);//100//0
				room_turn_odds=irandom(20,10);//100//5
				room_x_max=irandom(4,1);//2
				room_y_max=irandom(4,1);//2
				allow_room_overlap=false;//false

				fix_loop=3;//3
				fix_loop_secret_extender=5;//5
				fix_loop_by_tile=3;//3

				wall_thickness=1;//1

				detect_deadend=irandom(4,2);//3


				single_remove_odds=100;
				single_prop_odds=irandom(1);
				spawn_prop_odds=irandom(1)+1;
				small_prop_odds=irandom(1)+1;
				
				burrowers = irandom(2);
				displacementrange = irandom(10);
				
				gamemode = "arena";
			} else if (s=="spookytwo"){
				spawnsecretmin=0;
				spawnsecretmax=5;

				odds=4;
				num_pathers=9;
				pather_loop=83;
				pather_jump=3;
				use_jump=0;
				pather_noturn_min=1;
				pather_noturn_max=6;

				room_start_odds=1;
				room_end_odds=18;
				room_turn_odds=19;
				room_x_max=2;
				room_y_max=2;
				allow_room_overlap=0;

				fix_loop=3;
				fix_loop_secret_extender=5;
				fix_loop_by_tile=3;

				wall_thickness=1;

				detect_deadend=4;


				single_remove_odds=100;
				single_prop_odds=0;
				spawn_prop_odds=2;
				small_prop_odds=1;
				
				burrowers = 0;
				displacementrange = irandom(10);
				
				gamemode = "arena";
			} else if (s=="spookythree"){
				spawnsecretmin=0;
				spawnsecretmax=5;

				odds=5;
				num_pathers=4;
				pather_loop=157;
				pather_jump=3;
				use_jump=0;
				pather_noturn_min=0;
				pather_noturn_max=20;

				room_start_odds=15;
				room_end_odds=7;
				room_turn_odds=13;
				room_x_max=3;
				room_y_max=4;
				allow_room_overlap=0;

				fix_loop=3;
				fix_loop_secret_extender=5;
				fix_loop_by_tile=3;

				wall_thickness=1;

				detect_deadend=3;


				single_remove_odds=100;
				single_prop_odds=0;
				spawn_prop_odds=2;
				small_prop_odds=1;
				
				burrowers = 0;
				displacementrange = irandom(10);
				
				gamemode = "arena";
			} else if (s=="spookyfour"){
				spawnsecretmin=0;
				spawnsecretmax=5;

				odds=3;
				num_pathers=9;
				pather_loop=105;
				pather_jump=3;
				use_jump=0;
				pather_noturn_min=0;
				pather_noturn_max=18;

				room_start_odds=6;
				room_end_odds=19;
				room_turn_odds=11;
				room_x_max=1;
				room_y_max=1;
				allow_room_overlap=0;

				fix_loop=3;
				fix_loop_secret_extender=5;
				fix_loop_by_tile=3;

				wall_thickness=1;

				detect_deadend=3;


				single_remove_odds=100;
				single_prop_odds=0;
				spawn_prop_odds=1;
				small_prop_odds=1;
				
				burrowers = 1;
				displacementrange = 5;
				
				gamemode = "arena";
			} else {
				srand (time(NULL));
				spawnsecretmin=0;
				spawnsecretmax=0;

				odds=irandom(5,1);//1
				num_pathers=irandom(3,1);//4 NOTE: must be a square number
				num_pathers=num_pathers*num_pathers;
				pather_loop=irandom(1000/num_pathers,750/num_pathers);//250
				pather_jump=3;//BROKEN, ignore
				use_jump=false;//BROKEN, always set to false
				pather_noturn_min=irandom(7);//0
				pather_noturn_max=irandom(20,5);//20

				room_start_odds=irandom(20);//100//1
				room_end_odds=irandom(20);//100//0
				room_turn_odds=irandom(20);//100//5
				room_x_max=irandom(4,1);//2
				room_y_max=irandom(4,1);//2
				allow_room_overlap=(irandom(1)==1);//false

				fix_loop=3;//3
				fix_loop_secret_extender=5;//5
				fix_loop_by_tile=3;//3

				wall_thickness=1;//1

				detect_deadend=irandom(4,2);//3


				single_remove_odds=1000;
				single_prop_odds=irandom(2);
				spawn_prop_odds=irandom(2);
				small_prop_odds=irandom(2);
				
				burrowers = irandom(1);
				displacementrange = irandom(10);
				
				gamemode = "arena";
			}
			ScaleHyperly();
		}
		int odds;
		int num_pathers;
		int pather_loop;
		int pather_jump;
		bool use_jump;
		int fix_loop;
		int fix_loop_secret_extender;
		int fix_loop_by_tile;
		int single_prop_odds;
		int spawnsecretmin;
		int spawnsecretmax;
		int single_remove_odds;
		int pather_noturn_max;
		int pather_noturn_min;
		int room_end_odds;
		int room_start_odds;
		int room_turn_odds;
		int room_x_max;
		int room_y_max;
		bool allow_room_overlap;
		int wall_thickness;
		int detect_deadend;
		string gamemode;
		int spawn_prop_odds;
		int small_prop_odds;
		int burrowers;
		int displacementrange;
	//private:
		void ScaleHyperly(){
			odds *= HYPERSCALE;
			pather_loop *= HYPERSCALE;
			room_x_max *= HYPERSCALE;
			room_y_max *= HYPERSCALE;
			//wall_thickness *= HYPERSCALE;
			detect_deadend *= HYPERSCALE;
			
		}
};

int minpath(int xs, int ys, int xt, int yt, vector<vector<int> > absgrid){
	vector<vector<int> > searchgrid;
	while (searchgrid.size() <= width) searchgrid.push_back(vector<int>());
	for (int x=0; x<=width-1; x++){
		while (searchgrid[x].size() <= height) searchgrid[x].push_back(0);
	}
	searchgrid[xs][ys]=true;
	int r=0;
	while (!searchgrid[xt][yt]){
		r++;
		for (int x=1; x<width-1; x++){
			for (int y=1; y<height-1; y++){
				if (!searchgrid[x][y]&&absgrid[x][y]==FLOOR){
					if (searchgrid[x+1][y]==2||searchgrid[x-1][y]==2||searchgrid[x][y+1]==2||searchgrid[x][y-1]==2){
						searchgrid[x][y]=1;
					} else if (r%4==0){
						if (searchgrid[x+1][y+1]==2||searchgrid[x-1][y-1]==2||searchgrid[x-1][y+1]==2||searchgrid[x+1][y-1]==2){
							searchgrid[x][y]=1;
						}
					}
				}
			}
		}
		for (int x=1; x<width-1; x++){
			for (int y=1; y<height-1; y++){
				if (searchgrid[x][y]==1){
					searchgrid[x][y]=2;
				}
			}
		}
		if (r>50) return r;
	}
	return r;
}

int checkoverpath(int xs, int ys, int xt, int yt, vector<vector<int> > absgrid, vector<vector<Tile> > extragrid, vector<vector<int> > inoutgrid){
	vector<vector<int> > searchgrid;
	while (searchgrid.size() <= width) searchgrid.push_back(vector<int>());
	for (int x=0; x<=width-1; x++){
		while (searchgrid[x].size() <= height) searchgrid[x].push_back(0);
	}
	searchgrid[xs][ys]=true;
	int r=0;
	while (!searchgrid[xt][yt]){
		bool cont = false;
		r++;
		for (int x=1; x<width-1; x++){
			for (int y=1; y<height-1; y++){
				if (!searchgrid[x][y]&&(absgrid[x][y]!=FLOOR||inoutgrid[x][y]>0)&&extragrid[x][y].GetTileID()!=VOID){
					if (searchgrid[x+1][y]==2||searchgrid[x-1][y]==2||searchgrid[x][y+1]==2||searchgrid[x][y-1]==2){
						searchgrid[x][y]=1;
						cont = true;
					} else if (r%2==0){
						if (searchgrid[x+1][y+1]==2||searchgrid[x-1][y-1]==2||searchgrid[x-1][y+1]==2||searchgrid[x+1][y-1]==2){
							searchgrid[x][y]=1;
							cont = true;
						}
					}
				}
			}
		}
		for (int x=1; x<width-1; x++){
			for (int y=1; y<height-1; y++){
				if (searchgrid[x][y]==1){
					searchgrid[x][y]=2;
					cont = true;
				}
			}
		}
		if (!cont){
			return -1;
		}
	}
	return r;
}

vector<vector<int> > getsearchgrid(int xs, int ys, vector<vector<Tile> > absgrid){
	vector<vector<int> > searchgrid;
	while (searchgrid.size() <= width) searchgrid.push_back(vector<int>());
	for (int x=0; x<width; x++){
		while (searchgrid[x].size() <= height) searchgrid[x].push_back(0);
	}
	//cout << "setup" << endl;
	searchgrid[xs][ys]=true;
	int r=0;
	bool cont = true;
	//cout << "init" << endl;
	while (cont){
		//cout << r << endl;
		cont = false;
		r++;
		for (int x=1; x<width-1&&x<absgrid.size(); x++){
			for (int y=1; y<height-1&&y<absgrid[x].size(); y++){
				if (!searchgrid[x][y]&&absgrid[x][y].GetTileID()!=VOID){
					if (searchgrid[x+1][y]==2||searchgrid[x-1][y]==2||searchgrid[x][y+1]==2||searchgrid[x][y-1]==2){
						searchgrid[x][y]=1;
						cont = true;
					} else if (r%2==0){
						if (searchgrid[x+1][y+1]==2||searchgrid[x-1][y-1]==2||searchgrid[x-1][y+1]==2||searchgrid[x+1][y-1]==2){
							searchgrid[x][y]=1;
							cont = true;
						}
					}
				}
			}
		}
		for (int x=1; x<width-1; x++){
			for (int y=1; y<height-1; y++){
				if (searchgrid[x][y]==1){
					searchgrid[x][y]=2;
					cont = true;
				}
			}
		}
	}
	return searchgrid;
}

int checkLoS(int xs, int ys, int xt, int yt, vector<vector<int> > absgrid){
	vector<vector<int> > searchgrid;
	while (searchgrid.size() <= width) searchgrid.push_back(vector<int>());
	for (int x=0; x<=width-1; x++){
		while (searchgrid[x].size() <= height) searchgrid[x].push_back(0);
	}
	int xmod = 0;
	int ymod = 0;
	if (xs < xt) xmod = 1;
	if (xs > xt) xmod = -1;
	if (ys < yt) ymod = 1;
	if (ys > yt) ymod = -1;
	searchgrid[xs][ys]=true;
	int r=0;
	bool gotem = true;
	while (!searchgrid[xt][yt]){
		gotem = true;
		r++;
		for (int x=1; x<width-1; x++){
			for (int y=1; y<height-1; y++){
				if (!searchgrid[x][y]&&absgrid[x][y]==FLOOR){
					if (searchgrid[x+xmod][y]==2||searchgrid[x][y+ymod]==2){
						searchgrid[x][y]=1;
						gotem = false;
					}
				}
			}
		}
		for (int x=1; x<width-1; x++){
			for (int y=1; y<height-1; y++){
				if (searchgrid[x][y]==1){
					searchgrid[x][y]=2;
					gotem = false;
				}
			}
		}
		if (gotem) return -1;
		if (r>50) return r;
	}
	return r;
}